unit UnitAutoSplit;

interface

type TAutoSplit = class(TObject)

    function GetWildcardExpression : string;
end;

var AutoSplit : TAutoSplit;

implementation

uses UnitFrmMain, UnitColumnManager, Classes, Controls, StrUtils, SysUtils, UnitUtil, UnitFrmDummyShowPreview;


{ TAutoSplit }


type token_type = (
    _digit = 0,
    _alpha = 1,
    _space = 2,
    _punc = 3
);
function TAutoSplit.GetWildcardExpression: string;
var types : TStringList;
    i, x, maxx : integer;
    s, ext, maxext, maxmask : string;
    example : string;



    function GetMask(example : string) : string;
    var i : integer;
        ttype, lasttype : token_type;
        s : string;
    begin
        // digit, alpha,  space, punctiation
        for i := 1 to length(example) - 4 {extlength} do begin
            case example[i] of
            'a'..'z',
            'A'..'Z': ttype := _alpha;
            '0'..'9': ttype := _digit;
            ' ': ttype := _space;
            else begin
                ttype := _punc;
            end;
            end;

            if i = 1 then begin
                case ttype of
                    _digit: result := '0';
                    _alpha: result := 'A';
                    _space: result := ' ';
                    _punc: result := example[i];
                end;
            end else begin
                if (lasttype <> ttype) or (ttype=_punc) or (ttype=_space) then begin
                    case ttype of
                        _digit: result := result + '0';
                        _alpha: result := result + 'A';
                        _space: result := result + ' ';
                        _punc: result := result + example[i];
                    end;
                end;
            end;
            lasttype := ttype;
        end;


        // Ignore steams of digits separated by spaces
        // Ignore steams of letters separated by spaces
        while ContainsTerm('0 0 ', result) do
            result := StringReplace(result, '0 0 ', '0 ',[rfReplaceAll]);
        while ContainsTerm(' 0 0', result) do
            result := StringReplace(result, ' 0 0', ' 0',[rfReplaceAll]);
        while ContainsTerm('A A ', result) do
            result := StringReplace(result, 'A A ', 'A ',[rfReplaceAll]);
        while ContainsTerm(' A A', result) do
            result := StringReplace(result, ' A A', ' A',[rfReplaceAll]);

        result := StringReplace(result,'0','[0-9]', [rfReplaceAll]);
        result := StringReplace(result,'A','*', [rfReplaceAll]);

        result := trimright(result);
    end;
begin
    maxx := 0;
    types := TStringList.Create;
    for i := 0 to FrmMain.lvFileList.items.Count - 1 do begin
        if FrmDummyShowPreview.GetChecked(i) then begin
            ext := ExtractFileExt(UnitColumnManager.GetName(i));
            s := types.values[ext];
            x := SafeInt(s,0);
            inc(x);
            if x > maxx then begin
                maxext := ext;
                maxx := x;
                example := UnitColumnManager.GetName(i);
            end;
            types.values[ext] := IntToStr(x);
        end;
    end;
    result := '';

    types.Clear;
    maxx := 0;
    for i := 0 to FrmMain.lvFileList.items.Count - 1 do begin
        if FrmDummyShowPreview.GetChecked(i) then begin
            ext := ExtractFileExt(UnitColumnManager.GetName(i));
            if ext = maxext then begin
                example := GetMask(UnitColumnManager.GetName(i));
                s := types.Values[example];
                x := SafeInt(s,0);
                inc(x);
                if x > maxx then begin
                    maxmask := example;
                    maxx := x;
                end;
                types.Values[example] := IntToStr(x);
            end;
        end;
    end;

    result := maxmask + maxext;
end;

initialization
begin
    AutoSplit := TAutoSplit.Create;
end;
end.
