unit UnitDebug;

interface

uses Classes, SysUtils;

type TDebugLog = class(TObject)
public
    procedure Append(s : string);
private
    sl : TStringList;
    enabled : boolean;
    constructor Create;
    destructor Destroy; override;
end;

var DebugLog : TDebugLog;


implementation

uses UnitUtil, IOUtils;

constructor TDebugLog.Create;
begin
    sl := TStringList.Create;

    enabled := TDirectory.Exists( TPath.Combine(UnitUtil.GetINIPathOnly, 'debug') );

end;
destructor TDebugLog.Destroy;
begin
    if enabled then begin
        sl.SaveToFile(
            TPath.Combine( UnitUtil.GetINIPathOnly, 'debug\debuglog.txt' ), TEncoding.Unicode
        );
    end;

    inherited;
end;

procedure TDebugLog.Append(s: string);
begin
    if enabled then begin
        sl.Add(DateToStr(now) + ': ' + s);
    end;
end;

initialization
begin
    DebugLog := TDebugLog.Create;
end;
finalization
begin
    DebugLog.free;
end;

end.
