unit UnitFoldersCount;
{
    Purpose:
        This form keeps a counter for each folder name of each file
        durring a recursive scan

    Updates:
        Got rid of the lazy dummy form and replaced it
        with a static object.
        
//
// NOTES: The THashedStringList is a good way for very fast lookups for
// a folder name. Also, a TStringList can associate an object reference to
// each string.
//
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, inifiles {for THashedStringList};

type
  TFoldersCount = class(TObject)
  private
    folders : THashedStringList;
    { Private declarations }
  public
    { Public declarations }
    constructor Create();
    destructor Destroy(); override;

    procedure Clear;
    procedure IncFolderCount(folder : string);
    function GetCount(folder : string) : longint;
  end;


// glorified LongInt class wraper
type TCount = class(TObject)
    private
        cnt : longint;
    public
        constructor Create();
        procedure Clear;
        procedure Inc;
        function GetCount : longint;
end;


var FoldersCounter : TFoldersCount;
//var NewFoldersCounter : TFoldersCount;

implementation



//
// TCount - seems somewhat evident
//
constructor TCount.Create;
begin
    self.clear;
end;
procedure TCount.inc;
begin
    System.inc(cnt);
end;
function TCount.GetCount : longint;
begin
    result := cnt;
end;
procedure TCount.clear;
begin
    cnt := 0;
end;



constructor TFoldersCount.Create();
begin
    folders := THashedStringList.create();
end;

destructor TFoldersCount.Destroy;
begin
    //Folders.Free;
end;


procedure TFoldersCount.Clear;
var i : longint;
begin
    folders.CaseSensitive := false;

    for i := 0 to (folders.Count - 1) do begin
        folders.Objects[i].Free;
    end;

    folders.Clear;
end;



procedure TFoldersCount.IncFolderCount(folder : string);
var i : longint;
    cnt : TCount;
begin

    i := folders.IndexOf(folder);
    if (i <> -1) then begin
        // inc folder count
        TCount(folders.Objects[i]).inc;
    end else begin
        // new folder
        cnt := TCount.Create;
        cnt.inc;
        folders.AddObject(folder, cnt)
    end;
end;

function TFoldersCount.GetCount(folder : string) : longint;
begin
    result := folders.IndexOf(folder);
    if (result = -1) then begin
        result := 0;
    end else begin
        result := TCount(folders.Objects[result]).GetCount;
    end;
end;

initialization
    FoldersCounter := TFoldersCount.Create;
//    NewFoldersCounter := TFoldersCount.Create;
end.
