unit UnitFrameCheckFilesDropdown;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls,
  UnitFrameDropDown, Vcl.ComCtrls;

type TFileSelectedEvent = procedure(caption : string) of object;
type
  TFrameCheckedFileDropdown = class(TFrame)
    FrameDropDown1: TFrameDropDown;
  private
    { Private declarations }
    fOnSelected : TFileSelectedEvent;
    fListView : TListView;
    procedure DropDownSelected(caption : string; index : integer);
    procedure RefreshList;
    procedure DropDownCallback;
  public
    { Public declarations }
    procedure setOnSelected(OnSelected : TFileSelectedEvent);
    procedure setFileList(lv : TListView);
    procedure setCurrent(filename : string);

  end;

implementation

{$R *.dfm}

uses System.Generics.Collections, UnitUtil;

// public interface
procedure TFrameCheckedFileDropdown.setOnSelected(OnSelected : TFileSelectedEvent);
begin
    fOnSelected := OnSelected;
end;
procedure TFrameCheckedFileDropdown.SetFileList(lv : TListView);
begin
    fListView := lv;
    FrameDropDown1.setOnPopup(self.DropDownCallback);
    FrameDropDown1.setOnSelected(self.DropDownSelected);
end;
procedure TFrameCheckedFileDropdown.setCurrent(filename : string);
begin
    FrameDropDown1.setCurrent(filename);
end;
// user events
procedure TFrameCheckedFileDropdown.DropDownSelected(caption : string; index : integer);
begin
    if Assigned(fOnSelected) then begin
        fOnSelected(Caption);
    end;
end;

procedure TFrameCheckedFileDropdown.DropDownCallback;
begin
    self.RefreshList;
end;
procedure TFrameCheckedFileDropdown.RefreshList;
var l : TList<string>;
    i : integer;
    li : TListItem;
begin
    if not assigned(fListView) then EXIT;

    l := TList<string>.Create;

    for li in fListView.Items do begin
        if li.Checked then
            l.Add(li.Caption)
    end;

    FrameDropDown1.setItems(l);
    l.Free;
end;
end.
