unit UnitFrameFilter;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ComCtrls,
  Vcl.Buttons, Vcl.ExtCtrls;

type
  TFrameFilter = class(TFrame)
    Timer1: TTimer;
    pnlShow: TPanel;
    pnlEdit: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    SpeedButton1: TSpeedButton;
    procedure Label1Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Edit1Exit(Sender: TObject);
    procedure Label1MouseEnter(Sender: TObject);
    procedure Label1MouseLeave(Sender: TObject);
  private
    { Private declarations }
    var fAutoClear : Boolean;

    function GetFilter:string;
    procedure setfilter(value : string);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent) ; override;
    property filter : string read getfilter write setfilter;
    property AutoClear : Boolean read fAutoClear write fAutoClear;
  end;

implementation

{$R *.dfm}

uses UnitUtil, UnitFrmMain;

function TFrameFilter.GetFilter:string;
begin
    result := edit1.text;
end;
procedure TFrameFilter.setfilter(value : string);
begin
    edit1.text := value;
end;



constructor TFrameFilter.Create(AOwner: TComponent);
begin
    inherited;
    pnlShow.Visible := true;
    pnlEdit.Visible := false;
end;

procedure TFrameFilter.Edit1Change(Sender: TObject);
var s : string;
begin
    s := Edit1.Text;
    if s = '*.*' then begin
        Label1.Font.Style := Label1.Font.Style - [fsBold];
        s := 'none';
    end else begin
        Label1.Font.Style := Label1.Font.Style + [fsBold];
    end;
    Label1.Caption := 'Filter:  ' + s;
end;

procedure TFrameFilter.Edit1Exit(Sender: TObject);
begin
    Timer1.Enabled := true;
end;

procedure TFrameFilter.Label1Click(Sender: TObject);
begin
    pnlShow.Visible := false;
    pnlEdit.Visible := true;
    if fAutoClear then begin
        Edit1.Text := '*.*';
    end;
    Timer1.Enabled := false;
    Edit1.SetFocus;
end;

procedure TFrameFilter.Label1MouseEnter(Sender: TObject);
begin
    label1.Font.Color := clBlue;
end;

procedure TFrameFilter.Label1MouseLeave(Sender: TObject);
begin
    label1.Font.Color := clBtnText;
end;

procedure TFrameFilter.SpeedButton1Click(Sender: TObject);
begin
    edit1.SelectAll;
    UnitUtil.ShowPopupRight(SpeedButton1, FrmMain.poFilter);
end;

procedure TFrameFilter.Timer1Timer(Sender: TObject);
begin
    Timer1.Enabled := false;
    pnlShow.Visible := true;
    pnlEdit.Visible := false;

end;

end.
