unit UnitFrameStep;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, 
  Dialogs, ExtCtrls;

type
  TFrameStep = class(TFrame)
    FlowPanel1: TFlowPanel;
    pnlTopline: TPanel;
    pnlContent: TPanel;
    pnlBottomLine: TPanel;
    pnlDescription: TFlowPanel;
    pnlExpand: TPanel;
    pnlButtons: TPanel;
  private
    { Private declarations }

  public
    { Public declarations }
    constructor Create(AOwner: TComponent) ; override;
  end;

implementation

uses UnitUtil,  StdCtrls, ComCtrls, TypInfo ;

{$R *.dfm}

type TMyToplinePanel = Class(TPanel)
    private
    protected
        procedure Paint(); override;
        procedure Resize(); override;

    public
        RoundBottom : boolean;
         procedure Invalidate; override;
end;

type TTransPanel = Class(TPanel)
    public
        procedure Invalidate; override;

    protected
        procedure CreateParams(var Params: TCreateParams); override;
        procedure Paint; override;
        procedure Resize; override;
end;


{ TFrameStep }



constructor TFrameStep.Create(AOwner: TComponent);
    procedure ClonePanel(fromp, top : TPanel);
    begin
        top.align := fromp.align;
        top.BevelEdges := fromp.beveledges;
    end;

begin
    inherited;



    pnlTopline.Free;
    pnlContent.free;
    pnlBottomLine.free;
    
    pnlTopline := TMyToplinePanel.Create(self);
    pnlTopline.Parent := FlowPanel1;
    pnlTopline.Constraints.MinWidth := 300;
    pnlTopline.Align := altop;
    pnlTopline.Align := albottom;
    pnlTopline.BevelEdges := [];


    //pnlTopline.Parent := self.FlowPanel1;
    pnlExpand := TTransPanel.create(aowner);
    pnlButtons := TTransPanel.create(aowner);


end;


procedure TMyToplinePanel.Invalidate;
begin
    //if not SmoothAni then
        inherited;

end;

procedure TMyToplinePanel.Paint;
var
    rHead : TRect;
///    ssc : TScriptStepControl;
begin
    self.ParentColor := false;
    if self.RoundBottom  then begin
        self.color := DimColor(clBtnFace, 0.95);
    end else begin
        self.color := SetBlueColor(clBtnFace, 1.14);
    end;


    self.Canvas.Brush.Color := clBtnFace;
    self.Canvas.FillRect(
        rect(
        self.ClientRect.Left,
        self.ClientRect.top,
        self.ClientRect.Right,
        self.ClientRect.Bottom
        )
    );

    // outter gray rounded corners
    if self.RoundBottom  then begin
        self.Canvas.Pen.Color := clGray;
    end else begin
         self.Canvas.Pen.Color := DimColor(clGray, 0.80);
    end;
    self.Canvas.Brush.Color := DimColor(self.color,   0.97);
    self.Canvas.RoundRect(
        self.ClientRect.Left,
        self.ClientRect.Top,
        self.ClientRect.Right,
        self.ClientRect.Bottom,
        11,7
    );
    // side lines

    if self.RoundBottom  then begin
        self.Canvas.Rectangle(
            self.ClientRect.Left,
            self.ClientRect.top + trunc(self.clientrect.Bottom * 0.5),
            self.ClientRect.Right,
            self.ClientRect.Bottom-7
        );
    end else begin
        self.Canvas.Rectangle(
            self.ClientRect.Left,
            self.ClientRect.top + trunc(self.clientrect.Bottom * 0.5),
            self.ClientRect.Right,
            self.ClientRect.Bottom
        );
    end;

    if RoundBottom then begin
        // rounded part of bottom with outline
        self.Canvas.Pen.Color := DimColor(clGray, 0.97);
        self.Canvas.Brush.Color := DimColor(self.color,   0.93);


        self.Canvas.RoundRect(
            self.ClientRect.Left,
            self.ClientRect.bottom - 14,
            self.ClientRect.Right,
            self.ClientRect.Bottom,
            11,7
        );

        // bottom darker color
        rhead.Left := self.ClientRect.left+1;
        rhead.right := self.ClientRect.Right-1;
        rhead.Top := self.ClientRect.top + trunc(self.clientrect.Bottom * 0.5);
        rhead.Bottom := self.ClientRect.Bottom - 7;

        self.canvas.Brush.color := DimColor(self.Color,   0.93);
        self.Canvas.FillRect(rhead);

        //
        // right button shadowbox
        //ssc := TScriptStepControl(FrmScriptActions.ScriptControlList.items[self.tag]);

        self.Canvas.Pen.Color := DimColor(self.color, 0.93);
        self.canvas.Brush.color := DimColor(self.Color,   0.93);

    end else begin
        // bottom darker color
        rhead.Left := self.ClientRect.left+1;
        rhead.right := self.ClientRect.Right-1;
        rhead.Top := self.ClientRect.top + trunc(self.clientrect.Bottom * 0.5);
        rhead.Bottom := self.ClientRect.Bottom;

        //self.canvas.Brush.color := DimColor(self.Color,   0.93);
        self.Canvas.FillRect(rhead);

    end;
end;

procedure TMyToplinePanel.Resize;
begin
    canvas.Brush.Style := bsClear;
    //inherited;

end;



procedure TTransPanel.CreateParams(var Params: TCreateParams);
begin
    inherited CreateParams(Params);
    params.ExStyle := Params.ExStyle + WS_EX_Transparent;
    ControlStyle := ControlStyle - [csOpaque] + [csAcceptsControls];
    canvas.Brush.Style := bsClear;

    self.DoubleBuffered := true;
end;

procedure TTransPanel.Invalidate;
begin
    //if not SmoothAni then
        canvas.Brush.Style := bsClear;
    inherited;

end;

procedure TTransPanel.Paint;
begin
    //if not SmoothAni then
        canvas.Brush.Style := bsClear;
end;


procedure TTransPanel.Resize;
begin
    canvas.Brush.Style := bsClear;
    //inherited;

end;


end.
