unit UnitFrmCollisionDialog;
{
    Purpose:
        Show renames that will cause a filename collision

    Notes:
        The Preview button on FrmMain uses this
        The Rename button uses the temp DisableShowIfCollision to keep
        this dialog from showing
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, INIFiles, ComCtrls, StdCtrls {for THashedStringList};


type TMyHashedStringList = class(THashedStringList)

    public
        //function Add(const s : string) : integer; override;
end;

type
  TFrmCollisionDialog = class(TForm)
    lvNames: TListView;
    Button1: TButton;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    //NewNameList : TMyHashedStringList;
    //OriginalIndexList : TMyHashedStringList;

    NewNamesHash : TStringHash;

    //NewNameIndex : array of integer;
    DisableShow : boolean;
  public
    { Public declarations }
    procedure Clear(size : integer);
    function Add(OldName,NewName : string; index : integer) : integer;
    function Exists(name : string) : boolean; overload;
    function Exists(name : string; var index : integer) : boolean; overload;


    procedure EndUpdate;
    procedure ShowIfCollision;
    procedure DisableShowIfCollision;
  end;

var
  FrmCollisionDialog: TFrmCollisionDialog;

implementation
uses StrUtils, UnitFrmMain, UnitUtil, UnitFormScaling;
{$R *.dfm}

procedure TFrmCollisionDialog.FormCreate(Sender: TObject);
begin
    NewNamesHash := TStringHash.Create();
    TFormScaling.RegisterSelf(self);
end;



procedure TFrmCollisionDialog.Clear;
begin
    NewNamesHash.Clear;
    NewNamesHash.free;
    NewNamesHash := TStringHash.Create(size);
end;
function TFrmCollisionDialog.Add(OldName,NewName : string; index : integer) : integer;
var li : TListItem;
    i, j, k : integer;
    s : string;
begin
    // A name ending in a dot is the same as a name without
    // a dot as far as the OS is conserned
    if NewName[Length(NewName)] = '.' then begin
        Newname := leftstr(NewName, length(NewName) - 1);
    end;


    result := NewNamesHash.ValueOf(lowercase(newname));
    if (result = -1) then
        NewNamesHash.Add(lowercase(newname), index);
end;


procedure TFrmCollisionDialog.ShowIfCollision;
begin
    if (lvNames.Items.Count <> 0) and (not DisableShow) and (not self.Visible)then begin
        self.ShowModal;
    end;
    DisableShow := false;
end;
procedure TFrmCollisionDialog.Button1Click(Sender: TObject);
begin
    self.ModalResult := mrOK;
end;
procedure TFrmCollisionDialog.DisableShowIfCollision;
begin
    DisableShow := true;
end;
procedure TFrmCollisionDialog.EndUpdate;
begin

end;

function TFrmCollisionDialog.Exists(name: string; var index: integer): boolean;
var i : integer;
begin
    if Name[Length(Name)] = '.' then begin
        name := leftstr(Name, length(Name) - 1);
    end;


    i := NewNamesHash.ValueOf(lowercase(name));
    if i <> -1 then
        index := i;
    result := (i <> -1);
end;

function TFrmCollisionDialog.Exists(name: string): boolean;
var i : integer;
begin
    if Name[Length(Name)] = '.' then begin
        name := leftstr(Name, length(Name) - 1);
    end;
    result := NewNamesHash.ValueOf(lowercase(name)) <> -1;
end;

end.
