unit UnitFrmConfig;
{
    Purpose:
        user interface to select configuration options

    Updates:
        ParentFont = true screws up the form in Large Fonts  (plus auto-scroll)
        ----------
        Removed need to create a form during the creation of
        this form.
        
        -------------
        New save Column Sizes option
        New File list font option 

        --------
        new "Open Maximized" option
}

interface

uses
    UnitFolderWriteTest,

  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Buttons, System.Generics.Collections;


type
TColumnResizeType = (
    AUTO_COLUMN = 0,
    FULL_COLUMN = 1,
    USER_COLUMN = 3
);


type
  TfrmConfig = class(TForm)
    {$region 'default'}
    Panel1: TPanel;
    btnSave: TButton;
    btnCancel: TButton;
    bAbout: TButton;
    FontDialog1: TFontDialog;
    Label2: TLabel;
    Label11: TLabel;
    StatusBar1: TStatusBar;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    tsColors: TTabSheet;
    ColorDialog1: TColorDialog;
    Label24: TLabel;
    Label25: TLabel;
    Panel6: TPanel;
    lblPathFore: TLabel;
    lblPathBack: TLabel;
    pnlPath: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Panel8: TPanel;
    pnlOptions: TPanel;
    lblOptionsFore: TLabel;
    SpeedButton5: TSpeedButton;
    lblOptionsBack: TLabel;
    SpeedButton6: TSpeedButton;
    Panel2: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label10: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    txtGreater: TEdit;
    txtQuote: TEdit;
    txtLess: TEdit;
    txtSlash: TEdit;
    txtBackslash: TEdit;
    Label8: TLabel;
    Label6: TLabel;
    Label9: TLabel;
    Label7: TLabel;
    Label23: TLabel;
    txtPeriod: TEdit;
    txtAsterisk: TEdit;
    txtPipe: TEdit;
    txtColon: TEdit;
    txtQuestion: TEdit;
    Panel3: TPanel;
    Label19: TLabel;
    cbOnContextMenu: TCheckBox;
    btnCreateShortcut: TButton;
    Label15: TLabel;
    Panel4: TPanel;
    Label21: TLabel;
    cbRememberPosition: TCheckBox;
    cbRememberSize: TCheckBox;
    cbRememberLastFolder: TCheckBox;
    cbRememberBrowserPane: TCheckBox;
    cbRememberColumnSizes: TCheckBox;
    Panel5: TPanel;
    Label22: TLabel;
    cbOpenMaximized: TCheckBox;
    Panel10: TPanel;
    Label20: TLabel;
    cbAutoPreview: TCheckBox;
    cbNoHiddenFiles: TCheckBox;
    cbDontSelectFolders: TCheckBox;
    cbFilterFolders: TCheckBox;
    cbNoIcache: TCheckBox;
    Panel11: TPanel;
    cbFullDateTime: TCheckBox;
    cbNoFileIcons: TCheckBox;
    txtFontName: TEdit;
    btnSet: TButton;
    Label14: TLabel;
    TabSheet2: TTabSheet;
    Panel12: TPanel;
    Label1: TLabel;
    cbShowUpDown: TCheckBox;
    cbAlwaysShowStepButtons: TCheckBox;
    Label16: TLabel;
    cbAlwaysShowStepDescriptions: TCheckBox;
    cbIgnoreEmpty: TCheckBox;
    cbDetectEnvVars: TCheckBox;
    Label17: TLabel;
    pnl1: TPanel;
    Label18: TLabel;
    pnlFileList: TPanel;
    lblFileListFore: TLabel;
    lblFileListBack: TLabel;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    pnlCollision: TPanel;
    lblCollisionsFore: TLabel;
    pnlRenamed: TPanel;
    lblToBeRenamed: TLabel;
    SpeedButton8: TSpeedButton;
    SpeedButton7: TSpeedButton;
    pnl2: TPanel;
    SpeedButton9: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton12: TSpeedButton;
    Label26: TLabel;
    lblRemoveStep: TLabel;
    lblReplaceStep: TLabel;
    lblAddStep: TLabel;
    pnlRemoveStep: TPanel;
    pnlReplaceStep: TPanel;
    pnlAddStep: TPanel;
    pnlStepContainer: TPanel;
    lblStepContainer: TLabel;
    SpeedButton11: TSpeedButton;
    cbUseEffects: TCheckBox;
    cbAutoCollapse: TCheckBox;
    pnl3: TPanel;
    Label27: TLabel;
    txtScriptFontName: TEdit;
    btnScriptFont: TButton;
    FontDialog2: TFontDialog;
    cbNoClearFilter: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure cbOnContextMenuClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure rbPreserveCaseClick(Sender: TObject);
    procedure rbAlterCaseClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure bAboutClick(Sender: TObject);
    procedure btnSetClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure txtBackslashChange(Sender: TObject);
    procedure txtSlashChange(Sender: TObject);
    procedure txtPipeChange(Sender: TObject);
    procedure txtColonChange(Sender: TObject);
    procedure txtQuestionChange(Sender: TObject);
    procedure txtAsteriskChange(Sender: TObject);
    procedure txtGreaterChange(Sender: TObject);
    procedure txtLessChange(Sender: TObject);
    procedure txtQuoteChange(Sender: TObject);
    procedure txtPeriodChange(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnCreateShortcutClick(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure btnPathForegroundClick(Sender: TObject);
    procedure lblPathForeClick(Sender: TObject);
    procedure lblPathBackClick(Sender: TObject);
    procedure lblFileListForeClick(Sender: TObject);
    procedure lblFileListBckClick(Sender: TObject);
    procedure lblOptionsForeClick(Sender: TObject);
    procedure lblOptionsBackClick(Sender: TObject);
    procedure lblCollisionsForeClick(Sender: TObject);
    procedure lblToBeRenamedClick(Sender: TObject);
    procedure lblRemoveStepClick(Sender: TObject);
    procedure lblReplaceStepClick(Sender: TObject);
    procedure lblAddStepClick(Sender: TObject);
    procedure lblStepContainerClick(Sender: TObject);
    procedure btnScriptFontClick(Sender: TObject);
    {$endregion}
  private
    ActivateOnce : boolean;
    LastFolder: string;
    LastPosition: TPoint;
    LastSize: TPoint;
    LastSplitterSize: TPoint;
    LastFont : TFont;
    LastBrowsePaneWidth : integer;
    LastBrowsePaneVisible : boolean;
    LastColumnButtonPressed : TColumnResizeType;
    ScriptView : boolean;
    FirstRun : boolean;

    ScriptFont : TFont;
    ScalePercent : integer;

    fOldFileMenuVisible : boolean;

    { Private declarations }
    function StringToBool(s: string) : boolean;
    function BoolToString(b: boolean) : string;
    procedure SaveSettings;
    procedure LoadSettings;
    procedure DupeFont(target, dest : TFont);
    procedure ColorDialog( l : TLabel );


//    function PreserveCase() : Boolean;
//    function UseUpperCase() : Boolean;
//    function UseLowerCase() : boolean;
//    function UseCapitalWords() : boolean;
    //function UseOldSelectFolderForm() : boolean;
//    function UseBrowseForm() : boolean;
//    function UseOpenDialog() : boolean;


    { Public declarations }
  public
    function GetScriptView : boolean;

    function UseLastFolder() : Boolean;

    function RememberPosition() : boolean;
    function RememberSize() : boolean;
    //function RememberColumnSizes() : boolean;
    {called by FrmMain durring a destroy}
    function GetLastFolder() : string;
    procedure SetLastFolder(folder: string);
    function GetLastPosition() : TPoint;
    procedure SetLastPosition(p : Tpoint);
    function GetLastSize() : TPoint;
    procedure SetLastSize(s : TPoint);
    function GetLastSplitterSize() : TPoint;
    procedure SetlastSplitterSize(s : TPoint);
    procedure SetLastColumnsSizes(col : TListColumns);
    procedure GetLastColumnsSizes(col : TListColumns);
    procedure SetLastBrowsePaneWidth(w : integer);
    function GetLastBrowsePaneWidth : integer;
    procedure SetLastBrowsePaneVisible(value : boolean);
    function GetLastBorwsePaneVisible : boolean;
    procedure SetColumnButtonPressed(T : TColumnResizeType);
    function GetColumnButtonPressed : TColumnResizeType;
    procedure GetFont(f : Tfont);
    procedure GetScriptFont(f : TFont);
    function GetRememberBrowsePaneState : boolean;
    function GetDisableCollisionDetection : boolean;

    function RenameFiles : boolean;
    function RenameFolders : boolean;
    function UseFileIcons : boolean;
    function UseFullDateTime() : boolean;
    function UseFolderFilters : boolean;

    function SelectFolders : boolean;

    procedure SaveFileFolderView;
    function IsFirstRun : boolean;

    function GetOldFileMenuVisible : boolean;
    function GetFormScaling : integer;
    procedure PerformScaling;

    class function getIsMaximed : boolean;
  end;

  TMyFrmConfing = class(TFrmConfig)
  end;

var
  frmConfig: TfrmConfig;

implementation

{$R *.dfm}

uses INIFiles, UnitFrmMain, Registry, UnitFrmAbout, UnitUtil,
  UnitMetaVariables, ShellAPI,
  {these 3 for creating a shortcut in the SendTo menu}
  ComObj, ShlObj, ActiveX, UnitColumnManager, UnitFrmThumbPreview,
  UnitFrmMetaVariables, UnitFrmScriptActions, UnitRMScript, UnitFileIcon, UnitFrmMetaVariables2, UnitFormScaling;



//
// Public Interface
//

class function TfrmConfig.getIsMaximed : boolean;
var
    ini : TmyIniFile;
begin
    ini := TmyInifile.Create(UnitUtil.getinipath);
    result := ini.ReadBool('Startup', 'OpenMaximized', false );
    freeandnil(ini);
end;


function TfrmConfig.IsFirstRun;
begin
    result := FirstRun;
end;
function TfrmConfig.GetLastSplitterSize: TPoint;
begin
    result := LastSplitterSize;
end;

procedure TfrmConfig.SetlastSplitterSize(s: TPoint);
begin
    LastSplitterSize := s;
end;


function TFrmConfig.GetRememberBrowsePaneState : boolean;
begin
    result := cbRememberBrowserPane.Checked;
end;

function TfrmConfig.GetScriptView: boolean;
begin
    //result := ScriptView;
    result := true;
end;

procedure TFrmConfig.GetFont(f : Tfont);
begin
    self.dupefont(lastfont, f);
end;
procedure TfrmConfig.GetScriptFont(f : TFont);
begin
    self.DupeFont(ScriptFont, f);
end;
procedure TFrmConfig.SetColumnButtonPressed(T : TColumnResizeType);
begin
    LastColumnButtonPressed := T;
end;
function TFrmConfig.GetColumnButtonPressed : TColumnResizeType;
begin
    result := LastColumnButtonPressed;
end;


procedure TFrmConfig.SetLastBrowsePaneVisible(value : boolean);
begin
    LastBrowsePaneVisible := value;
end;
function TFrmConfig.GetLastBorwsePaneVisible : boolean;
begin
    result := LastBrowsePaneVisible;
end;
procedure TFrmConfig.SetLastBrowsePaneWidth(w : integer);
begin
    LastBrowsePaneWidth := w;
end;
function TFrmConfig.GetLastBrowsePaneWidth : integer;
begin
    result := LastBrowsePaneWidth;
end;

{
function TFrmConfig.RememberColumnSizes() : boolean;
begin
    result := cbRememberColumnSizes.Checked;
end;
}

function Colname(name : string) : string;
begin
    result := StringReplace(name,' ', '_', [rfreplaceall]);
    result := stringreplace(result,'[+]_','',[]);
    result := stringreplace(result,'[-]_','',[]);
    //result := stringreplace(result,'_Created','',[]);
    //result := stringreplace(result,'_Modified','',[]);
end;

procedure TFrmConfig.SetLastColumnsSizes(col : TListColumns);
var i : integer;
    ini : TIniFile;
    s : string;
begin
    ini := TInifile.Create(UnitUtil.getinipath);
    for i := 0 to col.Count - 1 do begin
        s := colname(col.items[i].caption);

        ini.WriteInteger('Column_' + s, 'Width', col.Items[i].Width);
        ini.WriteInteger('Column_' + s, 'Index', i);
    end;
    ini.UpdateFile;
    ini.free;
end;
procedure TFrmConfig.GetLastColumnsSizes(col : TListColumns);
var i,j : integer;
    ini : TIniFile;
    newpos : array[0 .. 10] of integer;
    c : array[0 .. 10] of TListColumn;
begin
    ini := TInifile.Create(UnitUtil.getinipath);


    for i := 0 to Col.Count - 1 do begin
        j := ini.ReadInteger('Column_' + colname(Col.Items[i].caption), 'Width', -1);
        if (j <> -1) then begin
            col.items[i].Width := j;
        end;


        j := ini.ReadInteger('Column_' + colname(Col.Items[i].caption), 'Index', -1);
        newpos[i] := j;
        c[i] := col.items[i];
    end;

    //
    // Once I start moving, I can't trust the items in the TListColumns collection
    //
    for i := 0 to col.count - 1 do begin
        if newpos[i] <> -1 then begin
            if newpos[i] >= col.count then begin
                c[col.count-1].index := col.count-1;
            end else begin
                c[  i].Index := newpos[i];
            end;
        end;
    end;
    // no writes, no update needed
    ini.free;
end;


//function TFrmConfig.UseOldSelectFolderForm() : boolean;
//begin
//end;
//function TFrmConfig.UseBrowseForm() : boolean;
//begin
//    //result := self.rbBrowse.checked;
//end;
//function TFrmConfig.UseOpenDialog() : boolean;
//begin
//    //result := self.rbStandardOpen.Checked;
//end;



function TFrmConfig.UseLastFolder() : Boolean;
begin
    result := cbRememberLastFolder.checked;
end;
function TFrmConfig.GetLastFolder() : string;
begin
    result := self.LastFolder;
end;
procedure TFrmConfig.SetLastFolder(folder: string);
begin
    LastFolder := folder;
end;
//function TFrmConfig.PreserveCase() : Boolean;
//begin
//    //result := rbPreserveCase.checked;
//end;
//function TFrmConfig.UseUpperCase() : Boolean;
//begin
//    //result := rbUppercase.Checked;
//end;
//function TFrmConfig.UseLowerCase() : boolean;
//begin
//    //result := rbLowercase.Checked;
//end;
//function TFrmConfig.UseCapitalWords() : boolean;
//begin
//    //result := rbCapitalizeWords.Checked;
//end;


function TFrmConfig.RememberPosition() : boolean;
begin
    result := cbRememberPosition.Checked;
end;
function TFrmConfig.RememberSize() : boolean;
begin
    result := cbRememberSize.Checked;
end;
function TFrmConfig.GetLastPosition() : TPoint;
begin
    result := LastPosition;
end;
function TFrmConfig.GetLastSize() : TPoint;
begin
    result := LastSize;
end;


procedure TFrmConfig.SetLastPosition(p : Tpoint);
begin
    LastPosition := p;
end;

procedure TFrmConfig.SetLastSize(s : TPoint);
begin
    LastSize := s;
end;


function TFrmConfig.UseFullDateTime() : boolean;
begin
    result := cbFullDateTime.Checked;
end;

function TFrmConfig.RenameFiles : boolean;
begin
    //result := rbFiles.Checked or rbFilesFolders.checked;
    result := frmmain.FilesOnly2.checked or frmmain.FilesandFolders2.checked;
end;
function TFrmConfig.RenameFolders : boolean;
begin
    //result := rbFolders.Checked or rbFilesFolders.checked;
    result := frmmain.FoldersOnly2.checked or frmmain.FilesandFolders2.checked;
end;

function TFrmConfig.UseFileIcons : boolean;
begin
    result := cbNoFileIcons.Checked;
end;

function TFrmConfig.SelectFolders : boolean;
begin
    result := (not cbDontSelectFolders.Checked) or  frmmain.FoldersOnly2.checked;
end;

function TFrmConfig.UseFolderFilters : boolean;
begin
    result := cbFilterFolders.Checked;
end;


function TFrmConfig.GetOldFileMenuVisible : boolean;
begin
    result := fOldFileMenuVisible;
end;

function TFrmConfig.GetFormScaling : integer;
begin
    result := self.ScalePercent;
end;

procedure TFrmConfig.PerformScaling;
var l : TList<TForm>;
    f : TForm;
begin
    if self.ScalePercent = 100 then EXIT;

    l := TList<TForm>.create;
    TFormScaling.GetRegistrationList(l);
    for f in l do begin
        f.ScaleBy(self.ScalePercent, 100);
    end;
    freeandnil(l);
end;


{
//------------------------------------------------------------------------
// Private Implementation
//------------------------------------------------------------------------
}

//--------------------
// Create/Destroy/Show
//--------------------
procedure TfrmConfig.FormCreate(Sender: TObject);
begin
    ActivateOnce := true;
    self.LastFont := TFont.Create;
    self.ScriptFont := TFont.Create;

    lblFileListFore.Color := ColorToRGB(clWindowText);
    lblFileListBack.Color := ColorToRGB(clWindow);

    lblOptionsFore.Color := ColorToRGB(clWindowText);
    lblOptionsBack.Color := ColorToRGB(clWindow);

    //lblPathBack.color := $00E73D88;
    //lblPathFore.color := ColorToRGB(clWindow);
    lblPathBack.color := ColorToRGB(clWindow);
    lblPathFore.color := ColorToRGB(clWindowText);



    lblCollisionsFore.Color := $FF;
    lblToBeRenamed.Color := clWindowText;

    lblAddStep.Color := 7635314;
    lblRemoveStep.Color := 7499654;
    lblReplaceStep.color := 12167059;

    lblStepContainer.Color := $00C4C4C6;
//    lblRemoveStep_unicode=7696778
//lblReplaceStep_unicode=12167059
//lblAddStep_unicode=7635314


    self.LoadSettings;
    //
    // DIRTY TRICK
    // I need this form created before the mainform, so this
    // is the mechanism I used
    // (TFrmMain.Create relies on this forms public methods)
    //
    {if not NotFirstUse then begin
        Application.CreateForm(TfrmMain, frmMain);
        NotFirstUse := true;
    end;}
    // the "LoadSettings" can't set the font because
    // FrmMain doesn't exist until here.
    
    //self.dupefont(LastFont, GetFileList.Font);

    TFormScaling.RegisterSelf(self);
    PageControl1.ActivePageIndex := 0;
end;
procedure TfrmConfig.FormDestroy(Sender: TObject);
begin
    self.SaveSettings;
    self.LastFont.free;
end;

procedure TfrmConfig.FormShow(Sender: TObject);
begin
    self.LoadSettings;
end;


procedure TFrmConfig.LoadSettings;
var ini: TmyIniFile;
    i, j, k : integer;
    ctrl : TControl;
begin
    firstrun := not FileExists(UnitUtil.getinipath);
    ini := TmyInifile.Create(UnitUtil.getinipath);

    FrmMain.thumbnaillist1.Checked :=  ini.ReadBool('Startup', frmmain.thumbnaillist1.Name, false );
    frmmain.ToggleToolbar1.Checked := ini.ReadBool('Startup', frmmain.ToggleToolbar1.name, false);

    //frmmain.OldInterface1.Checked := not ini.ReadBool('Startup', frmmain.OldInterface1.Name, false );
    //frmmain.OldInterface1.click;
    //frmmain.SaveFilterinscript1.checked :=  ini.ReadBool('Startup', frmmain.SaveFilterinscript1.Name, true);
    //FrmMain.ChangeFolderonOpen1.checked :=  ini.ReadBool('Startup' ,'ChangeToFolderInScript', true);
    cbOnContextMenu.Checked := StringToBool(ini.ReadString('Registry','OnContextMenu','No'));
    cbRememberLastFolder.Checked := not StringToBool(ini.ReadString('Startup','DontUseLastFolder','No'));
    cbRememberPosition.Checked := stringtobool(ini.ReadString('Startup','RememberPosition','Yes'));
    cbRememberSize.Checked := stringtobool(ini.ReadString('Startup','RememberSize','Yes'));
    LastPosition.X := StrToInt(ini.ReadString('Startup','WindowX', '0'));
    LastPosition.Y := StrToInt(ini.ReadString('Startup','WindowY', '0'));
    LastSize.X := StrToInt(ini.ReadString('Startup','WindowWD','890'));
    LastSize.Y := StrToInt(ini.ReadString('Startup','WindowHT','650'));
    LastSplitterSize.X := Ini.ReadInteger('Startup','WindowSplitterXa',0);
    LastSplitterSize.Y := ini.ReadInteger('Startup','LastSplitterYa',0);
    frmmain.MIFilelistonLeftSize1.Checked := ini.ReadBool('Startup',frmmain.MIFilelistonLeftSize1.name, false);
    frmmain.MIToggleWideLayout1.checked := ini.ReadBool('Startup', frmmain.MIToggleWideLayout1.Name, true);

    cbOpenMaximized.checked := ini.ReadBool('Startup', 'OpenMaximized', false );
    self.LastFolder := ini.ReadString('Startup','lastfolder', '');
    cbRememberColumnSizes.Checked :=  ini.ReadBool('Startup','RememberColumnSizes', false);
    LastBrowsePaneWidth := ini.ReadInteger('Startup','BroswePaneWidth', -1);
    LastBrowsePaneVisible := ini.ReadBool('Startup','BroswePaneVisible', false);
    //LastColumnButtonPressed := ini.ReadBool('Startup','ColumnButtonPressed',false);
    LastColumnButtonPressed := TColumnResizeType( ini.ReadInteger('Startup','ColumnResizeType', 0) );
    cbRememberBrowserPane.checked := ini.ReadBool('Startup','RememberBrowserPane',true);

    //rbPreserveCase.checked := StringToBool(ini.ReadString('Case','Preserve','Yes'));
    //rbAlterCase.Checked := StringToBool(ini.ReadString('Case','Alter','No'));
    //rbUppercase.Checked := StringToBool(ini.ReadString('Case','Uppercase','No'));
    //rbLowercase.Checked := stringtobool(ini.ReadString('Case','Lowercase','Yes'));
    //rbCapitalizeWords.Checked := StringToBool(ini.ReadString('Case','CapitalizeWords','No'));
    cbFullDateTime.checked := StringToBool(ini.ReadString('System','FullDateTime','No'));


    txtBackslash.text := ini.ReadString('System','Backslash', '-');
    txtSlash.text := ini.ReadString('System','Slash', '{');
    txtColon.text:= ini.ReadString('System','Colon', ';');
    txtAsterisk.text := ini.ReadString('System','Asterisk', '+');
    txtQuestion.text := ini.ReadString('System','Question', '#');
    txtPipe.text := ini.ReadString('System','Pipe', '!');
    txtGreater.text := ini.ReadString('System','Greater', '[');
    txtLess.text := ini.ReadString('System','Lest', ']');
    txtQuote.text := ini.ReadString('System','Quote', '''');
    txtPeriod.text := ini.ReadString('System','Period', '.');

    //cbAutoFormatPopup.checked := ini.ReadBool('RenamingScript', cbAutoFormatPopup.Name, true);
    cbShowUpDown.checked := ini.ReadBool('RenamingScript', cbShowUpDown.Name, false);
    cbAlwaysShowStepButtons.Checked := ini.ReadBool('RenamingScript', cbAlwaysShowStepButtons.Name, false);
    cbAlwaysShowStepDescriptions.Checked := ini.ReadBool('RenamingScript', cbAlwaysShowStepDescriptions.Name, false);
    cbIgnoreEmpty.checked := ini.ReadBool('RenamingScript', cbIgnoreEmpty.Name, true);
    cbDetectEnvVars.Checked := ini.ReadBool('RenamingScript', cbDetectEnvVars.Name, true);
    cbAutoCollapse.Checked := ini.ReadBool('RenamingScript', cbAutoCollapse.Name, true);

    //rbFiles.checked := StringToBool(ini.ReadString('Renaming','Files','Yes'));
    //rbFolders.Checked := StringToBool(ini.ReadString('Renaming','Folders','No'));
    //rbFilesFolders.Checked := StringToBool(ini.ReadString('Renaming','FilesFolders','No'));
    frmmain.FilesOnly2.checked := StringToBool(ini.ReadString('Renaming','Files','Yes'));
    frmmain.FoldersOnly2.Checked := StringToBool(ini.ReadString('Renaming','Folders','No'));
    frmmain.FilesandFolders2.Checked := StringToBool(ini.ReadString('Renaming','FilesFolders','No'));



    cbFilterFolders.Checked := StringToBool(ini.ReadString('Renaming','FilterFolders', 'No'));
    //cbDisableCollisionDetection.checked := ini.ReadBool('Renaming','DisableCollisionDetection', false);
    cbAutoPreview.Checked := ini.ReadBool('Renaming', cbAutoPreview.name, true);
    cbNoHiddenFiles.Checked := ini.ReadBool('Renaming', cbNoHiddenFiles.Name, false);
    //rbWildcards.Checked := ini.ReadBool('Renaming', rbWildcards.Name, true);
    //rbRegExp.Checked := ini.ReadBool('Renaming', rbRegExp.Name, false);


    //rbOldSelectFolder.checked := StringToBool(ini.ReadString('SelectFolder','UseOldForm', 'No'));
    //rbBrowse.checked := StringToBool(ini.ReadString('SelectFolder','Browse', 'Yes'));
    //rbStandardOpen.checked := StringToBool(ini.ReadString('SelectFolder','OpenDialog', 'No'));

    cbNoFileIcons.Checked := StringToBool(ini.ReadString('FileOptions','DisableIcons','No'));
    cbDontSelectFolders.Checked := StringToBool(ini.ReadString('FileOptions','DontSelectFolders','Yes'));
    cbNoIcache.Checked := ini.ReadBool('FileOptions', cbNoIcache.Name, false );
    cbNoClearFilter.checked := ini.ReadBool('FileOptions', cbNoClearFilter.Name, false);


    LastFont.Name := ini.ReadString('Font','Name',  LastFont.Name);
    LastFont.Size := ini.ReadInteger('Font','Size', LastFont.Size );
    if ini.ReadBool('Font','Bold', false) then
        LastFont.style := LastFont.style + [fsBold];
    if ini.ReadBool('Font','Italic', false) then
       LastFont.style := LastFont.style + [fsItalic];

    ScriptFont.Name := ini.ReadString('ScriptFont','Name',  ScriptFont.Name);
    ScriptFont.Size := ini.ReadInteger('ScriptFont','Size', ScriptFont.Size );
    if ini.ReadBool('ScriptFont','Bold', false) then
        ScriptFont.style := ScriptFont.style + [fsBold];
    if ini.ReadBool('ScriptFont','Italic', false) then
       ScriptFont.style := ScriptFont.style + [fsItalic];

    // being replaced with 2 date columns   
    //cbFileCreatedDate.checked := ini.ReadBool('FileOptions', cbFileCreatedDate.Name, false);

    FrmThumbPreview.width := ini.ReadInteger('ThumbnailWindow', 'width', 350);
    FrmThumbPreview.height := ini.ReadInteger('ThumbnailWindow', 'height', 400);

    txtScriptFontName.Text := ini.ReadString('ScriptFont', txtScriptFontName.Name, txtScriptFontName.text);

    if not ini.ReadBool('MetavariableWindow', 'DetailsVisible', false) then begin
        //frmMetaVariables.Height := frmMetaVariables.Height - frmMetaVariables.formatHeight;
        //frmMetaVariables.btnMore.Click;
    end;

    //frmMetaVariables.Width := ini.ReadInteger('MetavariableWindow', 'width', 540);
    //frmMetaVariables.height := ini.ReadInteger('MetavariableWindow', 'height', 350);
    //frmMetaVariables.topoffset := ini.ReadInteger('MetavariableWindow', 'topoffset',  0) ;
    //frmMetaVariables.leftoffset := ini.ReadInteger('MetavariableWindow', 'leftoffset', 0);

    frmmain.MiniRenamingButtons1.Checked := ini.ReadBool('View',FrmMain.MiniRenamingButtons1.Name, true);



    self.ScriptView := true;
    //self.ScriptView := ini.ReadBool('ScriptingView', frmmain.btnScriptToggle.Name, true);

    // load colors
    for i := 0 to tsColors.ControlCount - 1 do begin
        if (tsColors.Controls[i] is TPanel) then begin
            for k := 0 to TPanel(tsColors.controls[i]).ControlCount - 1 do begin
                ctrl := TPanel(tsColors.Controls[i]).Controls[k];
                if ctrl.Hint <> '' then begin
                    j := ini.ReadInteger(
                        'Colors',
                        ctrl.Name,
                        -1
                    );
                    if j <> -1 then begin
                        TLabel(ctrl).Color := j;
                    end;
                end;
            end;
        end;
        {if (tsColors.Controls[i] is TScrollBox) then begin
            for k := 0 to TScrollBox(tsColors.controls[i]).ControlCount - 1 do begin
                ctrl := TScrollBox(tsColors.Controls[i]).Controls[k];
                if ctrl.Hint <> '' then begin
                    j := ini.ReadInteger(
                        'Colors',
                        ctrl.Name,
                        -1
                    );
                    if j <> -1 then begin
                        TLabel(ctrl).Color := j;
                    end;
                end;
            end;
        end;}

    end;

    cbUseEffects.Checked := ini.ReadBool('Colors',cbUseEffects.Name, true);



    fOldFileMenuVisible := ini.ReadBool('Hidden', 'OldFileMenuVisible', false);
    ini.WriteBool('Hidden', 'OldFileMenuVisible', fOldFileMenuVisible);

    self.ScalePercent := ini.ReadInteger('Hidden','FormScaling', 100);
    ini.WriteInteger('Hidden','FormScaling', self.ScalePercent);


    ini.UpdateFile;
    ini.free;

    if firstrun then begin
        self.SaveSettings;
    end;
end;

procedure TfrmConfig.SaveFileFolderView;
var ini: TmyIniFile;
begin
    ini := TmyInifile.Create(UnitUtil.getinipath);
    ini.WriteString('Renaming','Files', boolToString(frmmain.FilesOnly2.checked));
    ini.WriteString('Renaming','Folders', BoolToString(frmmain.FoldersOnly2.Checked));
    ini.WriteString('Renaming','FilesFolders', boolToString(frmmain.FilesandFolders2.Checked));
    ini.UpdateFile;
    ini.free;
end;

procedure TFrmConfig.SaveSettings;
var ini: TmyIniFile;
    i,  k : integer;
    ctrl : TControl;
begin
    ini := TmyInifile.Create(UnitUtil.getinipath);
    ini.WriteBool('Startup', frmmain.thumbnaillist1.Name, FrmMain.thumbnaillist1.Checked );

    ini.WriteBool('Startup', frmmain.ToggleToolbar1.name, frmmain.ToggleToolbar1.Checked );

    //ini.WriteBool('Startup', frmmain.OldInterface1.Name, frmmain.OldInterface1.Checked  );
    //ini.WriteBool('Startup', frmmain.SaveFilterinscript1.Name, frmmain.SaveFilterinscript1.checked);
    //ini.WriteBool('Startup' ,'ChangeToFolderInScript', FrmMain.ChangeFolderonOpen1.checked);
    ini.WriteString('Startup','DontUseLastFolder', BoolToString( not cbRememberLastFolder.checked));
    if (not cbRememberLastFolder.checked) then begin
        ini.writestring('Startup','lastfolder', '');
    end else begin
        ini.writestring('Startup','lastfolder', LastFolder);
    end;
    ini.WriteString('Startup','RememberPosition', booltostring(cbRememberPosition.checked));
    ini.WriteString('Startup','WindowX', IntToStr(LastPosition.X));
    ini.WriteString('Startup','WindowY', IntToStr(LastPosition.Y));
    ini.WriteString('Startup','WindowWD', IntToStr(LastSize.X));
    ini.WriteString('Startup','WindowHT', IntToStr(LastSize.y));
    Ini.WriteInteger('Startup','WindowSplitterXa', LastSplitterSize.X);
    ini.WriteInteger('Startup','LastSplitterYa',LastSplitterSize.Y );
    ini.WriteBool('Startup', frmmain.MIToggleWideLayout1.Name, frmmain.MIToggleWideLayout1.checked);
    ini.WriteBool('Startup',frmmain.MIFilelistonLeftSize1.name, frmmain.MIFilelistonLeftSize1.Checked);
    ini.WriteString('Startup','RememberSize',BoolToString(cbRememberSize.Checked));
    ini.WriteBool('Startup', 'OpenMaximized', cbOpenMaximized.checked);
    ini.WriteBool('Startup','RememberColumnSizes', cbRememberColumnSizes.Checked);
    ini.WriteInteger('Startup','BroswePaneWidth', LastBrowsePaneWidth);
    ini.WriteBool('Startup','BroswePaneVisible', LastBrowsePaneVisible);
    //ini.WriteBool('Startup','ColumnButtonPressed', LastColumnButtonPressed);
    ini.WriteInteger('Startup','ColumnResizeType', Integer(LastColumnButtonPressed));
    ini.WriteBool('Startup','RememberBrowserPane', cbRememberBrowserPane.checked);

    //ini.WriteString('Case','Preserve', BoolToString(rbPreserveCase.checked));
    //ini.WriteString('Case','Alter',BoolToString(rbAlterCase.Checked));
    //ini.WriteString('Case','Uppercase', BoolToString(rbUppercase.Checked));
    //ini.WriteString('Case','Lowercase', BoolToSTring(rbLowercase.Checked));
    //ini.WriteString('Case', 'CapitalizeWords', BoolToString(rbCapitalizeWords.Checked ));


    ini.WriteString('System','FullDateTime',BoolToString(cbFullDateTime.Checked));
    ini.WriteString('System','Backslash', txtBackslash.text);
    ini.WriteString('System','Slash', txtSlash.text);
    ini.WriteString('System','Colon', txtColon.text);
    ini.WriteString('System','Asterisk', txtAsterisk.text);
    ini.WriteString('System','Question', txtQuestion.text);
    ini.WriteString('System','Pipe', txtPipe.text);
    ini.WriteString('System','Greater', txtGreater.text);
    ini.WriteString('System','Lest', txtLess.text);
    ini.WriteString('System','Quote', txtQuote.text);
    ini.WriteString('System','Period', txtPeriod.text);

//    ini.WriteBool('RenamingScript', cbAutoFormatPopup.Name, cbAutoFormatPopup.checked);
    ini.WriteBool('RenamingScript', cbShowUpDown.Name, cbShowUpDown.checked);
    ini.WriteBool('RenamingScript', cbAlwaysShowStepButtons.Name, cbAlwaysShowStepButtons.Checked);
	ini.WriteBool('RenamingScript', cbAlwaysShowStepDescriptions.Name, cbAlwaysShowStepDescriptions.Checked);
    ini.WriteBool('RenamingScript', cbIgnoreEmpty.Name, cbIgnoreEmpty.checked);
    ini.WriteBool('RenamingScript', cbDetectEnvVars.Name, cbDetectEnvVars.Checked);
    ini.WriteBool('RenamingScript', cbAutoCollapse.Name, cbAutoCollapse.checked);

    ini.WriteString('Registry','OnContextMenu', BoolToString(cbOnContextMenu.Checked) );


    //ini.WriteString('Renaming','Files', boolToString(rbFiles.checked));
    //ini.WriteString('Renaming','Folders', BoolToString(rbFolders.Checked));
    //ini.WriteString('Renaming','FilesFolders', boolToString(rbFilesFolders.Checked));
    ini.WriteString('Renaming','Files', boolToString(frmmain.FilesOnly2.checked));
    ini.WriteString('Renaming','Folders', BoolToString(frmmain.FoldersOnly2.Checked));
    ini.WriteString('Renaming','FilesFolders', boolToString(frmmain.FilesandFolders2.Checked));



    ini.WriteString('Renaming','FilterFolders', BoolToString(cbFilterFolders.Checked));
    //ini.WriteBool('Renaming','DisableCollisionDetection', cbDisableCollisionDetection.checked);
    ini.WriteBool('Renaming', cbAutoPreview.name, cbAutoPreview.Checked);
    ini.WriteBool('Renaming', cbNoHiddenFiles.Name, cbNoHiddenFiles.Checked);
    //ini.WriteBool('Renaming', rbWildcards.Name, rbWildcards.Checked);
    //ini.WriteBool('Renaming', rbRegExp.Name, rbRegExp.Checked);


    ini.WriteString('FileOptions','DisableIcons', BoolToString(cbNoFileIcons.checked));
    ini.WriteString('FileOptions','DontSelectFolders', boolToString(cbDontSelectFolders.checked));
    //ini.WriteBool('FileOptions', cbFileCreatedDate.Name, cbFileCreatedDate.checked);
    ini.WriteBool('FileOptions',cbNoIcache.Name, cbNoIcache.Checked);
    ini.WriteBool('FileOptions', cbNoClearFilter.Name, cbNoClearFilter.checked);


    //ini.WriteString('SelectFolder','UseOldForm', BooltoString(rbOldSelectFolder.checked));
    //ini.WriteString('SelectFolder','Browse', BoolToString(rbBrowse.checked));
    //ini.WriteString('SelectFolder','OpenDialog', BoolToString(rbStandardOpen.checked));

    ini.WriteString('Font','Name', LastFont.Name );
    ini.WriteInteger('Font','Size', LastFont.Size );
    ini.WriteBool('Font','Bold', fsbold in LastFont.Style);
    ini.WriteBool('Font','Italic', fsItalic in LastFont.Style);

    ini.WriteString('ScriptFont','Name', ScriptFont.Name );
    ini.WriteInteger('ScriptFont','Size', ScriptFont.Size );
    ini.WriteBool('ScriptFont','Bold', fsbold in ScriptFont.Style);
    ini.WriteBool('ScriptFont','Italic', fsItalic in ScriptFont.Style);



    //ini.WriteInteger('ThumbnailWindow', 'width', FrmThumbPreview.width );
    //ini.WriteInteger('ThumbnailWindow', 'height', FrmThumbPreview.Height );

    //ini.WriteInteger('MetavariableWindow', 'width', frmMetaVariables.Width);
    //ini.WriteInteger('MetavariableWindow', 'height', frmMetaVariables.height);

    ini.WriteInteger('MetavariableWindow', 'topoffset', frmMetaVariables.top - frmmain.Top);
    ini.WriteInteger('MetavariableWindow', 'leftoffset', frmMetaVariables.left - frmmain.Left);

    //ini.WriteString('MetavariableWindow', 'caption', frmMetaVariables.btnFormat.caption);

    //TODO: remember why this was a thing
    //ini.WriteBool('MetavariableWindow', 'DetailsVisible', frmMetaVariables.DetailsAreVisible);


    ini.WriteInteger('ThumbnailWindow', 'width', FrmThumbPreview.width);
    ini.WriteInteger('ThumbnailWindow', 'height', FrmThumbPreview.height);

    ini.WriteString('ScriptFont', txtScriptFontName.Name, txtScriptFontName.text);

    ini.WriteBool('View',FrmMain.MiniRenamingButtons1.Name, frmmain.MiniRenamingButtons1.Checked);
    //ini.WriteBool('ScriptingView', 'btnScriptToggle', frmmain.GetScriptingInterface);
    // save colors
    {
    for i := 0 to tsColors.ControlCount - 1 do begin
        if tsColors.Controls[i].Hint <> '' then begin
            ini.WriteInteger(
                'Colors',
                tsColors.Controls[i].Name,
                TLabel(tsColors.Controls[i]).color
            );
        end;
    end;
    }
    for i := 0 to tsColors.ControlCount - 1 do begin
        if tsColors.Controls[i] is TPanel then begin
            for k := 0 to TPanel(tsColors.controls[i]).ControlCount - 1 do begin
                ctrl := TPanel(tsColors.Controls[i]).Controls[k];
                if ctrl.Hint <> '' then begin
                    ini.WriteInteger(
                        'Colors',
                        ctrl.name,
                        TLabel(ctrl).color
                    );
                end;
            end;
        end;
    end;

    ini.WriteBool('Colors',cbUseEffects.Name, cbUseEffects.Checked);

    ini.UpdateFile;
    ini.Free;
end;


function TfrmConfig.StringToBool(s: string) : boolean;
begin
    result := (s = 'Yes');
end;
function TfrmConfig.BoolToString(b: boolean) : string;
begin
    case(b) of
    true: result := 'Yes';
    false: result := 'No';
    end;
end;


procedure TfrmConfig.cbOnContextMenuClick(Sender: TObject);
var reg: TRegistry;
begin
    //
    // add or remove the Context menu entry
    //
    reg := TRegistry.Create;
    //reg.RootKey := HKEY_CLASSES_ROOT;
    reg.RootKey := HKEY_CURRENT_USER;
//    HKEY_CURRENT_USER\Software\Classes\directory
    if cbOnContextMenu.Checked then begin
        //if not reg.KeyExists('\Software\Classes\Directory\shell\RenameMaster') then begin
            reg.OpenKey('\Software\Classes\Directory\shell\RenameMaster\command',true);
            reg.WriteString('',application.ExeName + ' "%1"');
            reg.CloseKey;
        //end;
    end else begin
        reg.DeleteKey('\Software\Classes\Directory\shell\RenameMaster');
    end;
    reg.Free;
end;


procedure TfrmConfig.rbPreserveCaseClick(Sender: TObject);
begin
    //rbUppercase.Enabled := false;
    //rbLowercase.Enabled := false;
    //rbCapitalizeWords.Enabled := false;
end;

procedure TfrmConfig.rbAlterCaseClick(Sender: TObject);
begin
    //rbUppercase.Enabled := true;
    //rbLowercase.Enabled := true;
    //rbCapitalizeWords.Enabled := true;
end;

procedure TfrmConfig.btnSaveClick(Sender: TObject);
begin
    self.DupeFont(GetFileList.Font, LastFont);
    self.SaveSettings;

    {if (cbFileCreatedDate.Checked) then begin
        Unitcolumnmanager.setDateColumnName(COL_DATE + ' Created');
    end else begin}
        Unitcolumnmanager.setDateColumnName(COL_DATE + ' Modified');
 {   end;}


    self.ModalResult := 1;
    FrmMain.RefreshColors;
	frmscriptactions.RefreshAllButtons;
    FrmScriptActions.RefreshColors;
    FrmScriptActions.redosentences;
end;

procedure TfrmConfig.btnScriptFontClick(Sender: TObject);
begin
    FontDialog2.Font.Name :=  txtScriptFontName.Text;
    if (FontDialog2.Execute) then begin
        DupeFont(fontdialog2.Font, self.ScriptFont);
        txtScriptFontName.Text := FontDialog2.Font.Name;
    end;
end;

procedure TfrmConfig.btnCancelClick(Sender: TObject);
begin
    self.DupeFont(self.LastFont, GetFileList.Font);
    self.ModalResult := 1;
end;


procedure TfrmConfig.bAboutClick(Sender: TObject);
begin
    FrmAbout.show;
end;

procedure TfrmConfig.btnSetClick(Sender: TObject);
begin
    if (FontDialog1.Execute) then begin
        self.DupeFont(GetFileList.Font, self.LastFont);
        self.DupeFont(FontDialog1.Font, getfileList.Font);
        txtFontName.Text := GetFileList.Font.Name;
    end;
end;

procedure TfrmConfig.FormActivate(Sender: TObject);
begin
    FontDialog1.Font := GetFileList.Font;
    txtFontName.Text := GetFileList.Font.Name;
   
end;


procedure TFrmConfig.DupeFont(target, dest : TFont);
begin
    dest.Name := target.name;
    dest.Size := target.size;
    dest.Style := target.Style;
end;

procedure TfrmConfig.txtBackslashChange(Sender: TObject);
begin
    if length(txtBackslash.Text) > 0 then begin
        UnitMetaVariables.SetBackslashChar(txtBackslash.text[1]);
    end;
end;
procedure TfrmConfig.txtSlashChange(Sender: TObject);
begin
    if length(txtSlash.Text) > 0 then begin
        UnitMetaVariables.SetSlashChar(txtSlash.text[1]);
    end;
end;
procedure TfrmConfig.txtPipeChange(Sender: TObject);
begin
    if length(txtPipe.Text) > 0 then begin
        UnitMetaVariables.SetPipeChar(txtPipe.text[1]);
    end;
end;
procedure TfrmConfig.txtColonChange(Sender: TObject);
begin
    if length(txtColon.Text) > 0 then begin
        UnitMetaVariables.SetColonChar(txtColon.text[1]);
    end;
end;
procedure TfrmConfig.txtQuestionChange(Sender: TObject);
begin
    if length(txtQuestion.Text) > 0 then begin
        UnitMetaVariables.SetQuestionChar(txtQuestion.text[1]);
    end;
end;
procedure TfrmConfig.txtAsteriskChange(Sender: TObject);
begin
    if length(txtAsterisk.Text) > 0 then begin
        UnitMetaVariables.SetAsteriskChar(txtAsterisk.text[1]);
    end;
end;
procedure TfrmConfig.txtGreaterChange(Sender: TObject);
begin
    if length(txtGreater.Text) > 0 then begin
        UnitMetaVariables.SetGreaterChar(txtGreater.text[1]);
    end;
end;
procedure TfrmConfig.txtLessChange(Sender: TObject);
begin
    if length(txtLess.Text) > 0 then begin
        UnitMetaVariables.SetLessChar(txtLess.text[1]);
    end;
end;
procedure TfrmConfig.txtQuoteChange(Sender: TObject);
begin
    if length(txtQuestion.Text) > 0 then begin
        UnitMetaVariables.SetQuoteChar(txtQuestion.text[1]);
    end;
end;

function TfrmConfig.GetDisableCollisionDetection: boolean;
begin
    //result := cbDisableCollisionDetection.checked;
    // NO longer used
    result := false;
end;

procedure TfrmConfig.txtPeriodChange(Sender: TObject);
begin
    if length(txtAsterisk .Text) > 0 then begin
        UnitMetaVariables.SetPeriodChar(txtPeriod.text[1]);
    end;
end;

procedure TfrmConfig.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if key = Ord(#27) then begin
        self.btnCancel.click;
    end;
end;



procedure TfrmConfig.btnCreateShortcutClick(Sender: TObject);
    procedure CreateShortcut(const exePath, args, workdir, shortcut : string);
    var obj  : IUnknown;
        link   : IShellLink;
        PFile   : IPersistFile;
        wsLink  : WideString;
    begin
        obj := ComObj.CreateComObject(CLSID_ShellLink);
        link := obj as IShellLink;
        pfile := obj as IPersistFile;

        link.SetPath(PChar(exePath));
        link.SetArguments(PChar(Args));
        link.SetWorkingDirectory(PChar(WorkDir));
        
        wsLink := Shortcut;
        PFile.Save(PWChar(wsLink), False);
    end;
    function GetSendToPath : string;

        function GetPath(CLSIDL : word) : string;
        var p : PItemIDList;
            Path: array[0..MAX_PATH] of char;
        begin
            SHGetSpecialFolderLocation(Application.Handle , CLSIDL, p);
            SHGetPathFromIDList(p, path);
            result := path;
        end;
    begin
        result := GetPath(CSIDL_SENDTO);
    end;
var s : string;
begin
    s := ExtractFilePath(Application.EXEName);
    CreateShortcut(
        Application.ExeName,
        '',
        s,
        IncludeTrailingPathDelimiter(GetSendToPath) + 'RenameMaster.lnk');

    ShowMessage('Shortcut Created.' + #13#10 + #13#10 + 
        'Select a group of files in Explorer and use' + #13#10 +
        '[Right-Click -> Send To -> RenameMaster] to open in RenameMaster.');
end;

procedure TfrmConfig.PageControl1Change(Sender: TObject);
    procedure DefaultC(l : TLabel; c : TColor);
    begin
        if l.Color = clNone then begin
            l.color := c;
        end;
    end;
begin
    if PageControl1.ActivePageIndex <> 4 then EXIT;

    {
    defaultc(lblPathFore, frmmain.cbPath.Font.Color);
    defaultc(lblPathBack, frmmain.cbPath.Color);

    defaultc(lblFileListFore, GetFileList.font.color);
    defaultc(lblFileListBack, GetFileList.Color);

    defaultc(lblOptionsFore , GetFileList.font.Color);
    defaultc(lblOptionsBack , GetFileList.Color);
    }
    pnlPath.Color := lblPathBack.Color;
    pnlPath.Font.Color := lblPathFore.Color;

    pnlFileList.color := lblFileListBack.Color;
    pnlFileList.Font.Color := lblFileListFore.Color;

    pnlCollision.Font.Color := lblCollisionsFore.color;
    pnlCollision.Color := lblFileListBack.Color;

    pnlRenamed.Font.Color := lblToBeRenamed.Color;
    pnlRenamed.Color := lblFileListBack.Color;


    pnlOptions.Color := lblOptionsBack.color;
    pnlOptions.Font.Color := lblOptionsFore.color;

    pnlRemoveStep.Color := lblRemoveStep.Color;
    pnlRemoveStep.Font.Color := clWhite;

    pnlReplaceStep.Color := lblReplaceStep.Color;
    pnlReplaceStep.Font.Color := clWhite;

    pnlAddStep.Color := lblAddStep.Color;
    pnlAddStep.Font.Color := clWhite;

    pnlStepContainer.Color := lblStepContainer.Color;
    pnlStepContainer.Font.Color := clBlack;

end;

procedure TfrmConfig.btnPathForegroundClick(Sender: TObject);
begin
    ColorDialog1.Execute;
end;

procedure TfrmConfig.ColorDialog( l : TLabel );
begin
    ColorDialog1.Color := l.Color;
    if ColorDialog1.Execute then begin
        l.Color := ColorToRGB(ColorDialog1.Color);
        PageControl1Change(self);
    end;
end;

procedure TfrmConfig.lblPathForeClick(Sender: TObject);
begin
    self.ColorDialog(lblPathFore) ;
    lblPathFore.Refresh;
end;
procedure TfrmConfig.lblRemoveStepClick(Sender: TObject);
begin
    self.ColorDialog(lblRemoveStep);
end;
procedure TfrmConfig.lblReplaceStepClick(Sender: TObject);
begin
    self.ColorDialog(lblReplaceStep);
end;
procedure TfrmConfig.lblStepContainerClick(Sender: TObject);
begin
    Self.ColorDialog(lblStepContainer);
end;

procedure TfrmConfig.lblToBeRenamedClick(Sender: TObject);
begin
    self.ColorDialog(lblToBeRenamed);
    lblToBeRenamed.Refresh;
end;
procedure TfrmConfig.lblPathBackClick(Sender: TObject);
begin
    self.ColorDialog(lblPathBack);
end;
procedure TfrmConfig.lblFileListForeClick(Sender: TObject);
begin
    self.ColorDialog(lblFileListFore);
end;
procedure TfrmConfig.lblFileListBckClick(Sender: TObject);
begin
    self.ColorDialog(lblFileListBack);
end;
procedure TfrmConfig.lblOptionsForeClick(Sender: TObject);
begin
    self.ColorDialog(lblOptionsFore);
end;
procedure TfrmConfig.lblOptionsBackClick(Sender: TObject);
begin
    self.ColorDialog(lblOptionsBack);
end;
procedure TfrmConfig.lblAddStepClick(Sender: TObject);
begin
    self.ColorDialog(lblAddStep);
end;
procedure TfrmConfig.lblCollisionsForeClick(Sender: TObject);
begin
    self.ColorDialog(lblCollisionsFore);
end;

end.
