unit UnitFrmCustomColumns;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, Menus;


type TCustomMode = (cmNewColumn, cmEditColumn);
type
  TFrmCustomColumns = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    txtColumnTitle: TEdit;
    btnSave: TButton;
    Button2: TButton;
    Panel49: TPanel;
    SpeedButton36: TSpeedButton;
    txtColumnData: TEdit;
    Label3: TLabel;
    cbxType: TComboBox;
    btnExamples: TSpeedButton;
    pmExample: TPopupMenu;
    MP3Track1: TMenuItem;
    MP3Artist1: TMenuItem;
    MP3Albumb1: TMenuItem;
    JPEGDate1: TMenuItem;
    JPEGWidth1: TMenuItem;
    JPEGHeight1: TMenuItem;
    procedure SpeedButton36Click(Sender: TObject);
    procedure txtColumnTitleChange(Sender: TObject);
    procedure btnExamplesClick(Sender: TObject);
    procedure MP3Track1Click(Sender: TObject);
    procedure MP3Artist1Click(Sender: TObject);
    procedure MP3Albumb1Click(Sender: TObject);
    procedure JPEGDate1Click(Sender: TObject);
    procedure JPEGWidth1Click(Sender: TObject);
    procedure JPEGHeight1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    mode : TCustomMode;
  public
    { Public declarations }
    function ShowNewColumn(var title,data : string) : TModalResult;
    function ShowEditColumn(var title,data : string) : TModalResult;

    procedure EditColumnMenuClick(sender : TOBject);
    procedure DeleteColumnMenuClick(sender : TOBject);
  end;

var
  FrmCustomColumns: TFrmCustomColumns;

implementation

{$R *.dfm}

{ TFrmCustomColumns }
uses UnitFrmMain, UnitColumnManager, UnitFrmDummyPreview,  UnitToken,
  UnitUtil, UnitFrmDummyShowPreview, UnitFormScaling;

procedure TFrmCustomColumns.DeleteColumnMenuClick(sender: TOBject);
var mi : TMenuItem;
    c,h : string;
begin
    with TmenuItem(sender) do begin
        c := Caption;
        h := Hint;

        try
            frmmain.lvFileList.Enabled := false;
            FrmMain.lvFileList.Columns.BeginUpdate;
            UnitColumnManager.DeleteCustomColumn(c);
            frmmain.PreviewNow;
        finally
            FrmMain.lvFileList.Columns.EndUpdate;
            frmmain.lvFileList.Enabled := true;
        end;

    end;
end;
procedure TFrmCustomColumns.EditColumnMenuClick(sender: TOBject);
var mi : TMenuItem;
    c,h : string;
begin
    with TmenuItem(sender) do begin
        c := Caption;
        h := Hint;
    end;

    delete(c,1, length('Edit '));
    self.ShowEditColumn(c, h);
end;




procedure TFrmCustomColumns.FormCreate(Sender: TObject);
begin
    TFormScaling.RegisterSelf(self);
end;

function TFrmCustomColumns.ShowEditColumn(var title, data : string) : TModalResult;
var ct : TColumnType;
begin
    mode := cmEditColumn;

    txtColumnTitle.Text :=     title;
    txtColumnData.text :=        data;

    result := self.ShowNewColumn(title, data)
end;
function TFrmCustomColumns.ShowNewColumn(var title,data : string) : TmodalResult;
var ct : TColumnType;
    mi : TMenuItem;
begin
    mode := cmNewColumn;
    if txtColumnTitle.text = ''  then
        btnSave.Enabled := false;

    result := self.ShowModal;
    if result = mrYes then begin
        title := txtColumnTitle.Text;
        data := txtColumnData.text;
        ct := COL_TYPE_NAME;
        case cbxType.ItemIndex of
        1: ct := COL_TYPE_DATE;
        2: ct := COL_TYPE_SIZE;
        end;
        try
            frmmain.lvFileList.Enabled := false;
            FrmMain.lvFileList.Columns.BeginUpdate;
            UnitColumnManager.NewCustomColumn(title, data, ct);
            frmmain.PreviewNow;
        finally
            FrmMain.lvFileList.Columns.EndUpdate;
            frmmain.lvFileList.Enabled := true;
        end;

    end;
end;

procedure TFrmCustomColumns.btnExamplesClick(Sender: TObject);
begin
    unitutil.ShowPopupRight(btnExamples, pmExample);
end;

procedure TFrmCustomColumns.SpeedButton36Click(Sender: TObject);
begin
    FrmMain.InsertButtonClick(sender);
end;

procedure TFrmCustomColumns.txtColumnTitleChange(Sender: TObject);
begin
    btnSave.Enabled := txtColumnTitle.Text <>  '';
end;



procedure TFrmCustomColumns.MP3Albumb1Click(Sender: TObject);
begin
    txtColumnTitle.text := 'MP3 - Album';
    txtColumnData.Text := '?i_al?';
    cbxType.ItemIndex := 0;
end;
procedure TFrmCustomColumns.MP3Artist1Click(Sender: TObject);
begin
    txtColumnTitle.text := 'MP3 - Artist';
    txtColumnData.Text := '?i_ar??';
    cbxType.ItemIndex := 0;
end;
procedure TFrmCustomColumns.MP3Track1Click(Sender: TObject);
begin
    txtColumnTitle.text := 'MP3 - Track';
    txtColumnData.Text := '?i_tr?';
    cbxType.ItemIndex := 2;
end;
procedure TFrmCustomColumns.JPEGDate1Click(Sender: TObject);
begin
    txtColumnTitle.text := 'JPEG - Date';
    txtColumnData.Text := '?x_dt:Fyyyy-MM-dd?';
    cbxType.ItemIndex := 1;
end;
procedure TFrmCustomColumns.JPEGHeight1Click(Sender: TObject);
begin
    txtColumnTitle.text := 'JPEG - Height';
    txtColumnData.Text := '?J_W?';
    cbxType.ItemIndex := 2;
end;
procedure TFrmCustomColumns.JPEGWidth1Click(Sender: TObject);
begin
    txtColumnTitle.text := 'JPEG - Width';
    txtColumnData.Text := '?J_W?';
    cbxType.ItemIndex := 2;
end;

end.
