unit UnitFrmDummyPreview;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;

type
  TFrmDummyAutoPreview = class(TForm)
    timPreview: TTimer;
    procedure timPreviewTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    disabled : boolean;
    WasTriggeredOnce : boolean;
    DoFireWhenEnabled : boolean;
  public
    { Public declarations }
    function GetEnabled : boolean; override;
    procedure SetEnabled(value : boolean); override;
    procedure StopTimer;
    procedure InformOfKeypress;
    procedure ForceTriggerIfEnabled;
    function WasTriggered : boolean;
    procedure FireWhenEnabled;
  end;

var
  FrmDummyAutoPreview: TFrmDummyAutoPreview;

implementation

uses UnitFrmMain, UnitFrmConfig;

{$R *.dfm}

{ TFrmDummyPreview }

procedure TFrmDummyAutoPreview.FireWhenEnabled;
begin
    DoFireWhenEnabled := true;
end;
function TFrmDummyAutoPreview.WasTriggered : boolean;
begin
    result := WasTriggeredOnce;
end;
function TFrmDummyAutoPreview.GetEnabled: boolean;
begin
    result := not self.disabled;
end;

var InformOfKeypressRunning : boolean;
procedure TFrmDummyAutoPreview.InformOfKeypress;
begin
    if InformOfKeypressRunning then EXIT;
    try
        InformOfKeypressRunning := true;
        timPreview.Enabled := false;
        frmmain.ReportAutopreview;
        if self.disabled then EXIT;
        if not FrmConfig.cbAutoPreview.checked then EXIT;
        if not frmmain.Visible  then EXIT;

        // disable any pending timer triger, then re-enable
        timPreview.Enabled := true;
    finally
        InformOfKeypressRunning := false;
    end;

end;

procedure TFrmDummyAutoPreview.timPreviewTimer(Sender: TObject);
begin
    timPreview.Enabled := false;
    WasTriggeredOnce := true;
    frmmain.btnPreview2.Click;
end;

procedure TFrmDummyAutoPreview.ForceTriggerIfEnabled;
begin
    if self.GetEnabled then begin
        self.timPreviewTimer(nil);
        Application.ProcessMessages;
    end;
end;

procedure TFrmDummyAutoPreview.FormCreate(Sender: TObject);
begin
    self.disabled := true;
end;

procedure TFrmDummyAutoPreview.SetEnabled(value: boolean);
begin
    self.disabled := not value;
    if GetEnabled and DoFireWhenEnabled then begin
        DoFireWhenEnabled := false;
        ForceTriggerIfEnabled;
    end;
end;

procedure TFrmDummyAutoPreview.StopTimer;
begin
    timPreview.Enabled := false;
end;

end.
