unit UnitFrmEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TFrmEdit = class(TForm)
    txtEdit: TEdit;
    StatusBar1: TStatusBar;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    e : TEdit;
  public
    { Public declarations }
    procedure ShowForm(e : TEdit);
  end;

var
  FrmEdit: TFrmEdit;

implementation

uses UnitFrmMain, UnitFormScaling;

{$R *.dfm}

{ TFrmEdit }

procedure TFrmEdit.ShowForm(e: TEdit);
var p : TPoint;
    r : TRect;
begin
    self.e := e;
    p := Point(e.left, e.Top);
    Windows.GetWindowRect(e.Handle, r);

    self.top := r.top + (r.Bottom - r.top) + 3;
    self.Left := FrmMain.Left + trunc(r.left * 0.2);
    //self.Left := r.left;

    self.txtEdit.text := e.text;
    self.Show;
end;

procedure TFrmEdit.FormCreate(Sender: TObject);
begin
    //refresh only, make topmost
    Windows.SetWindowPos(self.Handle, HWND_TOPMOST, 0, 0, 0, 0,
        (SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOOWNERZORDER or
                         SWP_NOZORDER Or SWP_FRAMECHANGED) and not SWP_NOZORDER);

TFormScaling.RegisterSelf(self);
end;

procedure TFrmEdit.FormKeyPress(Sender: TObject; var Key: Char);
begin
    case ord(key) of
    VK_ESCAPE: key := #0;
    end;
end;

procedure TFrmEdit.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    case key of
        VK_ESCAPE: begin
            self.close;
        end;
        VK_RETURN: begin
            e.text := self.txtEdit.text;
            self.Close;
        end;
    end;
end;

procedure TFrmEdit.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    e.Text := self.txtEdit.text;
end;

end.
