unit UnitFrmError;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TfrmError = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    lblCurrent: TLabel;
    lblNew: TLabel;
    lblError: TLabel;
    btnIgnore: TButton;
    btnUndo: TButton;
    Label5: TLabel;
    procedure btnIgnoreClick(Sender: TObject);
    procedure btnUndoClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ShowError(errCode : integer; curName, newName : string);

    procedure MyExceptionHandler(Sender : TObject; E : Exception );
  end;

var
  frmError: TfrmError;

implementation

uses UnitFrmUndo, UnitUtil, UnitFrmMain, SysConst , UnitFormScaling;

{$R *.dfm}

procedure TFrmError.ShowError(errCode : integer; curName, newName : string);
begin
    lblError.Caption := SysErrorMessage(errcode);
    if (errCode = 3) then begin
        lblError.Caption := lblError.Caption + ' (Filename length may be too long) ';
    end;
    lblNew.Caption := newName;
    lblCurrent.Caption := curName;

    self.ShowModal;
end;

procedure TfrmError.btnIgnoreClick(Sender: TObject);
begin
    self.ModalResult := mrIgnore;
end;

procedure TfrmError.btnUndoClick(Sender: TObject);
begin
    frmUndo.UndoNow;
    self.ModalResult := mrCancel;
end;

procedure TfrmError.FormCreate(Sender: TObject);
begin
TFormScaling.RegisterSelf(self);
end;

procedure TfrmError.MyExceptionHandler(Sender: TObject; E: Exception);
begin
    frmmain.SetSubStatusText(e.Message);

    if (e.message = SDateEncodeError)  then begin
        Dialogs.MessageDlg(
            'There is a known bug in Windows 7 that may be causing this issue.'+
            #13#10#13#10+
            'Under [Control Panel>Region and Language>Additional settings], press the Reset button to fix this problem.'
            ,mtError, [mbOK],0);
    end;
    // TODO - log something here
   //ShowMessage(e.Message);
end;

end.
