unit UnitFrmExclude;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Menus, Buttons;

type
  TFrmExclude = class(TForm)
    lbExcluded: TListBox;
    txtName: TEdit;
    Button1: TButton;
    Label1: TLabel;
    btnDelete: TButton;
    btnExcludeNow: TButton;
    btnAddExamples: TSpeedButton;
    pmAdd: TPopupMenu;
    MITextFilestxt1: TMenuItem;
    MIInifilesini1: TMenuItem;
    MIThumbsdb1: TMenuItem;
    MIDesktopini1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure lbExcludedClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure btnExcludeNowClick(Sender: TObject);
    procedure MITextFilestxt1Click(Sender: TObject);
    procedure MIInifilesini1Click(Sender: TObject);
    procedure MIThumbsdb1Click(Sender: TObject);
    procedure btnAddExamplesClick(Sender: TObject);
    procedure MIDesktopini1Click(Sender: TObject);
  private
    { Private declarations }
    folder : TStringList;
    ini  : string;
  public
    { Public declarations }
    function GetFolders : TStringList;
    function ExcludeNow : integer;
    function IsExcluded(name : string) : boolean;
  end;

var
  FrmExclude: TFrmExclude;

implementation

uses UnitFrmSelectFolderNew, UnitFrmMain, UnitFrmDummyShowPreview, ComCtrls,
  UnitWildcards, Masks, UnitUtil, UnitFormScaling;

{$R *.dfm}
function TFrmExclude.IsExcluded(name : string) : boolean;
var j : integer;
begin
    result := false;
    for j := 0 to folder.Count - 1 do begin
        if MatchesMask(name, folder[j]) then begin
            result := true;
            BREAK;
        end;
    end;
end;
function TFrmExclude.ExcludeNow: integer;
var i, j : integer;
    li : TListItem;
    s : string;
begin
    result := 0;
    GetFileList.items.BeginUpdate;
    for i := (GetFileList.items.Count - 1) downto 0 do begin
        li := GetFileList.Items[i];

        s := li.Caption;
        if IsExcluded(s) then begin
            FrmDummyShowPreview.SetChecked(i, false);
            inc(result);
        end;
    end;
    GetFileList.items.EndUpdate;
    self.Close;
end;



procedure TFrmExclude.FormCreate(Sender: TObject);
begin
    folder := TStringList.Create;
    folder.Sorted := true;
    folder.Duplicates := dupIgnore;
    ini :=          IncludeTrailingPathDelimiter(
            ExtractFilePath(application.ExeName)
         ) + 'exclude.ini';

    if fileexists(ini) then begin
        folder.LoadFromFile( ini );
    end;
    TFormScaling.RegisterSelf(self);
end;

procedure TFrmExclude.FormHide(Sender: TObject);
begin
    folder.SaveToFile( ini );
end;

procedure TFrmExclude.FormActivate(Sender: TObject);
begin
    lbExcluded.items.clear;
    lbExcluded.Items.AddStrings(folder);
end;

procedure TFrmExclude.Button1Click(Sender: TObject);
begin
    if txtname.text = '' then begin
        ShowMessage('ERROR: File name must not be empty.');
        EXIT;
    end;

    folder.Add(txtname.text);

    lbExcluded.Clear;
    lbExcluded.Items.AddStrings(folder);
end;



procedure TFrmExclude.lbExcludedClick(Sender: TObject);
begin
    if lbExcluded.ItemIndex = -1 then EXIT;

    txtname.text := folder.strings[lbExcluded.ItemIndex];
end;

function TFrmExclude.GetFolders: TStringList;
begin
    result := folder;
end;

procedure TFrmExclude.MIThumbsdb1Click(Sender: TObject);
begin
    txtname.text := 'thumbs.db';
end;

procedure TFrmExclude.MIInifilesini1Click(Sender: TObject);
begin
    txtname.text := '*.ini';
end;

procedure TFrmExclude.btnDeleteClick(Sender: TObject);
begin
    if lbExcluded.ItemIndex = -1 then EXIT;

    folder.Delete(lbExcluded.itemindex);
    lbExcluded.Items.Delete(lbExcluded.itemindex);
end;

procedure TFrmExclude.MIDesktopini1Click(Sender: TObject);
begin
    txtname.text := 'desktop.ini';
end;

procedure TFrmExclude.MITextFilestxt1Click(Sender: TObject);
begin
    txtname.text := '*.txt';
end;

procedure TFrmExclude.btnAddExamplesClick(Sender: TObject);
begin
    ShowPopupRight(btnAddExamples, pmAdd);
end;

procedure TFrmExclude.btnExcludeNowClick(Sender: TObject);
var i, j : integer;
    li : TListItem;
    s : string;
begin
    self.ExcludeNow;
    self.Close;
end;

end.
