unit UnitFrmFiletags;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Menus, UnitFrameCheckFilesDropdown, Vcl.Buttons,
  Vcl.ExtCtrls;

type
  TFrmFileTags = class(TForm)
    Memo1: TMemo;
    StatusBar1: TStatusBar;
    ListView1: TListView;
    pmCopy: TPopupMenu;
    CopyTag1: TMenuItem;
    CopyValue1: TMenuItem;
    pnl1: TPanel;
    btnCopyTag: TSpeedButton;
    FrameCheckedFileDropdown1: TFrameCheckedFileDropdown;
    btnCopyData: TSpeedButton;
    procedure ListView1CustomDrawItem(Sender: TCustomListView; Item: TListItem;
      State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure ListView1CustomDrawSubItem(Sender: TCustomListView;
      Item: TListItem; SubItem: Integer; State: TCustomDrawState;
      var DefaultDraw: Boolean);
    procedure CopyTag1Click(Sender: TObject);
    procedure CopyValue1Click(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure btnCopyTagClick(Sender: TObject);
    procedure btnCopyDataClick(Sender: TObject);
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure FileSelectedCallback(caption : string);
  private
    { Private declarations }
    procedure ExtractTags(filename : string);
    procedure setStatus(status : string);
  public
    { Public declarations }
        procedure ShowTags(filename : string; left:integer=-1;top:integer=-1);


  end;

var
  FrmFileTags: TFrmFileTags;

implementation
uses INIFiles, UnitFileTags, UnitUtil, UnitVideo,
Clipbrd, TypInfo, UnitFrmMain, IOUtils, UnitFormScaling, System.UITypes {lets Brushes use inline};
{$R *.dfm}

var NameToAbbr : THashedSTringList;

{ TFrmFileTags }

// public interface
procedure TFrmFileTags.ShowTags(filename : string; left:integer=-1;top:integer=-1);
begin
    self.Caption := 'File Tags ';
    SetStatus('');
    FrameCheckedFileDropdown1.setCurrent(
        TPath.GetFileName(filename)
    );

    // event may be triggered multiple times for the same file
    //

    self.ExtractTags(filename);

    self.Position := poMainFormCenter;
    self.Show;

    if (left<>-1) or (top<>-1) then begin
        self.Position := poDesigned;
        if left<>-1 then self.Left := left;
        if top<>-1 then self.Top := top;
    end;
end;

procedure TFrmFileTags.CreateParams(var Params: TCreateParams);
begin
    inherited;


    Params.ExStyle := Params.ExStyle or WS_Ex_AppWindow;
end;
procedure TFrmFileTags.FormCreate(Sender: TObject);
begin
    FrameCheckedFileDropdown1.setFileList(FrmMain.lvFileList);
    FrameCheckedFileDropdown1.setOnSelected(self.FileSelectedCallback);

    TFormScaling.RegisterSelf(self);
end;

// user events
procedure TFrmFileTags.btnCopyDataClick(Sender: TObject);
begin
    self.CopyValue1Click(CopyValue1);
end;
procedure TFrmFileTags.btnCopyTagClick(Sender: TObject);
begin
    self.CopyTag1Click(copytag1);
end;
procedure TFrmFileTags.CopyTag1Click(Sender: TObject);
var s : string;
begin
    if ListView1.Selected = nil then EXIT;

    s := ListView1.Selected.SubItems[0];
    Clipboard.SetTextBuf(pchar(s));

    SetStatus('Tag Copied: ' + s);
end;
procedure TFrmFileTags.CopyValue1Click(Sender: TObject);
var s : string;
begin
    if ListView1.Selected = nil then EXIT;

    s := ListView1.Selected.SubItems[1];
    Clipboard.SetTextBuf(pchar(s));

    SetStatus('Contents Copied');
end;

procedure TFrmFileTags.FileSelectedCallback(caption : string);
begin
    self.ExtractTags(
        IncludeTrailingPathDelimiter(FrmMain.FrameBreadcrumbs1.Path) +
        caption
    );
end;

// utility
procedure TFrmFileTags.ExtractTags;
 procedure AddTags(sl : THashedStringList);
    var i : integer;
        li : TListItem;
        s : string;
    begin
        //listview1.items.Clear;

        for i := 0 to sl.Count - 1 do begin
            // remove debug stuff
            if sl.names[i] = 'IFD0' then CONTINUE;
            if sl.names[i] = 'SubIFD' then CONTINUE;
            if sl.names[i] = 'InterIFD' then CONTINUE;

            if ContainsTerm('not found', sl.Names[i]) then CONTINUE;

            li := ListView1.Items.Add;
            s := sl.Names[i];;
            if (s <> '') and (s[1] = '?') then begin
            	li.caption := '';
				li.SubItems.add(s);

            end else begin
            	li.caption := s;
            	li.SubItems.add('');
            end;
            li.SubItems.Add(sl.Values[sl.Names[i]]);
        end;



    end;
var tags : THashedStringList;
	i : integer;
    s {, data} : string;
begin

    FrameCheckedFileDropdown1.setCurrent(TPath.GetFileName(filename));

    // event may be triggered multiple times for the same file
    //

    memo1.Lines.Clear;
    listview1.items.beginupdate;
    listview1.Clear;
    listview1.Visible := false;
    try

        ListView1.Columns[0].Width := 10;
        ListView1.Columns[1].Width := 10;

        if ContainsTerm(lowercase(ExtractFileExt(filename)), '.mp3') then begin
            tags := THashedStringList.Create;
            ReadMP3Full(filename, tags);
            tags.Sort;
            AddTags(tags);
            for i := 0 to listview1.Items.Count -1 do begin
                if listview1.Items[i].SubItems[0] = '' then begin
                    s := NameToAbbr.Values[listview1.Items[i].caption];
                    if s <> '' then begin
                        listview1.Items[i].SubItems[0] := '?'+lowercase(s)+'?';
                    end;
                end;
            end;
            tags.Free;
        end;

        if StringIn(lowercase(ExtractFileExt(filename)), ['.jpeg','.jpg'])  then begin
            tags := THashedStringList.Create;
            readjpeg(filename, tags);
            tags.Sort;
            AddTags(tags);
            for i := 0 to listview1.Items.Count -1 do begin
                if listview1.Items[i].SubItems[0] = '' then begin
					s := NameToAbbr.Values[listview1.Items[i].caption];
                    if s <> '' then begin
                        listview1.Items[i].SubItems[0] := '?'+lowercase(s)+'?';
                    end;
                end;
            end;
            tags.Free;
        end;

        if UnitVideo.FileSupported(filename) then begin
            tags := THashedStringList.Create;
            if UnitVideo.GetVideoTags(filename, tags) then begin
                tags.Sort;
                AddTags(tags);
            end;
            tags.free;
        end;
        ListView1.Columns[0].Width := -1;
        ListView1.Columns[1].Width := -1;
        listview1.Visible := true;
    except on e : exception do begin
	    listview1.Visible := false;
        memo1.Lines.add('Error reading tags from file. ' + e.Message);
    end;
    end;
    listview1.items.EndUpdate;
end;
procedure TFrmFileTags.setStatus(status : string);
begin
    StatusBar1.Panels[0].Text := status;
end;

// list view stuff
procedure TFrmFileTags.ListView1CustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
var //i  : integer;
    c : tcolor;
    r : TRect;
begin
    if item.Selected then EXIT;

//    c := sender.Canvas.Brush.color;

    sender.Canvas.Font.Color := 0;
    c := ColorToRGB(clWindow);
    if (item.Selected) then begin
        c := colortoRGB( graphics.clHighlight );
    end else if odd(item.Index) then begin
        c := ColorToRGB( dimcolor(c, 0.95) );
    end;

    // kludge: if the item isn't changed, it may not be updated
    // with the new settings made here
    sender.Canvas.Brush.Color := 0;
    sender.Canvas.Brush.Color := c;

    // there's no middle ground, either you have little control
    // or you have to draw the entire thing including sub items
    r := item.DisplayRect(drBounds);
    Windows.SetBkMode(sender.Canvas.Handle, TRANSPARENT);

    r := item.DisplayRect(drLabel);
    defaultdraw := true;
end;
procedure TFrmFileTags.ListView1CustomDrawSubItem(Sender: TCustomListView;
  Item: TListItem; SubItem: Integer; State: TCustomDrawState;
  var DefaultDraw: Boolean);
var// i  : integer;
    c : tcolor;
    r : TRect;
begin
    if item.Selected then EXIT;

    //c := sender.Canvas.Brush.color;

    sender.Canvas.Font.Color := 0;
    c := ColorToRGB(clWindow);
    if (item.Selected) then begin
        c := colortoRGB( graphics.clHighlight );
        sender.Canvas.font.color := graphics.clHighlightText;
    end else if odd(item.Index) then begin
        c := ColorToRGB( dimcolor(c, 0.95) );
    end;

    // kludge: if the item isn't changed, it may not be updated
    // with the new settings made here

    sender.Canvas.Brush.Color := 0;
    sender.Canvas.Brush.Color := c;


    // there's no middle ground, either you have little control
    // or you have to draw the entire thing including sub items

    r := item.DisplayRect(drBounds);
    Windows.SetBkMode(sender.Canvas.Handle, TRANSPARENT);

    r := item.DisplayRect(drLabel);
    defaultdraw := true;
end;
procedure TFrmFileTags.ListView1DblClick(Sender: TObject);
var
    pt : TPoint;
begin
    pt := Mouse.CursorPos;
    pmCopy.Popup(pt.X, pt.Y+ ListView1.Canvas.TextHeight('ZZ')+10);
end;
procedure TFrmFileTags.ListView1SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
    btnCopyTag.Enabled := ListView1.SelCount > 0;
    btnCopyData.Enabled := btnCopyTag.Enabled;
end;


var x : EXIF_Enum;
	m : MP3_Enum;
initialization
begin
	NameToAbbr := THashedStringList.create;
    for x := low(EXIF_Enum) to high(EXIF_ENum) do begin
        // skip internal structure tags or problematic tags
        if x in [X_JPEGP, X_EO, X_II, X_MN, X_IO, X_IW, X_IL,
            X_GPSI, X_CC ] then CONTINUE;

        NameToAbbr.Values[UnitFileTags.GetTagName(x)] := UnitFileTags.GetTagAbbr(x);
    end;
    NameToAbbr.values[JFIF_PRECISION] := 'j_b';
	NameToAbbr.values[JFIF_WIDTH] := 'j_w';
	NameToAbbr.values[JFIF_HEIGHT] := 'j_h';


    for m := low(mp3_enum) to high(mp3_enum) do begin
    	NameToAbbr.Values[UnitFileTags.GetMP3TagName(m)] := GetEnumName(TypeInfo(MP3_Enum), integer(m));
    end;
end;


end.
