unit UnitFrmFilter;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Buttons;

type
  TFrmFilter = class(TForm)
    Label1: TLabel;
    txtFilter: TEdit;
    Button1: TButton;
    Button2: TButton;
    ComboBox1: TComboBox;
    cbIncludeFolders: TCheckBox;
    btnResetFilter: TBitBtn;
    cbFullRegExp: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnResetFilterClick(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmFilter: TFrmFilter;

implementation

uses UnitFrmMain, UnitFrmDummyShowPreview, UnitWildcards, UnitFormScaling;

{$R *.dfm}

procedure TFrmFilter.Button1Click(Sender: TObject);
var rec : TSearchRec;
    path : string;
    i, attr : integer;
    j,k : cardinal;
    li : TListItem;
    value : boolean;
    wc : TWildcards;
    filename : string;
begin
    path :=  IncludeTrailingPathDelimiter(FrmMain.GetPath);
    value := self.ComboBox1.ItemIndex in [0, 1];
    attr := faAnyFile or faHidden;
    if (self.cbIncludeFolders.checked) then attr := attr or faDirectory;

    // select only mean clear all items first
    if (self.ComboBox1.ItemIndex = 0) then begin
        frmmain.uncheckall1.Click;
    end;

    if cbFullRegExp.Checked  then begin
        wc := TRegExpWildcards.Create;
    end else begin
        wc := TWildcards.Create;
    end;

    wc.SetSearchPattern(txtFilter.text);

    for i := 0 to frmmain.lvFileList.Items.Count - 1 do begin
        filename := ExtractFileName( frmmain.lvFileList.Items[i].caption);

        wc.SetSearchString( filename );
        if wc.FindFirst(j,k) and (j=1) and (k = length(filename)) then begin
            if FrmDummyShowPreview.IsFolder(frmmain.lvFileList.items[i])
            then begin
                if (self.cbIncludeFolders.checked) then
                    FrmDummyShowPreview.SetChecked(i, value);
            end else begin
                FrmDummyShowPreview.SetChecked(i, value);
            end;
        end;
    end;
    wc.Free;
    
    self.ModalResult := mrok;
end;

procedure TFrmFilter.Button2Click(Sender: TObject);
begin
    self.ModalResult := mrok;
end;

procedure TFrmFilter.FormActivate(Sender: TObject);
begin
    {self.Left := Mouse.CursorPos.X + 20;
    self.top := Mouse.CursorPos.y - 10;
    }
end;

procedure TFrmFilter.FormCreate(Sender: TObject);
begin
TFormScaling.RegisterSelf(self);
end;

procedure TFrmFilter.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if key = VK_ESCAPE then begin
        key := 0;
        self.ModalResult := mrok;
    end;
end;

procedure TFrmFilter.btnResetFilterClick(Sender: TObject);
begin
    txtFilter.Text := '*.*';
end;

end.
