unit UnitFrmMetaVariables;

{
    Purpose:
        Give the user a point & click method of inserting ?xx? style
        metavariables.

    Updates:
        Fixed Current Folder meta-variable not inserting

        new "Preview" for meta-tags formatting
        ------------------
        Insert doesn't close form
        Form is no longer modal, always on top instead

        -----------------
        New "formatting" pane and toggle button
        ----------------
        New ?cf? current folder variable in File Properties


        Inserting zero padded numbers would ignore input typed in the
        textbox and only use the up/down buttons.

}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Buttons, Menus,
  UnitFrameCheckFilesDropdown;

type
  TfrmMetaVariablesOld1 = class(TForm)
    {$region 'default'}
    pnlSelect: TPanel;
    PageControl1: TPageControl;
    tsFile: TTabSheet;
    tsTodaysDate: TTabSheet;
    rbTDDateshort: TRadioButton;
    rbTDDateMedium: TRadioButton;
    rbTDDatelong: TRadioButton;
    tsMP3: TTabSheet;
    Label7: TLabel;
    tsJPEG: TTabSheet;
    StatusBar1: TStatusBar;
    pnlFormat: TPanel;
    cbxFile: TComboBox;
    pcFile: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    imgCollapse: TImage;
    imgExpand: TImage;
    pnlTop: TPanel;
    btnFormatClose: TButton;
    btnFormatInsert: TButton;
    pnlRect: TPanel;
    btnCustomFormat: TButton;
    pmDateExamples: TPopupMenu;
    yyyymmddformat1: TMenuItem;
    yyyymmddhhmmssformat1: TMenuItem;
    N24hourtimehhmmss1: TMenuItem;
    cbxFormat: TComboBox;
    pmFormat: TPopupMenu;
    AddPadding1: TMenuItem;
    AddDecimalPoint1: TMenuItem;
    DateTimeFormatting1: TMenuItem;
    Hexidecimal1: TMenuItem;
    Substring1: TMenuItem;
    ChangeNumberstoLetters1: TMenuItem;
    none1: TMenuItem;
    N1: TMenuItem;
    pcFormat: TPageControl;
    TabSheet4: TTabSheet;
    Label17: TLabel;
    TabSheet5: TTabSheet;
    Label9: TLabel;
    Label11: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    cbPad: TComboBox;
    txtChar: TEdit;
    txtLength: TEdit;
    UpDown1: TUpDown;
    TabSheet6: TTabSheet;
    Label20: TLabel;
    Label21: TLabel;
    txtDecimal: TEdit;
    UpDown2: TUpDown;
    TabSheet7: TTabSheet;
    Label22: TLabel;
    Label13: TLabel;
    btnFormatExample: TSpeedButton;
    txtDateFormat: TEdit;
    cbxAlter: TComboBox;
    txtAlterAmount: TEdit;
    cbxAlterUnits: TComboBox;
    TabSheet8: TTabSheet;
    Label14: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    txtHexPad: TEdit;
    UpDown3: TUpDown;
    TabSheet9: TTabSheet;
    Label2: TLabel;
    Label26: TLabel;
    txtSubX: TEdit;
    txtSubY: TEdit;
    TabSheet10: TTabSheet;
    Label27: TLabel;
    cbStartWithZero: TCheckBox;
    TabSheet11: TTabSheet;
    rbFPDateshort: TRadioButton;
    rbFPDatemedium: TRadioButton;
    rbFPDatelong: TRadioButton;
    rbFPDateModified: TRadioButton;
    rbFPDateCreated: TRadioButton;
    rbFPType: TRadioButton;
    rbFPCurFolder: TRadioButton;
    RadioButton1: TRadioButton;
    rbFPName: TRadioButton;
    rbFCCurrent: TRadioButton;
    txtZeros: TEdit;
    fcUpDown: TUpDown;
    Label1: TLabel;
    rbRFTotal: TRadioButton;
    rbFCTotalSelected: TRadioButton;
    rbFCTotalFolder: TRadioButton;
    rbFSBytes: TRadioButton;
    rbFSKilos: TRadioButton;
    rbFSMegs: TRadioButton;
    rbFSGigs: TRadioButton;
    Panel1: TPanel;
    Label16: TLabel;
    lblName: TLabel;
    Panel2: TPanel;
    lblData: TLabel;
    lblPreview: TLabel;
    lblFilename: TLabel;
    Panel3: TPanel;
    btnSetFormat: TSpeedButton;
    lblFormat: TLabel;
    cbxLayout: TComboBox;
    rbFilenameOnly: TRadioButton;
    rbFileContents: TRadioButton;
    txtContentsA: TEdit;
    Label6: TLabel;
    txtContentsb: TEdit;
    cbxTextEncode: TComboBox;
    pnlMP3: TPanel;
    Label15: TLabel;
    Label23: TLabel;
    pnl1: TPanel;
    Label8: TLabel;
    rbArtist: TRadioButton;
    rbAlbum: TRadioButton;
    rbTitle: TRadioButton;
    rbTrack: TRadioButton;
    rbComment: TRadioButton;
    rbYear: TRadioButton;
    Label5: TLabel;
    rbBitrate: TRadioButton;
    rbSample: TRadioButton;
    rbChannels: TRadioButton;
    Label12: TLabel;
    pnl2: TPanel;
    Label10: TLabel;
    txtJPEGStarts: TEdit;
    btnDisableUnused: TButton;
    sbJPEG: TScrollBox;
    Label3: TLabel;
    Label4: TLabel;
    rbWidth: TRadioButton;
    rbHeight: TRadioButton;
    rbBits: TRadioButton;
    pnlJPG: TPanel;
    Label28: TLabel;
    Label29: TLabel;
    btnShowMP3: TSpeedButton;
    btnShowJPEG: TSpeedButton;
    FrameCheckedFileDropdown1: TFrameCheckedFileDropdown;
    pnl3: TPanel;
    Label30: TLabel;
    procedure rbTDDateshortClick(Sender: TObject);
    procedure rbTDDateMediumClick(Sender: TObject);
    procedure rbTDDatelongClick(Sender: TObject);
    procedure rbFCCurrentClick(Sender: TObject);
    procedure rbRFTotalClick(Sender: TObject);
    procedure rbFCTotalSelectedClick(Sender: TObject);
    procedure rbFPDateshortClick(Sender: TObject);
    procedure rbFPDatemediumClick(Sender: TObject);
    procedure rbFPDatelongClick(Sender: TObject);
    procedure rbFPTypeClick(Sender: TObject);
    procedure rbFSBytesClick(Sender: TObject);
    procedure rbFSKilosClick(Sender: TObject);
    procedure rbFSMegsClick(Sender: TObject);
    procedure rbFSGigsClick(Sender: TObject);
    procedure rbFSNoneClick(Sender: TObject);
    procedure rbFSCommasClick(Sender: TObject);
    procedure rbFSDecimalClick(Sender: TObject);
    procedure btnInsertClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure fcUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure rbFCTotalFolderClick(Sender: TObject);
    procedure txtZerosChange(Sender: TObject);
    procedure rbFPCurFolderClick(Sender: TObject);
    procedure rbArtistClick(Sender: TObject);
    procedure rbAlbumClick(Sender: TObject);
    procedure rbTitleClick(Sender: TObject);
    procedure rbTrackClick(Sender: TObject);
    procedure rbCommentClick(Sender: TObject);
    procedure rbYearClick(Sender: TObject);
    procedure rbBitrateClick(Sender: TObject);
    procedure rbSampleClick(Sender: TObject);
    procedure rbChannelsClick(Sender: TObject);
    procedure rbWidthClick(Sender: TObject);
    procedure rbBitsClick(Sender: TObject);
    procedure rbHeightClick(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure txtJPEGStartsChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure rbFormatDefaultClick(Sender: TObject);
    procedure cbPadClick(Sender: TObject);
    procedure txtCharChange(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure UpDown2Click(Sender: TObject; Button: TUDBtnType);
    procedure txtDateFormatChange(Sender: TObject);
    procedure rbFormatPadClick(Sender: TObject);
    procedure rbFormatDecimalClick(Sender: TObject);
    procedure rbDateFormatClick(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure rbFPNameClick(Sender: TObject);
    procedure rbFPDateModifiedClick(Sender: TObject);
    procedure rbFPDateCreatedClick(Sender: TObject);
    procedure rbSubstringClick(Sender: TObject);
    procedure txtSubXChange(Sender: TObject);
    procedure txtSubYChange(Sender: TObject);
    procedure rbLettersClick(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure cbxFileChange(Sender: TObject);
    procedure cbxFormatChange(Sender: TObject);
    procedure cbStartWithZeroClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnCustomFormatClick(Sender: TObject);
    procedure btnDisableUnusedClick(Sender: TObject);
    procedure yyyymmddformat1Click(Sender: TObject);
    procedure btnFormatExampleClick(Sender: TObject);
    procedure cbxAlterChange(Sender: TObject);
    procedure btnSetFormatClick(Sender: TObject);
    procedure FormatClick(Sender: TObject);
    procedure txtCharEnter(Sender: TObject);
    procedure txtCharClick(Sender: TObject);
    procedure StatusBar1DrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel;
      const Rect: TRect);
    procedure cbxLayoutChange(Sender: TObject);
    procedure rbFilenameOnlyClick(Sender: TObject);
    procedure pmFormatPopup(Sender: TObject);
    procedure rbFileContentsClick(Sender: TObject);
    procedure btnShowMP3Click(Sender: TObject);
    procedure btnShowJPEGClick(Sender: TObject);
    {$endregion}
  private
    { Private declarations }
    ActivateOnce : boolean;
    TargetEditControl: TCustomEdit;
    metavar0: string;
    metavar1: string;
    metavar2: string;
    metavar3: string;
    metavar4: string;
    FTopoffset : integer;
    FLeftoffset : integer;
    rbs : array[0..150] of TRadioButton;
    rbsCount : integer;
    previewFile : string;
    FullFormView : boolean;
    DetailsVisible : boolean;
    FormatMode : boolean;
    LastTopHeight : integer;
    FormatText : string;
    Preview : string;
    OriginalFormatting : string;
    SaveDetailsVisible : boolean;

    StartingTopHeight : integer;
    StartingSelectHeight : integer;
    StartingFormatHeight : integer;

    LastPageIndex :integer;

    IgnorePreviewOnce : boolean;

    procedure SetFilesizeMetavariable;
    procedure MyRBClick(Sender: TObject);
    procedure ShowPreview;
    function MetaFormat(s : string) : string;

    procedure SetVariable(section : integer; metavar : string; autopreview : boolean = true);
    procedure ParseFormatting(s : string);
    procedure SetFormatPage(i : integer);
    procedure SetVarDisplay(variable : string);
    procedure FileSelectedCallback(filename : string);
  public

      formatHeight : integer;
    { Public declarations }
    procedure ShowForm(t: TCustomEdit);
    procedure ShowFormFormat(t: TCustomEdit; ShowPage : integer = -1);
    procedure NotifyOfSelect(filename : string = '');
    property topoffset : integer read FTopoffset write FTopoffset;
    property leftoffset : integer read FLeftoffset write FLeftoffset;
    function DetailsAreVisible : boolean;
  end;

var
  frmMetaVariablesOld1: TfrmMetaVariablesOld1;

implementation

{$R *.dfm}
uses UnitMetaVariables, UnitFileTags, StrUtils, UnitFrmMain, UnitUtil,
  UnitFrmScriptActions, INIFiles, UnitWildcards, UnitFrmDummyShowPreview, UnitToken, UnitFormScaling;

type FormatPageName = (
    pnNone,
    pnPadding,
    pnDecimal,
    pnDate,
    pnHex,
    pnSubstring,
    pnLetters
);

//
// Public Interface
//
procedure TfrmMetaVariablesOld1.ShowForm(t: TCustomEdit);
begin
    self.Caption := 'Insert Meta-Variable -  File and date data';

    FormatMode := false;

    btnFormatInsert.Caption := 'Insert';

    pnlSelect.Visible  := true;
    pnlTop.Visible := true;
    pnlTop.top := 0;
    pnlSelect.Align := alnone;

    if (self.FTopoffset = 0) and (self.FLeftoffset = 0) then begin
        self.top := frmmain.top + trunc(frmmain.Height / 2) - trunc(self.Height/2);
        self.left := frmmain.left + trunc(frmmain.width / 2) - trunc(self.width/2);
    end else begin
        self.top := frmmain.top + self.FTopoffset;
        self.Left := frmmain.left + self.FLeftoffset;
    end;

    TargetEditControl := t;

    self.SetFormatPage(0);

    self.ShowPreview;

    pnlSelect.Align := alClient;
    self.Show;

    if t is tedit then begin
        TEdit(t).Color := clBtnShadow;
    end;
end;
procedure TfrmMetaVariablesOld1.ShowFormFormat(t: TCustomEdit; ShowPage:integer=-1);
var wc : TWildCards;
    s : string;
begin
    btnFormatInsert.Caption := 'Replace';

    FormatMode := true;
    btnFormatInsert.visible := true;
    btnFormatClose.visible := true;
    pnlSelect.Visible  := false;
    pnltop.Height := StartingTopHeight;
    self.ClientHeight := pnlTop.Height + StatusBar1.Height ;

    if (self.FTopoffset = 0) and (self.FLeftoffset = 0) then begin
        self.top := frmmain.top + trunc(frmmain.Height / 2) - trunc(self.Height/2);
        self.left := frmmain.left + trunc(frmmain.width / 2) - trunc(self.width/2);
    end else begin
        self.top := frmmain.top + self.FTopoffset;
        self.Left := frmmain.left + self.FLeftoffset;
    end;

    pnlTop.Visible := true;
    LastTopHeight := self.Height;

    s := t.SelText;
    s[1] := '?';
    s[length(s)] := '?';

    SetVarDisplay( s );
    TargetEditControl := t;
    FormatText := s;

    self.SetFormatPage(0);
    OriginalFormatting := '';
    if ShowPage = -1 then begin
        wc := TRegExpWildcards.Create;
        wc.SetSearchString(FormatText);
        wc.SetSearchPattern('\:[^?]*');

        OriginalFormatting := wc.FindString;
        FormatText := wc.SearchReplaceWith(FormatText,'\:.*\?','?',false);
        SaveDetailsVisible := DetailsVisible;

        self.ParseFormatting(OriginalFormatting);
    end else begin
         self.SetFormatPage(ShowPage)
    end;

    //self.Show;
    self.ShowPreview;
    self.Show;

    self.ClientHeight := pnlTop.Height + StatusBar1.Height ;
    if (TargetEditControl is TEdit) then
        TEdit(TargetEditControl).Color := clBtnShadow;
end;

//--------------------------------------
// Private Implementation
//--------------------------------------
procedure TfrmMetaVariablesOld1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     if (TargetEditControl is TEdit) then
        TEdit(TargetEditControl).Color := clWindow;
    pnlSelect.Visible := true;
    if FormatMode then begin
        self.Height := LastTopHeight;
    end;
end;
procedure TfrmMetaVariablesOld1.FormCreate(Sender: TObject);
var I : integer;
begin
    ActivateOnce := true;
    self.DetailsVisible := false;
    // always on top
     Windows.SetWindowPos(self.Handle, HWND_TOPMOST, 0, 0, 0, 0,
        (SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOOWNERZORDER or
                         SWP_NOZORDER Or SWP_FRAMECHANGED ) and not SWP_NOZORDER);

    //
    // set defaults, init each page's metavar? variables
    //
    //FIX: Forgot to inclue the new pages.
    {rbFSBytes.Checked := true;
    rbFSBytes.OnClick(self);}

    //rbFSNone.Checked := true;
    //rbFSNone.OnClick(self);

    {rbFPDateshort.Checked := true;
    rbFPDateshort.OnClick(self);}

    rbFCCurrent.Checked := true;
    rbFCCurrent.OnClick(self);

    rbFPDateModified.Checked := true;
    rbFPDateModified.OnClick(self);

    rbTDDateshort.checked := true;
    rbTDDateshort.OnClick(self);

    //rbBitrate.Checked := true;
    //rbBitrate.OnClick(self);
    rbArtist.Checked := true;
    rbArtist.OnClick(self);

    rbWidth.Checked := true;
    rbWidth.OnClick(rbwidth);

    self.StartingTopHeight := pnlTop.height;
    self.StartingSelectHeight := pnlSelect.Height;
    self.StartingFormatHeight := pnlFormat.Height;

    self.PageControl1.ActivePage := self.tsFile;


    self.pnlSelect.Align := alTop;
    self.pnlTop.Align := altop;
    self.formatHeight := self.pnlFormat.Height;


    for I := 0 to pcfile.PageCount  - 1 do begin
        pcfile.Pages[i].TabVisible := false;
    end;
    cbxfile.ItemIndex := 0;


    for I := 0 to pcFormat.PageCount  - 1 do begin
        pcFormat.Pages[i].TabVisible := false;
    end;
    self.SetFormatPage(0);

    FrameCheckedFileDropdown1.setOnSelected(self.FileSelectedCallback);
    FrameCheckedFileDropdown1.setFileList(frmmain.lvFileList);

    TFormScaling.RegisterSelf(self);
end;
procedure TfrmMetaVariablesOld1.FormActivate(Sender: TObject);
var
    sl : TStringList;
    x : EXIF_Enum;
    top : integer;
    i : integer;
    rb :TRadioButton;
begin
    if (ActivateOnce) then begin
        sl := TStringList.Create;

        top := 115;
        for x := low(EXIF_Enum) to high(EXIF_ENum) do begin
            // skip internal structure tags or problematic tags
            if X in [X_JPEGP, X_EO, X_II, X_MN, X_IO, X_IW, X_IL,
                X_GPSI, X_CC ] then CONTINUE;

            sl.Values[UnitFileTags.GetTagName(x)] := UnitFileTags.GetTagAbbr(x);
        end;
        sl.Sorted := true;
        sl.Sort;

        // generate a 2 column view of these
        rbsCount := 0;
        for i := 0 to sl.Count - 1 do begin
            rb := TRadioButton.Create(sbJPEG);
            rb.Caption := sl.Names[i];
            rb.Hint := sl.Values[sl.names[i]];
            rb.Top := top;
            rb.Width := 175;
            rb.Visible := true;
            rb.Checked := false;
            rb.Parent := sbJPEG;
            rb.OnClick := MyRBClick;
            rb.Font.Name := 'Verdana';
            rbs[i] := rb;
            case ((i+1) mod 3) of
            0 : begin
                rb.left := 365;
                inc(top, 18);
            end;
            1 : rb.left := 16;
            2:  rb.Left := 188;
            end;
            inc(rbsCount);
        end;
        sl.free;

        //sbFile.VertScrollBar.Position := 0;
        sbJPEG.VertScrollBar.Position := 0;

        ActivateOnce := false;
    end;

    self.previewFile := '';

    if FrmMain.selectedfile.FullName = '' then begin
        if FrmMain.FirstFileIndex <> -1 then begin
            if Assigned(FrmDummyShowPreview) then
                FrmDummyShowPreview.SetSelected(FrmMain.FirstFileIndex);
        end;
    end;

    if FrmMain.selectedfile.FullName <> '' then begin
        self.previewFile := ExtractFilename(frmMain.selectedfile.FullName);
        lblFilename.Caption := ExtractFilename(self.previewFile);
        FrameCheckedFileDropdown1.setCurrent(lblFilename.caption);
        self.ShowPreview;
    end else begin

        lblFilename.Caption := '[none]';
    end;


end;
procedure TfrmMetaVariablesOld1.FormShow(Sender: TObject);
begin
    if not formatmode then EXIT;

    SetVarDisplay(FormatText);
end;

procedure TfrmMetaVariablesOld1.SetVarDisplay(variable : string);
const
    HeaderPrefixFormat = 'Format Meta-Variable';
    HeaderPrefixInsert = 'Format Meta-Variables';
begin
    if FormatMode then begin
        self.Caption := HeaderPrefixFormat + '    --    ' + variable;
        self.btnFormatInsert.Caption := 'Edit';
    end else begin
        self.Caption := HeaderPrefixInsert + '    --    ' + variable;
        self.btnFormatInsert.Caption := 'Insert';
    end;
    self.lblName.caption := variable;
    self.lblName.Hint := variable;
end;
procedure TfrmMetaVariablesOld1.NotifyOfSelect;
begin
    if (filename = '') then begin
        self.previewFile := ExtractFileName(frmMain.GetFocusedFilename);
    end else begin
        self.previewFile := filename;
    end;
    self.lblFilename.caption := self.previewFile;
    self.StatusBar1.Panels[0].Text  := 'File used for preview:    ' + self.previewFile;

    FrameCheckedFileDropdown1.setCurrent(self.previewFile);
    self.invalidate;

    if not self.Visible then EXIT;

    self.ShowPreview;
end;
procedure TfrmMetaVariablesOld1.FileSelectedCallback(filename : string);
begin
    self.previewFile := filename;
    self.NotifyOfSelect(filename);
end;

procedure TfrmMetaVariablesOld1.ShowPreview;
var s, ext : string;
    ForceJPEG, ForceMP3 : boolean;
    i : integer;
    rr : RenameRecord;
begin
    if IgnorePreviewOnce then begin
        IgnorePreviewOnce := false;
        EXIT;
    end;
    //if not FullFormView then EXIT;
    ext := extractfileext(lowercase(self.previewFile));

    ForceJPEG := false;
    ForceMP3 := false;

    case (pagecontrol1.ActivePageIndex) of
        0: begin
            s := metavar0;
            LastPageIndex := 0;
        end;
        1:begin
            s := metavar1;
            LastPageIndex := 1;
        end;
        2: begin
            s := metavar2;
            LastPageIndex := 2;
        end;
        3: begin
            s := metavar3;
            ForceMP3 := true;
            LastPageIndex := 3;
        end;
        4: begin
            LastPageIndex := 4;
            s := metavar4;
            forceJPEG := true;
            btnDisableUnused.Enabled := StringIn(ext,['.jpeg','.jpg']);

            for i := 0 to sbjpeg.ControlCount- 1 do begin
                if sbjpeg.Controls[i] is TRadioButton then begin
                    with TRadioButton(sbjpeg.Controls[i]) do begin
                        sbjpeg.controls[i].Enabled := true;
                    end;
                end;
            end;
        end;
    end;

    if FormatMode then begin
        s := FormatText;
    end else begin
        FormatText := s;
    end;
    SetVarDisplay( s );

    //
    // Only force a full MPG/JPEG search when the advanced portion of
    // the form is shown
    //
    self.preview := '';
    if (self.previewFile <> '') then begin
        s := MetaFormat(s);
        SetVarDisplay( s );

        FrmDummyShowPreview.GetRecord(
            rr,
            FrmDummyShowPreview.FindByFilename( self.previewFile)
        );
        self.preview := UnitMetaVariables.ReplaceMetaVariables(s,
                rr,
                ForceJPEG and FullFormView,
                ForceMP3 and FullFormView);
        lblPreview.Caption :=  preview;
        if (length(lblPreview.Caption) > 1) and
            (lblPreview.Caption[2] = '?') then begin
            lblPreview.Font.Style := lblPreview.Font.Style + [fsItalic];
            lblPreview.caption := '[No Data Found]';
        end else begin
            lblPreview.Font.Style := lblPreview.Font.Style - [fsItalic];
        end;
    end;
end;



procedure TfrmMetaVariablesOld1.FormatClick(Sender: TObject);
begin
    self.SetFormatPage( StrToInt(TMenuItem(sender).hint) );
    lblFormat.Caption := TMenuItem(sender).caption;
    self.ShowPreview;
end;


procedure TfrmMetaVariablesOld1.SetVariable(section: integer; metavar: string;autopreview : boolean = true);
begin

    if not FormatMode then begin
        case section of
        0: metavar0 := metavar;
        1: metavar1 := metavar;
        2: metavar2 := metavar;
        3: metavar3 := metavar;
        4: metavar4 := metavar;
        end;

        SetVarDisplay( metavar );
    end;

    if self.Visible  then begin
        self.lblFormat.Caption := 'none';
        if not FormatMode then begin
            self.SetFormatPage(0);
        end;
    end;
    if autopreview then self.ShowPreview;

end;
procedure TfrmMetaVariablesOld1.SetFormatPage(i: integer);
begin
    pcFormat.ActivePageIndex := i;

    case FormatPageName(i) of
    pnPadding:
        lblFormat.Caption := 'Add Padding';
    pnDecimal:
        lblFormat.Caption := 'Add Decimal Point';
    pnDate:
        lblFormat.Caption := 'Change Date/Time ';
    pnHex:
        lblFormat.Caption := 'Hexidecimal';
    pnSubstring:
        lblFormat.Caption := 'Substring';
    pnLetters:
        lblFormat.Caption := 'Change Numbers to Letters';
    else
        lblFormat.Caption := 'none';
    end;

    if (formatmode) then begin
        pnlTop.Height := StartingTopHeight;
        pnlRect.Height := pnlTop.Height - 8;
        pcFormat.Visible := true;
        self.ClientHeight := StartingTopHeight +  StatusBar1.Height ;
    end else begin
//        pnlSelect.Align := alnone;
//        pnlTop.Align := alnone;
        pnlTop.Top := 0;
        pnlSelect.Top := pnlTop.top+pnlTop.Height;
        pnlSelect.Height := StartingSelectHeight;

        if (not FormatMode) and (i = 0) then begin
            pnlTop.Height := 127;
            pnlRect.Height := 107;
            pcFormat.Visible := false;

            self.ClientHeight := pnlTop.height +  StartingSelectHeight + StatusBar1.Height ;
        end else begin
            pnlTop.Height := StartingTopHeight;
            pnlRect.Height := pnlTop.Height - 25;
            pcFormat.Visible := true;

            self.ClientHeight := StartingTopHeight + StartingSelectHeight  + StatusBar1.Height;
        end;
        pnlTop.Align := alTop;
        pnlSelect.Align := alclient;
    end;
end;

procedure TfrmMetaVariablesOld1.btnInsertClick(Sender: TObject);
var
    s : string;
    start, len : integer;
begin
    if not formatmode then begin
        case (pagecontrol1.ActivePageIndex) of
        0: s := metavar0;
        1: s := metavar1;
        2: s := metavar2;
        3: s := metavar3;
        4: s := metavar4;
        end;
        s := lowercase(s);
    end else begin
        s := FormatText;
    end;

    if FormatMode then begin
        start := TargetEditControl.SelStart;
        len := TargetEditControl.SelLength;
        TargetEditControl.SelText := MetaFormat(s);
        TargetEditControl.SelStart := start;
        TargetEditControl.SelLength := len;
        btnFormatClose.Click;
    end else begin
        TargetEditControl.SelText := MetaFormat(s);
    end;
end;
procedure TfrmMetaVariablesOld1.btnCancelClick(Sender: TObject);
begin
    self.Close;

    self.leftoffset := self.Left - frmmain.Left;
    self.topoffset := self.Top - frmmain.Top;

    try
        if TargetEditControl.Visible and TargetEditControl.Enabled then
            TargetEditControl.SetFocus;
    except
        // the user can change the tab which makes the target unable
        // to gain focus
    end;
end;
procedure TfrmMetaVariablesOld1.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
    if key = Ord(#27) then btnFormatClose.Click;
end;

procedure TfrmMetaVariablesOld1.MyRBClick(sender : TObject);
begin
    if sender is TRadioButton then begin
        self.SetVariable(4, '?' + TRadioButton(sender).Hint + '?');
    end;
end;



procedure TfrmMetaVariablesOld1.btnSetFormatClick(Sender: TObject);
begin
    UnitUtil.ShowPopupRight(btnSetFormat, pmFormat);
end;
procedure TfrmMetaVariablesOld1.btnShowJPEGClick(Sender: TObject);
begin
    pnlJPG.Visible := false;
end;
procedure TfrmMetaVariablesOld1.btnShowMP3Click(Sender: TObject);
begin
    pnlMP3.Visible := false;
end;



procedure TfrmMetaVariablesOld1.txtJPEGStartsChange(Sender: TObject);
var i : integer;
begin
    for i := 0 to rbsCount -1 do begin
        if  StrUtils.AnsiStartsText(lowercase(txtjpegstarts.Text),
                lowercase(rbs[i].caption)) then begin
            sbJPEG.ScrollInView(rbs[i]);
            sbjpeg.VertScrollBar.Position := rbs[i].Top +
                sbjpeg.VertScrollBar.Position;
            rbs[i].Checked := true;
            EXIT;
        end;
    end;
end;

procedure TfrmMetaVariablesOld1.btnCustomFormatClick(Sender: TObject);
begin
    self.SetFormatPage(3);
    //if not DetailsVisible then btnMore.click;
end;
procedure TfrmMetaVariablesOld1.btnDisableUnusedClick(Sender: TObject);
var i : integer;
    sl : THashedStringList;
begin


    sl := THashedStringList.Create;
    UnitFileTags.ReadJpeg(self.previewFile, sl);

    for i := 0 to sbjpeg.ControlCount- 1 do begin
        if sbjpeg.Controls[i] is TRadioButton then begin
            with TRadioButton(sbjpeg.Controls[i]) do begin
            if (hint  <> '') and (hint[1] <> '?') then begin
                sbjpeg.controls[i].Enabled := sl.Values[caption] <> '';
            end;
            end;
        end;
    end;
    sl.free;
end;
procedure TfrmMetaVariablesOld1.btnFormatExampleClick(Sender: TObject);
begin
    UnitUtil.ShowPopupRight(btnFormatExample, pmDateExamples);
end;

procedure TfrmMetaVariablesOld1.StatusBar1DrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel; const Rect: TRect);
var c1, c2 : tcolor;
begin
    c1 := brush.Color;
    c2 := font.Color;
    brush.Color := ColorToRGB(clBtnShadow);
    font.Color := ColorToRGB(clBtnText);

    StatusBar.canvas.FillRect(Rect) ;
    StatusBar.canvas.TextRect(Rect, Rect.Left + 6, Rect.Top+2, Panel.Text) ;

    brush.Color := c1;
    font.Color := c2;

end;

function TfrmMetaVariablesOld1.MetaFormat(s : string) : string;
var fm : string;
    op, units : string;
begin
    // generate the "?tag:FORMAT?" style meta-variable
    // given "?tag?"
    fm := ':';

    case FormatPageName(pcFormat.ActivePageIndex) of
    pnNone:;
    pnPadding:
        begin
            if cbPad.Text = 'Left' then begin
                fm := fm + 'L';
            end else begin
                fm := fm + 'R';
            end;
            fm := fm + txtChar.text;
            fm := fm + txtLength.text;
        end;
    pnDecimal:
        fm := fm + 'D' + txtDecimal.text;
    pnDate:
        begin
            if SafeInt(txtAlterAmount.text) <> 0  then begin
                if cbxAlter.ItemIndex = 0  then begin
                    op := 'P';
                end else begin
                    op := 'M';
                end;
                units := intToStr(cbxAlterUnits.ItemIndex);
                fm := fm + 'C' + op + units + txtAlterAmount.text + 'F' + trim(txtDateFormat.text);
            end else begin
                fm := fm + 'F' + trim(txtDateFormat.text);
            end;
        end;
    pnHex:
        fm := fm + 'H' + txtHexPad.text;
    pnSubstring:
        fm := fm + 'S' + txtSubX.text + '.' + txtSubY.text;
    pnLetters:
        begin
            if cbStartWithZero.checked then begin
                fm := fm + 'T0';
            end else begin
                fm := fm + 'T1';
            end;
        end;
    end;


    if fm <> ':' then
        insert(fm, s,  length(s));
    result := s;
end;
procedure TfrmMetaVariablesOld1.ParseFormatting(s: string);
var amount : string;
begin
    self.SetFormatPage(0);
    if (s = '') or (s = ':') then EXIT;

    s := unittoken.clipOneChar(s);
    case uppercase(s[1])[1] of
        'L': {left "L 3"} begin
           self.SetFormatPage(1);
           cbpad.ItemIndex := 0;
           try
                s := clipOneChar(s);
                txtChar.Text := s[1];
                s := clipOneChar(s);
                txtLength.Text := s;
                updown1.Position := StrToInt(s);
           except

           end;
        end;
        'R': {right} begin
           self.SetFormatPage(1);
           cbpad.ItemIndex := 1;
           try
                s := clipOneChar(s);
                txtChar.Text := s[1];
                s := clipOneChar(s);
                txtLength.Text := s;
                updown1.Position := StrToInt(s);
           except

           end;

        end;
        'D': {decimal} begin
            self.SetFormatPage(2);
            try
                s := clipOneChar(s);
                txtDecimal.text := s;
                updown2.Position := StrToInt(s);
            except

            end;
        end;
        'F': {date Format} begin
            self.SetFormatPage(3);
            try
                s := clipOneChar(s);
                txtDateFormat.text := s;
            except

            end;
        end;
        'C': {date C[P][0][xx][F]yyyy} begin
            self.SetFormatPage(3);
            try
                s := clipOneChar(s);
                if s[1] = 'P' then begin
                    cbxAlter.ItemIndex := 0;
                end else begin
                    cbxAlter.ItemIndex := 1;
                end;
                s := clipOneChar(s);
                cbxAlterUnits.ItemIndex := StrToInt(s[1]);
                s := clipOneChar(s);
                amount := UnitToken.TokenString(s,'F');
                txtAlterAmount.Text := amount;
                txtDateFormat.text := s;
            except

            end;
        end;

        'H': {hex} begin
            self.SetFormatPage(4);
            try
                s := clipOneChar(s);
                txtHexPad.text := s;
                updown3.Position := StrToInt(s);
            except

            end;
        end;
        'S': {substring} begin
            self.SetFormatPage(5);
            try
                s := clipOneChar(s);

                txtSubX.text := UnitToken.TokenString(s,'.') ;
                txtSubY.text := s;
            except

            end;
        end;
        'T': {letters} begin
            self.SetFormatPage(6);
            try
                s := clipOneChar(s);
                cbStartWithZero.checked := (s='0');
            except

            end;
        end;
    end;
end;



procedure TfrmMetaVariablesOld1.pmFormatPopup(Sender: TObject);
var isInt, isDate : boolean;
    s : string;
    i : LongWord;
begin
    for i := 0 to pmFormat.Items.count - 1 do begin
        pmformat.Items[i].Enabled := true;
    end;
    s := self.Preview;

    if (self.preview <> '') and (not ContainsTerm('?',self.Preview)) then begin

        isInt := UnitUtil.StringIsInt(self.preview);
        isDate := UnitUtil.StringIsDate(self.Preview);

        isDate := isDate or StringIn(
            lowercase(FormatText),
            ['?cds?','?cdm?','?cdl?','?ds?','?dm?','?dl?','?dmo?','?dc?',
            '?x_dt?','?x_dto?','?x_dtd?','?x_sst?','?x_ssto?','?x_sstd?']
        );

        AddDecimalPoint1.Enabled := isInt;
        Hexidecimal1.Enabled := isInt;
        ChangeNumberstoLetters1.Enabled := isInt;

        DateTimeFormatting1.Enabled := isDate;
    end;
end;


procedure TfrmMetaVariablesOld1.rbFormatDefaultClick(Sender: TObject);
begin
    self.ShowPreview;
end;

procedure TfrmMetaVariablesOld1.cbPadClick(Sender: TObject);
begin
    self.ShowPreview;
end;
procedure TfrmMetaVariablesOld1.cbStartWithZeroClick(Sender: TObject);
begin
    self.ShowPreview;
end;
procedure TfrmMetaVariablesOld1.cbxAlterChange(Sender: TObject);
begin
    self.ShowPreview;
end;
procedure TfrmMetaVariablesOld1.cbxFileChange(Sender: TObject);
var i : integer;
    wc : TControl;
begin
    pcFile.ActivePageIndex := cbxFile.ItemIndex;
    for i := 0 to pcFile.ActivePage.ControlCount - 1 do begin
        wc := pcFile.ActivePage.Controls[i];
        if (wc is TRadioButton) then begin
            if TRadioButton(wc).Checked then begin
                TRadioButton(wc).OnClick(self);
                BREAK;
            end;
        end;
    end;

    self.ShowPreview;
end;
procedure TfrmMetaVariablesOld1.cbxFormatChange(Sender: TObject);
begin
    pcFormat.ActivePageIndex := cbxFormat.ItemIndex;
    self.ShowPreview;
end;
procedure TfrmMetaVariablesOld1.cbxLayoutChange(Sender: TObject);
begin
    self.SetFilesizeMetavariable;
end;

function TfrmMetaVariablesOld1.DetailsAreVisible: boolean;
begin
    result := self.DetailsVisible;
end;

procedure TfrmMetaVariablesOld1.txtCharChange(Sender: TObject);
begin
    self.ShowPreview;
end;
procedure TfrmMetaVariablesOld1.txtCharClick(Sender: TObject);
begin
    txtChar.SelectAll;
end;
procedure TfrmMetaVariablesOld1.txtCharEnter(Sender: TObject);
begin
    txtChar.SelectAll;
end;

procedure TfrmMetaVariablesOld1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
    self.ShowPreview;
end;
procedure TfrmMetaVariablesOld1.UpDown2Click(Sender: TObject; Button: TUDBtnType);
begin
    self.ShowPreview;
end;

procedure TfrmMetaVariablesOld1.yyyymmddformat1Click(Sender: TObject);
begin
    txtDateFormat.text := TMenuItem(sender).Hint;
end;
procedure TfrmMetaVariablesOld1.txtDateFormatChange(Sender: TObject);
begin
    self.ShowPreview;
end;

procedure TfrmMetaVariablesOld1.rbFormatPadClick(Sender: TObject);
begin
    self.ShowPreview;
end;
procedure TfrmMetaVariablesOld1.rbFormatDecimalClick(Sender: TObject);
begin
    self.ShowPreview;
end;
procedure TfrmMetaVariablesOld1.rbDateFormatClick(Sender: TObject);
begin
    self.ShowPreview;
end;

procedure TfrmMetaVariablesOld1.PageControl1Change(Sender: TObject);
begin
    self.ShowPreview;
end;




//
// today's date
//
procedure TfrmMetaVariablesOld1.rbTDDateshortClick(Sender: TObject);
begin
    self.SetVariable(2, var_cur_date_short);
end;
procedure TfrmMetaVariablesOld1.rbTDDateMediumClick(Sender: TObject);
begin
    self.SetVariable(2, VAR_CUR_DATE_MEDIUM);
end;
procedure TfrmMetaVariablesOld1.rbTDDatelongClick(Sender: TObject);
begin
    self.SetVariable(2, var_cur_date_long);
end;

//
// file counting
//
procedure TfrmMetaVariablesOld1.rbFCTotalFolderClick(Sender: TObject);
begin
    self.SetVariable(0, VAR_FOLDER_COUNT);
end;
procedure TfrmMetaVariablesOld1.rbFCCurrentClick(Sender: TObject);
var i : integer;
begin
    i := SafeInt(txtzeros.text, 2);
    txtzeros.text := inttostr(i);

    if i < 10 then begin
        self.SetVariable(0, var_number_base + '0' + txtzeros.Text + VAR_NUMBER_SUFFIX);
    end else begin
        self.SetVariable(0, var_number_base + txtzeros.Text + VAR_NUMBER_SUFFIX);
    end;
end;
procedure TfrmMetaVariablesOld1.fcUpDownClick(Sender: TObject; Button: TUDBtnType);
begin
    if strtoint(txtzeros.text) < 10 then begin
        self.SetVariable(0, var_number_base + '0' + txtzeros.Text + VAR_NUMBER_SUFFIX);
    end else begin
        self.SetVariable(0, var_number_base + txtzeros.Text + VAR_NUMBER_SUFFIX);
    end;

end;

procedure TfrmMetaVariablesOld1.txtZerosChange(Sender: TObject);
begin
    try
        if strtoint(txtzeros.text) < 10 then begin
            self.SetVariable(0, var_number_base + '0' + txtzeros.Text + VAR_NUMBER_SUFFIX);
        end else begin
            self.SetVariable(0, var_number_base + txtzeros.Text + VAR_NUMBER_SUFFIX);
        end;
    finally
    end;
end;

procedure TfrmMetaVariablesOld1.rbRFTotalClick(Sender: TObject);
begin
    self.SetVariable(0, VAR_COUNT);
end;
procedure TfrmMetaVariablesOld1.rbFCTotalSelectedClick(Sender: TObject);
begin
    self.SetVariable(0, VAR_SELECTED_COUNT);
end;
procedure TfrmMetaVariablesOld1.rbFilenameOnlyClick(Sender: TObject);
begin
    self.SetVariable(1, VAR_CUR_FILENAME_NOEXT );
end;

//
// File Properties
//
procedure TfrmMetaVariablesOld1.rbFPDateshortClick(Sender: TObject);
begin
    self.SetVariable(1, VAR_DATE_SHORT);
end;
procedure TfrmMetaVariablesOld1.rbFPDatemediumClick(Sender: TObject);
begin
    self.SetVariable(1, VAR_DATE_MEDIUM);
end;
procedure TfrmMetaVariablesOld1.rbFPDatelongClick(Sender: TObject);
begin
    self.SetVariable(1, var_date_long);
end;
procedure TfrmMetaVariablesOld1.rbFPTypeClick(Sender: TObject);
begin
    self.SetVariable(1, VAR_TYPE);
end;
procedure TfrmMetaVariablesOld1.rbFileContentsClick(Sender: TObject);
var t : string;
begin
    t := 'P';
    if cbxTextEncode.ItemIndex = 1 then begin
        t := 'U';
    end;

    Self.SetVariable(
        1,
        '?FC'+t+'_'+IntToSTr(SafeInt(txtContentsA.text, 1))+
        '.'+IntToStr(SafeInt(txtContentsB.text, 2)) + '?'
    );
end;
procedure TfrmMetaVariablesOld1.rbFPDateModifiedClick(Sender: TObject);
begin
    self.SetVariable(1, VAR_DATE_MODIFIED);
end;
procedure TfrmMetaVariablesOld1.rbFPDateCreatedClick(Sender: TObject);
begin
    self.SetVariable(1, VAR_DATE_CREATED);
end;

//
// File Sizes
//
procedure TfrmMetaVariablesOld1.rbFSBytesClick(Sender: TObject);
begin
    //rbFSDecimal.Enabled := false;
    cbxLayout.ItemIndex := 0;
    self.SetFilesizeMetavariable;
end;
procedure TfrmMetaVariablesOld1.rbFSKilosClick(Sender: TObject);
begin
    cbxLayout.ItemIndex := 2;
    //rbFSDecimal.Enabled := true;
    self.SetFilesizeMetavariable;
end;
procedure TfrmMetaVariablesOld1.rbFSMegsClick(Sender: TObject);
begin
    cbxLayout.ItemIndex := 2;
    //rbFSDecimal.Enabled := true;
    self.SetFilesizeMetavariable;
end;
procedure TfrmMetaVariablesOld1.rbFSGigsClick(Sender: TObject);
begin
    //rbFSDecimal.Enabled := true;
    cbxLayout.ItemIndex := 2;
    self.SetFilesizeMetavariable;
end;


procedure TfrmMetaVariablesOld1.SetFilesizeMetavariable;
begin
    if (rbFSBytes.Checked) then begin
        case cbxlayout.ItemIndex  of
        0: self.SetVariable(1, VAR_SIZE);
        1: self.SetVariable(1, VAR_SIZE_COMMAS);
        2: self.SetVariable(1, VAR_SIZE); // no need for decimals
        end;
    end else if (rbFSKilos.Checked)  then begin
        case cbxlayout.ItemIndex  of
        0: self.SetVariable(1, VAR_SIZE_KILO );
        1: self.SetVariable(1, VAR_SIZE_KILO_COMMAS );
        2: self.SetVariable(1, VAR_SIZE_KILO_2DEC );
        end;
    end else if (rbFSMegs.Checked )  then begin
        case cbxlayout.ItemIndex  of
        0: self.SetVariable(1, VAR_SIZE_MEGS );
        1: self.SetVariable(1, VAR_SIZE_MEGS_COMMAS);
        2: self.SetVariable(1, VAR_SIZE_MEGS_2DEC );
        end;
    end else if (rbFSGigs.Checked) then begin
        case cbxlayout.ItemIndex  of
        0: self.SetVariable(1, VAR_SIZE_GIGS);
        1: self.SetVariable(1, VAR_SIZE_GIGS_COMMAS );
        2: self.SetVariable(1, VAR_SIZE_GIGS_2DEC );
        end;
    end;

{
    if (rbFSBytes.Checked) and (rbFSNone.checked) then begin
        self.SetVariable(0, VAR_SIZE);
    end else if (rbFSBytes.Checked) and (rbfscommas.Checked) then begin
        self.SetVariable(0, VAR_SIZE_COMMAS);

    end else if (rbFSKilos.Checked) and (rbfsnone.Checked) then begin
        self.SetVariable(0, VAR_SIZE_KILO );
    end else if (rbFSKilos.Checked) and (rbFSCommas.Checked) then begin
        self.SetVariable(0, VAR_SIZE_KILO_COMMAS);
    end else if (rbFSKilos.Checked) and (rbFSDecimal.Checked) then  begin
        self.SetVariable(0, VAR_SIZE_KILO_2DEC);


    end else if (rbFSMegs.Checked ) and  (rbfsnone.Checked) then begin
        self.SetVariable(0, VAR_SIZE_MEGS);
    end else if (rbFSMegs.Checked ) and (rbFSCommas.Checked) then begin
        self.SetVariable(0, VAR_SIZE_MEGS_COMMAS);
    end else if (rbFSMegs.Checked ) and (rbFSDecimal.Checked) then begin
        self.SetVariable(0, VAR_SIZE_MEGS_2DEC);


    end else if (rbFSGigs.Checked) and rbfsnone.Checked then begin
        self.SetVariable(0, VAR_SIZE_GIGS );
    end else if (rbFSGigs.Checked) and rbFSCommas.Checked then begin
        self.SetVariable(0, VAR_SIZE_GIGS_COMMAS );
    end else if (rbFSGigs.Checked) and rbFSDecimal.Checked then begin
        self.SetVariable(0, VAR_SIZE_GIGS_2DEC);
    end;
}
end;

procedure TfrmMetaVariablesOld1.rbSubstringClick(Sender: TObject);
begin
    self.ShowPreview;
end;

procedure TfrmMetaVariablesOld1.txtSubXChange(Sender: TObject);
begin
    self.ShowPreview;
end;
procedure TfrmMetaVariablesOld1.txtSubYChange(Sender: TObject);
begin
    self.ShowPreview;
end;

procedure TfrmMetaVariablesOld1.rbLettersClick(Sender: TObject);
begin
    self.ShowPreview;
end;
procedure TfrmMetaVariablesOld1.RadioButton1Click(Sender: TObject);
begin
    self.SetVariable(1, VAR_PAR_FOLDER);
end;

procedure TfrmMetaVariablesOld1.rbFSNoneClick(Sender: TObject);
begin
    self.SetFilesizeMetavariable;
end;
procedure TfrmMetaVariablesOld1.rbFSCommasClick(Sender: TObject);
begin
    self.SetFilesizeMetavariable;
end;
procedure TfrmMetaVariablesOld1.rbFSDecimalClick(Sender: TObject);
begin
    self.SetFilesizeMetavariable;
end;

procedure TfrmMetaVariablesOld1.rbFPNameClick(Sender: TObject);
begin
    self.SetVariable(1, VAR_CUR_FILENAME);
end;
procedure TfrmMetaVariablesOld1.rbFPCurFolderClick(Sender: TObject);
begin
    self.SetVariable(1, VAR_CUR_FOLDER);
end;

procedure TfrmMetaVariablesOld1.rbArtistClick(Sender: TObject);
begin
    self.SetVariable(3, '?I_Ar?');
end;
procedure TfrmMetaVariablesOld1.rbAlbumClick(Sender: TObject);
begin
    self.SetVariable(3, '?I_Al?');
end;
procedure TfrmMetaVariablesOld1.rbTitleClick(Sender: TObject);
begin
    self.SetVariable(3, '?I_Ti?');
end;
procedure TfrmMetaVariablesOld1.rbTrackClick(Sender: TObject);
begin
    self.SetVariable(3, '?I_Tr?');
end;
procedure TfrmMetaVariablesOld1.rbCommentClick(Sender: TObject);
begin
    self.SetVariable(3, '?I_C?');
end;
procedure TfrmMetaVariablesOld1.rbYearClick(Sender: TObject);
begin
    self.SetVariable(3, '?I_Y?');
end;
procedure TfrmMetaVariablesOld1.rbBitrateClick(Sender: TObject);
begin
    self.SetVariable(3, '?M_B?');
end;
procedure TfrmMetaVariablesOld1.rbSampleClick(Sender: TObject);
begin
    self.SetVariable(3, '?M_S?');
end;
procedure TfrmMetaVariablesOld1.rbChannelsClick(Sender: TObject);
begin
    self.SetVariable(3, '?M_C?');
end;
procedure TfrmMetaVariablesOld1.rbWidthClick(Sender: TObject);
begin
    self.SetVariable(4, '?J_W?');
end;
procedure TfrmMetaVariablesOld1.rbBitsClick(Sender: TObject);
begin
    self.SetVariable(4, '?J_B?');
end;
procedure TfrmMetaVariablesOld1.rbHeightClick(Sender: TObject);
begin
    self.SetVariable(4, '?J_H?');
end;


end.
