unit UnitFrmNewFolder;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TFrmNewFolder = class(TForm)
    ListBox1: TListBox;
    txtName: TEdit;
    txtFolder: TEdit;
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Button2: TButton;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
    folder : TStringList;
    ini  : string;
  public
    { Public declarations }
    function GetFolders : TStringList;
  end;

var
  FrmNewFolder: TFrmNewFolder;

implementation

uses UnitFrmSelectFolderNew, UnitFormScaling, UnitUtil;

{$R *.dfm}

procedure TFrmNewFolder.FormCreate(Sender: TObject);
begin
    folder := TStringList.Create;
    ini :=          IncludeTrailingPathDelimiter(
            ExtractFilePath(application.ExeName)
         ) + 'newfolders.ini';

    if fileexists(ini) then begin
        folder.LoadFromFile( ini );
    end;

    TFormScaling.RegisterSelf(self);
end;

procedure TFrmNewFolder.FormHide(Sender: TObject);
begin
    folder.SaveToFile( ini );
end;

procedure TFrmNewFolder.FormActivate(Sender: TObject);
begin
    listbox1.items.clear;
    ListBox1.Items.AddStrings(folder); 
end;

procedure TFrmNewFolder.Button1Click(Sender: TObject);
begin
    if txtname.text = '' then begin
        ShowMessage('ERROR: Display name must not be empty.');
        EXIT;
    end;
    if not UnitUtil.LongerDirectoryExists(txtFolder.Text) then begin
        ShowMessage('ERROR: Folder does not exist.');
        EXIT;
    end;
    folder.values[txtName.text] := ExcludeTrailingPathDelimiter(txtFolder.text);

    listbox1.Clear;
    listbox1.Items.AddStrings(folder);
end;

procedure TFrmNewFolder.ListBox1Click(Sender: TObject);
begin
    if listbox1.ItemIndex = -1 then EXIT;

    txtname.text := folder.Names[listbox1.ItemIndex];
    txtFolder.Text := folder.Values[txtname.text];
end;

function TFrmNewFolder.GetFolders: TStringList;
begin
    result := folder;
end;

procedure TFrmNewFolder.Button2Click(Sender: TObject);
var s : string;
begin
    s := frmSelectFolderNew.GetSelectedFolder;
    if s <> '' then begin
        txtFolder.text := s;
    end;
end;

procedure TFrmNewFolder.Button3Click(Sender: TObject);
begin
    if ListBox1.ItemIndex = -1 then EXIT;

    folder.Delete(listbox1.itemindex);
    ListBox1.Items.Delete(listbox1.itemindex);
end;

end.
