unit UnitFrmRenameProgress;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls;

type
  TFrmRenameProgress = class(TForm)
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    timAutoShow: TTimer;
    timHide: TTimer;
    procedure timAutoShowTimer(Sender: TObject);
    procedure timHideTimer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ReportPreview;
    procedure ReportPhaseOne;
    procedure ReportPhraseTwo;
    procedure ReportDone;

    procedure Cancel;
  end;

var
  FrmRenameProgress: TFrmRenameProgress;

implementation

{$R *.dfm}

uses UnitFrmMain;

procedure TFrmRenameProgress.ReportPreview;
begin
    shape3.Visible := false;
    shape4.Visible := false;
    shape5.Visible := false;

    PopupParent:= FrmMain;
    self.PopupMode := pmExplicit;
    timAutoShow.Enabled := true;
end;

procedure TFrmRenameProgress.timAutoShowTimer(Sender: TObject);
begin
    timAutoShow.Enabled := false;
    self.Show;
    self.Invalidate;
end;

procedure TFrmRenameProgress.timHideTimer(Sender: TObject);
begin
    timHide.Enabled := false;
    self.Hide;
end;

procedure TFrmRenameProgress.ReportPhaseOne;
begin
    shape3.Visible := true;
    Application.ProcessMessages;
end;
procedure TFrmRenameProgress.ReportPhraseTwo;
begin
    shape4.Visible := true;
    Application.ProcessMessages;
end;
procedure TFrmRenameProgress.ReportDone;
begin

    timAutoShow.Enabled := false;
    shape5.Visible := true;

    Application.ProcessMessages;
    timHide.Enabled := true;
end;

procedure TFrmRenameProgress.Cancel;
begin
    timAutoShow.Enabled := false;
    self.Hide;
end;



end.
