unit UnitFrmSelectFolderNew;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, DiskTreeView, StdCtrls, ImgList, ExtCtrls;

type
  TfrmSelectFolderNew = class(TForm)
    btnCancel: TButton;
    btnOK: TButton;

    StatusBar1: TStatusBar;
    Panel1: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure tvDiskExpanding(Sender: TObject; Node: TTreeNode;
      var AllowExpansion: Boolean);

    procedure tvDiskMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure tvDiskCollapsing(Sender: TObject; Node: TTreeNode;
      var AllowCollapse: Boolean);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    DontSelect: boolean;
    AllowTreeAction: boolean;

  public
   tvDisk: TDiskTreeView;
    { Public declarations }
    function GetSelectedFolder() : string;
    procedure SetStartingFolder(fullpath: string);
  end;

var
  frmSelectFolderNew: TfrmSelectFolderNew;


{////////////////////}
{\\}implementation{//}
{////////////////////}

{$R *.dfm}

uses types, UnitFrmConfig, StrUtils, UnitFrmMain, UnitFrmDummyShowPreview, UnitFormScaling;


//--------------------------
// Public Interface
//--------------------------
function TFrmSelectFolderNew.GetSelectedFolder() : string;
begin

    self.showModal;
    if (self.ModalResult = mrok) then begin
        result := tvDisk.GetFullPathSelected;
    end else begin
        result := '';
    end;
end;

procedure TFrmSelectFolderNew.SetStartingFolder(fullpath: string);
begin
    tvDisk.InitDiskTree(true);

    AllowTreeAction  := true;
    if leftstr(fullpath,2) <> '\\' then begin
        tvdisk.ChangeTo(fullpath);
    end;
    AllowTreeAction := false;
end;

//--------------------------
// Private Implemenation
//--------------------------
procedure TfrmSelectFolderNew.FormCreate(Sender: TObject);
begin
    tvDisk := TDiskTreeView.Create(self);
    tvDisk.Parent := Panel1;
    tvDisk.Align := alClient;
    tvDisk.Images := frmDummyShowPreview.ilFolderBrowser;
    //tvDisk.ShowRoot := false;
    //tvDisk.RowSelect := true;
    //tvdisk.ShowButtons := true;
    //tvDisk.ShowLines := false;
    //tvDisk.HotTrack := true;
    //tvDisk.InitDiskTree(true);

    TFormScaling.RegisterSelf(self);
end;

procedure TfrmSelectFolderNew.FormShow(Sender: TObject);
begin
    //
    // this is good for scrolling with the wheelmouse
    //
    //tvDisk.InitDiskTree(true);
    tvdisk.SetFocus;

end;



//---------------------------------------------------------------
// Controlled 1-click expand collapse on name and +/- buttons
//---------------------------------------------------------------

//
// using expand/collapse selects that node
//
procedure TfrmSelectFolderNew.tvDiskExpanding(Sender: TObject;
  Node: TTreeNode; var AllowExpansion: Boolean);
begin
    AllowExpansion := AllowTreeAction;
    if not DontSelect then tvdisk.Selected := node;
end;
procedure TfrmSelectFolderNew.tvDiskCollapsing(Sender: TObject;
  Node: TTreeNode; var AllowCollapse: Boolean);
begin
    AllowCollapse := AllowTreeAction;
    if not DontSelect then tvdisk.Selected := node;
end;


//
// Only allow an expand/collapse here
// Expanding/Collapsing buttons only select the current node
// Selecting a folder automatically selects that node
//
procedure TfrmSelectFolderNew.tvDiskMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    if button = mbRight then exit;

    AllowTreeAction := true;

    if (tvdisk.Selected <> nil) then begin
        if (tvdisk.Selected.Expanded) then begin
            tvdisk.Selected.Collapse(false);
        end else begin
            tvdisk.Selected.Expand(false);
        end;
    end;

    AllowTreeAction := false;
end;

procedure TfrmSelectFolderNew.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if key = VK_ESCAPE then self.btnCancel.click;
end;

end.


