unit UnitFrmThumbPreview;
{
    Purpose - a floating, scalable, thumbnail window (always on top)
    notes:

    Updates
        - ability to select previous/next file on thumbnail
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, ImgList, Buttons, OleCtrls, SHDocVw_tlb{,
  WEBVWLib_TLB};

type
  TFrmThumbPreview = class(TForm)
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    Image1: TImage;
    Label1: TLabel;
    Timer1: TTimer;
    Panel2: TPanel;
    Memo1: TMemo;
    Panel3: TPanel;
    btnTop: TSpeedButton;
    btnUp: TSpeedButton;
    btnDown: TSpeedButton;
    btnBottom: TSpeedButton;
    WebBrowser1: TWebBrowser;
    procedure FormCreate(Sender: TObject);
    procedure btnUpClick(Sender: TObject);
    procedure btnDownClick(Sender: TObject);
    procedure tcThumbThumbnailReady(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnTopClick(Sender: TObject);
    procedure btnBottomClick(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure WebBrowser1BeforeNavigate2(ASender: TObject;
      const pDisp: IDispatch; const URL, Flags, TargetFrameName, PostData,
      Headers: OleVariant; var Cancel: WordBool);
  private
    { Private declarations }
    lastfile : string;
  public
    { Public declarations }
    procedure InformOfFileClick(filename : string);
  end;

var
  FrmThumbPreview: TFrmThumbPreview;

implementation

uses JPeg, UnitFrmMain, UnitFileTags, inifiles, math, UnitFrmDummyPreview,
  UnitFrmDummyShowPreview, UnitUtil,  ActiveX, ShellApi, UnitFrmFiletags,
  UnitVideo, StrUtils, MSHTML, UnitFormScaling;

{$R *.dfm}


{ TFrmPreview }

procedure TFrmThumbPreview.InformOfFileClick(filename: string);
var tags : THashedStringList;


	procedure LoadCode;
    var
		sl: TStringList;
    	ms: TMemoryStream;
        fn, code, data, shortname : string;
        rec : TSearchRec;
        filefound : boolean;
        systemtime : Windows.TSystemTime;
        w1,w2 : word;
        filedate : integer;
        datestr : integer;
        datecreated,datemodified : string;

        temps, fileurl, filesrc : string;
        i: Integer;
        x : word;
        c : char;
	begin
        for i := 1 to length(filename) do begin
            x := ord(filename[i]);
            temps := temps + '&#'+IntToStr(x)+';'
        end;



		WebBrowser1.Navigate('about:blank') ;

    	while WebBrowser1.ReadyState < READYSTATE_INTERACTIVE do
     		Application.ProcessMessages;
        if not Assigned(WebBrowser1.Document) then EXIT;


        filefound := FindFirst(filename, faAnyFile,rec)=0;
        if filefound then begin
        	FileTimeToSystemTime(rec.FindData.ftCreationTime, systemtime);
    		SystemTimeToTzSpecificLocalTime(nil, systemtime, systemtime);
    		SystemTimeToFileTime(systemtime, rec.FindData.ftCreationTime);
    		FileTimeToDOSDateTime(rec.FindData.ftCreationTime, w1, w2);
    		filedate := MakeLong(w2,w1);
            datecreated := FormatDateTime('c', FileDateToDateTime(filedate));

             FileTimeToSystemTime(rec.FindData.ftLastWriteTime, systemtime);
    		SystemTimeToTzSpecificLocalTime(nil, systemtime, systemtime);
    		SystemTimeToFileTime(systemtime, rec.FindData.ftLastWriteTime);
    		FileTimeToDOSDateTime(rec.FindData.ftLastWriteTime, w1, w2);
    		filedate := MakeLong(w2,w1);
            datemodified := FormatDateTime('c', FileDateToDateTime(filedate));
        end;

        fileurl := '/myfile/' + temps;
        filesrc := 'file://' + temps;
      	sl := TStringList.Create;
      	try
        	ms := TMemoryStream.Create;
        	try
            	fn := lowercase(ExtractFileExt(filename));

            	shortname := ExtractFilename(filename);
            	shortname := leftstr(shortname, length(shortname)- length(fn));
                if length(shortname)>20 then begin
                	shortname := leftstr(shortname,20) + '...';
                end;
                shortname := shortname + fn;

                code :=  '<html><head></head><body><font face="lucida console" style="font-size: 12px">' +
                '<table width="100%" CELLSPACING="0"><tr><td width="75%" valign="top">'+
                '<a href="' + fileurl + '" style="font-size: 14px">open ['+ExtractFileName(shortname) +']</a></td>';
                if StringIn(fn,['.jpeg','.jpg','.mp3','.avi','.mpg','.mpg',
                   '.mov','.mp4','.m4v','.asf','.wmv']) then begin
                   code := code + '<td valign="top" align="right" width="25%">'+
                   '<a href="/mytags/'+temps+'" style="font-size: 14px">View Tags</a></td>';
                end;
                code := code + '</tr></table>'#13#10;

                if (filefound) then begin
                    code := code + 'date created: '+datecreated+'<br/>'#13#10 +
                    	'date modifed: '+datemodified+'<br/>'#13#10 +
                        'size: ' + FormatFloat('#,##0',GetSizeOf(filename))+'<br/>'#13#10+
                        '</font><hr size="1" width="100%">';
                end;

              	if StringIn(fn,['.jpeg','.jpg','.bmp','.png','.gif','.tif','.tiff','.ico']) then begin
                    code := code + '<div style="text-align: center" width="100%">'+
                    '<div style="max-width: 80%; min-width: 30%; display: block"><img src="' + filesrc+
                    '" width="80%"  /></div></div>';
              	end else if (StringIn(fn, ['.txt','.ini'])) then begin
                    sl.LoadFromFile(filename);
                    data := sl.Text;
                    data := StringReplace(data,#13#10,#13#10'<br/>',[rfReplaceAll]);
                    sl.text := '';
                    code := code + data;
                end else if (fn = '.pdf') then begin
                	code := code +'<object data="'+filesrc+'" type="application/pdf"  width="100%" height="320" >'+
                    '<param name="src" value="'+filesrc+'"/>'+
                    '</object>';
              	end else if UnitVideo.FileSupported(filename) then begin
                	code := code +
                    '<div style="text-align: center" width="100%">' +
                    '<OBJECT id="VIDEO" CLASSID="clsid:6BF52A52-394A-11D3-B153-00C04F79FAA6" type="application/x-oleobject" width="320" height="240">' +
                    '    <PARAM NAME="URL" VALUE="'+filesrc+'">' +
                    '<PARAM NAME="SendPlayStateChangeEvents" VALUE="True">'+
                    '   <PARAM NAME="enabled" VALUE="True">' +
                    '   <PARAM NAME="AutoStart" VALUE="false">' +
                    '   <PARAM name="PlayCount" value="1">' +
                    '   <PARAM NAME="Mute" VALUE="true">' +
                    '   <PARAM name="uiMode" value="full">' +
                    '</OBJECT></div>';

                end;

                code := code + '</body></html>';

              	sl.Text := code;
              	sl.SaveToStream(ms) ;
              	ms.Seek(0, 0) ;

              	(WebBrowser1.Document as IPersistStreamInit).Load(TStreamAdapter.Create(ms));


            finally
          		ms.Free;
        	end;
      	finally
        	sl.Free;
      	end;
    end;
var ext : string;
	rec : TSearchRec;
begin
    if not self.Visible then EXIT;
    //if filename = self.lastfile then EXIT;


    // event may be triggered multiple times for the same file
    //

	LoadCode;
    memo1.Lines.Clear;
    label1.Visible := true;
    image1.Visible := false;
    try
        self.Caption := 'Thumbnail Preview - ' + ExtractFileName(filename);
        label1.visible := false;
        image1.Visible := true;

        if ContainsTerm(lowercase(ExtractFileExt(filename)), '.mp3') then begin
            tags := THashedStringList.Create;
            ReadMP3(filename, tags);
            memo1.Lines.AddStrings(tags);
            tags.Free;
        end;

        //Image1.Picture.LoadFromFile(filename);

        if StringIn(lowercase(ExtractFileExt(filename)), ['.jpeg','.jpg']) then begin
            tags := THashedStringList.Create;
            readjpeg(filename, tags);
            memo1.Lines.AddStrings(tags);
            tags.Free;
        end;


        lastfile := filename;
    except on e : exception do begin
        label1.Visible := true;
        image1.Visible := false;
        image1.Picture.Bitmap.FreeImage;
        label1.caption := e.Message;
        lastfile := '';
    end;
    end;
end;


procedure TFrmThumbPreview.WebBrowser1BeforeNavigate2(ASender: TObject;
  const pDisp: IDispatch; const URL, Flags, TargetFrameName, PostData,
  Headers: OleVariant; var Cancel: WordBool);
var newurl : string;
begin
	cancel := false;
	if ContainsTerm('/myfile',url) then begin
        newurl := StringReplace(url,'about:/myfile/','',[]);
        cancel := true;
        ShellExecute(Application.Handle, 'open', PChar(newURL), nil, nil, SW_NORMAL);
    end;
    if ContainsTerm('/myfirst',url) then begin
    	cancel := true;
        btnTop.Click;
    end;
    if ContainsTerm('/myprev',url) then begin
    	cancel := true;
        btnUp.Click;
    end;

    if ContainsTerm('/mynext',url) then begin
    	cancel := true;
        btnDown.Click;
    end;

    if ContainsTerm('/mylast',url) then begin
    	cancel := true;
        btnBottom.Click;
    end;

    if containsTerm('/mytags',url) then begin
    	newurl := StringReplace(url,'about:/mytags/','',[]);
        cancel := true;
        FrmFileTags.Left := self.Left+self.Width;
        FrmFileTags.ShowTags(newurl,self.Left+self.Width);
    end;
end;

procedure TFrmThumbPreview.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    timer1.enabled := false;
    WebBrowser1.Navigate('about:blank'); 
end;
procedure TFrmThumbPreview.FormCreate(Sender: TObject);
begin
    // always on top
     Windows.SetWindowPos(self.Handle, HWND_TOPMOST, 0, 0, 0, 0,
        (SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOOWNERZORDER or
                         SWP_NOZORDER Or SWP_FRAMECHANGED ) and not SWP_NOZORDER);
     TFormScaling.RegisterSelf(self);
end;

procedure TFrmThumbPreview.btnUpClick(Sender: TObject);
var li, li2 : TListItem;
	idx1, idx2 : integer;
    i : integer;
begin
    if frmmain.ActiveControl <> frmmain.lvFileList then begin
        frmmain.lvFileList.SetFocus;
    end;
    li :=  GetFileList.selected;
    if (li = nil) then begin
        self.btnTop.Click;
    end;
    if li <> nil then begin
        if (li.Index = 0) then begin
        	idx1 := GetFileList.Items.Count-1;
        end else begin
        	idx1 := li.Index;
            dec(idx1);
        end;

        FrmDummyShowPreview.ClearAllSelected(True);
        FrmDummyShowPreview.SetSelected(idx1);
        GetFileList.Selected.MakeVisible(true);
    end;
end;
procedure TFrmThumbPreview.btnTopClick(Sender: TObject);
var li : TListItem;
    i, found : integer;
begin
    FrmDummyShowPreview.ClearAllSelected;

    li  := GetFileList.items[GetFileList.Items.count-1];
    if not FrmDummyShowPreview.IsFolder(li) then begin
        for i := 0 to GetFileList.Items.count - 2 do begin
            li  := GetFileList.items[i];
            if not FrmDummyShowPreview.IsFolder(li) then begin
                BREAK;
                found := i;
            end;
        end;
    end;


    FrmDummyShowPreview.SetSelected(i);
	GetFileList.Selected.MakeVisible(false);
    //GetFileList.Selected := li;
    //GetFileList.ItemFocused := li;
end;
procedure TFrmThumbPreview.btnDownClick(Sender: TObject);
var li, li2 : TListItem;
    i, idx1 : integer;
begin
    if frmmain.ActiveControl <> frmmain.lvFileList then begin
        frmmain.lvFileList.SetFocus;
    end;

    li :=  GetFileList.selected;
    if (li = nil) then begin
        self.btnTop.Click;
    end;

    if li <> nil then begin
        if li.Index = GetFileList.Items.Count-1 then begin
        	idx1 := 0;
        end else begin
        	idx1 := li.Index;
            inc(idx1);
        end;

        FrmDummyShowPreview.ClearAllSelected(True);
        FrmDummyShowPreview.SetSelected(idx1);
        GetFileList.Selected.MakeVisible(true);
    end;
end;
procedure TFrmThumbPreview.btnBottomClick(Sender: TObject);
var li : TListItem;
begin
    GetFileList.ClearSelection;

    li  := GetFileList.items[GetFileList.Items.count-1];

    FrmDummyShowPreview.ClearAllSelected;    
    FrmDummyShowPreview.SetSelected(GetFileList.Items.count-1);

    getfilelist.Selected.MakeVisible(false);

    //GetFileList.ItemFocused := li;
    //GetFileList.Selected := li;

//li.MakeVisible(false);
end;



procedure TFrmThumbPreview.tcThumbThumbnailReady(Sender: TObject);
begin
    showmessage('test ready');
end;

procedure TFrmThumbPreview.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if key = VK_ESCAPE then self.Hide;
    if key = VK_UP then self.btnUp.Click;
    if key = VK_DOWN then self.btnDown.Click;
end;
procedure TFrmThumbPreview.FormShow(Sender: TObject);
begin
    timer1.Enabled := false;
end;

//
// restores the form for keystroke monitoring
//
procedure TFrmThumbPreview.FormDeactivate(Sender: TObject);
begin
   //timer1.Enabled := true;
end;
procedure TFrmThumbPreview.Timer1Timer(Sender: TObject);
begin

    //Timer1.Enabled := false;
    //if self.Visible then self.SetFocus;
end;



const
  SET_FEATURE_ON_PROCESS = $00000002;
  FEATURE_ZONE_ELEVATION                   = 1;
  FEATURE_DISABLE_NAVIGATION_SOUNDS = 21;

function CoInternetSetFeatureEnabled(FeatureEntry: DWORD; dwFlags: DWORD; fEnable: BOOL): HRESULT; stdcall; external 'urlmon.dll';

initialization
begin
  CoInternetSetFeatureEnabled(FEATURE_DISABLE_NAVIGATION_SOUNDS, SET_FEATURE_ON_PROCESS, True);
  //CoInternetSetFeatureEnabled(FEATURE_ZONE_ELEVATION, SET_FEATURE_ON_PROCESS, True);
end;

end.
