unit UnitFrmWizardRenamingOptions;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, ComCtrls, ExtCtrls, StdCtrls, UnitWildcards;

type
  TFrmWizardRenamingOptions = class(TForm)
    Image1: TImage;
    Panel1: TPanel;
    pcPanels: TPageControl;
    TabSheet1: TTabSheet;
    Panel2: TPanel;
    btnBack: TSpeedButton;
    btnNext: TSpeedButton;
    btnCancel: TSpeedButton;
    TabSheet2: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    RichEdit2: TRichEdit;
    TabSheet4: TTabSheet;
    Label5: TLabel;
    RichEdit3: TRichEdit;
    RichEdit4: TRichEdit;
    cbClear: TCheckBox;
    btnFinish: TSpeedButton;
    rbAdd: TRadioButton;
    rbReplace: TRadioButton;
    rbRemove: TRadioButton;
    TabSheet3: TTabSheet;
    Label3: TLabel;
    pcOptions: TPageControl;
    tsRemove: TTabSheet;
    tsReplace: TTabSheet;
    tsAdd: TTabSheet;
    rbBeginnig: TRadioButton;
    Label4: TLabel;
    cbxAddPart: TComboBox;
    rbEnding: TRadioButton;
    txtAdd: TEdit;
    Label8: TLabel;
    txtExampleName: TEdit;
    Label9: TLabel;
    rbAddPosition: TRadioButton;
    txtAddPosition: TEdit;
    tbPosition: TTrackBar;
    cbxAddPlace: TComboBox;
    rbAddAfter: TRadioButton;
    txtAfter: TEdit;
    cbReplacePart: TComboBox;
    lblReplace1: TLabel;
    txtReplacePhrase: TEdit;
    rbReplaceText: TRadioButton;
    txtReplaceWith: TEdit;
    rbReplaceChar: TRadioButton;
    txtReplaceChar1: TEdit;
    txtReplaceChar2: TEdit;
    Label11: TLabel;
    pnlReplaceOnly: TPanel;
    cbReplaceOnly: TCheckBox;
    txtRP2X: TEdit;
    upRP2X: TUpDown;
    Label7: TLabel;
    txtRP2Y: TEdit;
    upRP2Y: TUpDown;
    rbRemoveWord: TRadioButton;
    cbRemovePhrase: TComboBox;
    Label12: TLabel;
    cbRemovePhrasePart: TComboBox;
    txtRemovePhrase: TEdit;
    rbRemoveChars: TRadioButton;
    Panel22: TPanel;
    txtR2X: TEdit;
    udNS: TUpDown;
    Label13: TLabel;
    cbRemoveCharactersPart: TComboBox;
    Label14: TLabel;
    cbRemoveCharPosition: TComboBox;
    rbRemoveChars2: TRadioButton;
    cbRemoveType: TComboBox;
    Panel3: TPanel;
    txtR3X: TEdit;
    UpDown1: TUpDown;
    Panel4: TPanel;
    txtR3Y: TEdit;
    UpDown2: TUpDown;
    Label15: TLabel;
    Label16: TLabel;
    cbAndMove: TCheckBox;
    pnlRemove3: TPanel;
    txtR3Z: TEdit;
    UpDown3: TUpDown;
    btnFinish2: TButton;
    Button2: TButton;
    RichEdit1: TRichEdit;
    rbAddCollision: TRadioButton;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnBackClick(Sender: TObject);
    procedure btnNextClick(Sender: TObject);
    procedure rbAddClick(Sender: TObject);
    procedure rbReplaceClick(Sender: TObject);
    procedure rbRemoveClick(Sender: TObject);
    procedure tbPositionChange(Sender: TObject);
    procedure cbxAddPlaceSelect(Sender: TObject);
    procedure cbxAddPlaceCloseUp(Sender: TObject);
    procedure rbBeginnigClick(Sender: TObject);
    procedure rbEndingClick(Sender: TObject);
    procedure rbAddPositionClick(Sender: TObject);
    procedure rbAddAfterClick(Sender: TObject);
    procedure cbxAddPlaceClick(Sender: TObject);
    procedure txtAddChange(Sender: TObject);
    procedure txtAfterChange(Sender: TObject);
    procedure RemoveControlChange(Sender: TObject);
    procedure TabSheet3Show(Sender: TObject);
    procedure cbReplacePartChange(Sender: TObject);
    procedure ReplaceControlChange(Sender: TObject);
    procedure ReplaceControlClick(Sender: TObject);
    procedure tsReplaceShow(Sender: TObject);
    procedure cbxAddPartChange(Sender: TObject);
    procedure cbRemoveTypeChange(Sender: TObject);
    procedure tsRemoveShow(Sender: TObject);
    procedure rbRemoveWordClick(Sender: TObject);
    procedure btnFinish2Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnFinishClick(Sender: TObject);
  private
    { Private declarations }
    example : string;
    wc : TWildCards;
    procedure CheckButtonStates;
    procedure UpdateAddExampleName;
    procedure UpdateReplaceExampleName;
    procedure UpdateRemoveExampleName;
    procedure AddOption;
  public
    { Public declarations }
    procedure ForceAddToOnce;
    procedure ForceReplaceOnce;
    procedure ForceRemove;
    function GetOperationSentence(fp : TFlowPanel) : string;
  end;

var
  FrmWizardRenamingOptions: TFrmWizardRenamingOptions;

implementation


uses UnitFrmMain, UnitColumnManager, UnitUtil, StrUtils, UnitToken;

{$R *.dfm}

type ForceScreenType =
(fsNone, fsAddTo, fsReplace, fsRemove);

var ForceScreen : ForceScreenType = fsNone;


function TFrmWizardRenamingOptions.GetOperationSentence(fp : TFlowPanel): string;
    procedure Append(s : string); overload;
    var l : TLabel;
    begin
        l := Tlabel.Create(fp);
        l.parent := fp;
        l.caption := ' ' + s;

        result := result + s ;
    end;
    procedure Append(t : TEdit); overload;
    var t2 : TEdit;
    begin
        t2 := Tedit.Create(fp);
        t2.Parent := fp;
        t2.AutoSize := true;
        t2.Text := t.text;


        result := result + '{' + t.Text + '} ';
    end;
    procedure Append(cbx : TComboBox); overload;
    var l : TLabel;
    begin
        l := Tlabel.Create(fp);
        l.parent := fp;
        l.caption := cbx.text;
        l.Font.Style := l.font.style+ [fsUnderline];
        result := result + '[' + cbx.Text + '] ';
    end;
    procedure Append(rb : TRadioButton); overload;
    var l : TLabel;
    begin
        l := Tlabel.Create(fp);
        l.parent := fp;
        l.caption := ' ' + rb.caption + ' ';

        result := result + rb.caption + ' ';
    end;
    procedure Append(cb : TCheckbox); overload;
    var l : TLabel;
    begin
        l := Tlabel.Create(fp);
        l.parent := fp;
        l.caption := ' ' + cb.caption + ' ';

        result := result + cb.caption + ' ';
    end;
var i : integer;
begin
    result := '';
    // clear previous items
    for i := fp.ControlCount - 1 downto 0 do begin
        fp.Controls[i].Free;
    end;

    case pcOptions.ActivePageIndex  of
    0: // REMOVE
        begin

            if rbRemoveWord.checked then begin
                Append(rbRemoveWord);
                Append(cbRemovePhrase);
                Append(txtRemovePhrase);

                Append('from the ');
                Append(cbRemovePhrasePart);
                case cbRemovePhrasePart.ItemIndex  of
                0: // name
                    begin

                    end;
                1: // Extension
                    begin

                    end;
                end;
            end else if rbRemoveChars.checked then begin
                Append(rbRemoveChars);
                Append(txtr2x);
                Append('characters from the ');
                Append(cbRemoveCharPosition);
                Append('of the ');
                Append(cbRemoveCharactersPart);

            end else if rbRemoveChars2.checked then begin
                Append(rbRemoveChars2);
                Append(cbRemoveType);
                Append('characters ');
                        Append(txtR3X);
                        APpend('thru ');
                        Append(txtr3y);

                if cbAndMove.Checked then begin
                    Append(cbAndMove);
                        Append(txtr3z);
                end;
            end;
        end;
    1: // REPLACE
        begin

            if rbreplacetext.Checked  then begin
                Append(rbReplaceText);
                Append(cbReplacePart);
                case cbReplacePart.ItemIndex  of
                0: // Entire Name
                    begin
                        Append('with ');
                        Append(txtReplaceWith);
                    end;
                1: // Entire Extension
                    begin
                        Append('with ');
                        Append(txtReplaceWith);
                    end;
                2: // Phrase;
                    begin
                        Append(txtReplacePhrase);
                        Append('with ');
                        Append(txtReplaceWith);
                        if cbReplaceOnly.Checked  then begin
                            Append(cbReplaceOnly);
                            Append(txtRP2x);
                            APpend('thru ');
                            Append(txtrp2y);
                        end else begin
                        end;
                    end;
                end;
            end else begin
                Append(rbReplaceChar);
                Append(txtReplaceChar1);
                Append('with the characters in the list ');
                Append(txtReplaceChar2);
            end;
        end;
    2: // ADD
        begin

            Append('Add ');
            Append(txtAdd);
            Append('to the ');
            Append(cbxAddPart);

            if rbBeginnig.Checked  then begin
                Append(rbBeginnig);
            end else if rbEnding.checked then begin
                Append(rbEnding);
            end else if rbAddPosition.checked then begin
                Append(rbAddPosition);
                Append(txtAddPosition);
            end else if rbAddAfter.checked then begin
                Append(rbAddAfter);
                Append(cbxAddPlace);
                Append(txtAfter);
            end else if rbAddCollision.Checked  then begin
                Append(rbAddCollision);
            end;
        end;
    end;

end;

procedure TFrmWizardRenamingOptions.AddOption;
begin
    if cbclear.checked then frmmain.btnClearOptions.Click;


    case pcOptions.ActivePageIndex  of
    0: // REMOVE
        begin
            frmmain.pcTemplate.ActivePageIndex := 2;

            if rbRemoveWord.checked then begin
                case cbRemovePhrase.ItemIndex  of
                0: FrmMain.cbRMWordList.Checked := false;
                1: FrmMain.cbRMWordList.Checked := true;
                end;

                case cbRemovePhrasePart.ItemIndex  of
                0: // name
                    begin
                        frmmain.cbRMFromName.Checked := true;
                        frmmain.txtRMFromName.Text := txtRemovePhrase.text
                    end;
                1: // Extension
                    begin
                        frmmain.cbRMFromExtension.Checked := true;
                        frmmain.txtRMFromExtension.Text := txtRemovePhrase.text
                    end;
                end;
            end else if rbRemoveChars.checked then begin
                case cbRemoveCharPosition.ItemIndex  of
                0: // Beginning
                    begin
                        case cbRemoveCharactersPart.ItemIndex of
                        0: // Name
                            begin
                                frmmain.cbRMFromNameStart.Checked := true;
                                frmmain.txtRMFromNameStart.text := txtr2x.text;
                            end;
                        1: // Extension
                            begin
                                frmmain.cbRMFromExtensionStart.checked := true;
                                frmmain.txtRMFromExtensionStart.text := txtr2x.text;
                            end;
                        end;
                    end;
                1: // Ending
                    begin
                        case cbRemoveCharactersPart.ItemIndex of
                        0: // Name
                            begin
                                frmmain.cbRMFromNameEnd.Checked := true;
                                frmmain.txtRMFromNameEnd.text := txtr2x.text;
                            end;
                        1: // Extension
                            begin
                                frmmain.cbRMFromExtensionEnd.checked := true;
                                frmmain.txtRMFromExtensionEnd.text := txtr2x.text;
                            end;
                        end;
                    end;
                end;
            end else if rbRemoveChars2.checked then begin
                case cbRemoveType.ItemIndex  of
                0: // everything but
                    begin
                        frmmain.cbEverything.Checked := true;
                        frmmain.txtR2EverythingX.Text := txtR3X.Text;
                        frmmain.txtR2EverythingY.text := txtr3y.text;
                    end;

                1:
                    begin
                        frmmain.cbRM2Characters.Checked := true;
                        frmmain.txtR2CharactersX.Text := txtR3X.Text;
                        frmmain.txtR2CharactersY.text := txtr3y.text;
                        frmmain.cbRM2AndMove.Checked := cbAndMove.Checked;
                        frmmain.txtR2AndMove.text := txtr3z.text;

                    end;
                end;
            end;
        end;
    1: // REPLACE
        begin
            frmmain.pcTemplate.ActivePageIndex := 1;
            if rbreplacetext.Checked  then begin
                case cbReplacePart.ItemIndex  of
                0: // Entire Name
                    begin
                        frmmain.cbRPNameWith.Checked := true;
                        frmmain.txtRPNameWith.Text := txtReplaceWith.text;
                    end;
                1: // Entire Extension
                    begin
                        frmmain.cbRPExtensionWith.Checked := true;
                        frmmain.txtRPExtensionWith.Text := txtReplaceWith.text;
                    end;
                2: // Phrase;
                    begin
                        if cbReplaceOnly.Checked  then begin
                            frmmain.cbRP2Characters.checked := true;
                            frmmain.txtRP2X.text := txtRP2x.text;
                            frmmain.txtrp2y.Text := txtrp2y.text;
                            frmmain.txtRP2This.text := txtReplacePhrase.text;
                            frmmain.txtRP2With.text := txtReplaceWith.text;
                        end else begin
                            frmmain.cbRPThis.Checked := true;
                            frmmain.txtRPThis.text := txtReplacePhrase.text;
                            frmmain.txtRPWith.text := txtReplaceWith.text;
                        end;
                    end;
               end;
           end else begin
               frmmain.cbRP2CharacterList.checked := true;
               frmmain.txtrp2sc.text := txtReplaceChar1.text;
               frmmain.txtrp2scWith.text := txtReplaceChar2.text;
           end;
        end;
    2: // ADD
        begin
            frmmain.pcTemplate.ActivePageIndex := 0;
            case cbxAddPart.ItemIndex  of
            0: // Name
                begin
                    if rbBeginnig.Checked  then begin
                        frmmain.cbAnInsert.Checked := true;
                        frmmain.udNS.Position := 1;
                        frmmain.txtANInsert.Text := txtAdd.text;
                    end else if rbEnding.checked then begin
                        frmmain.cbAEndOfName.Checked := true;
                        frmmain.txtAEndOfName.text := txtAdd.text;
                    end else if rbAddPosition.checked then begin
                        frmmain.cbAnInsert.Checked := true;
                        frmmain.udNS.Position := SafeInt(txtAddPosition.text,1);
                        frmmain.txtANPosition.text := txtAddPosition.text;
                        frmmain.txtANInsert.Text := txtAdd.text;
                    end else if rbAddAfter.checked then begin
                        frmmain.cbA2Find.checked := true;
                        frmmain.cbA2Insert.itemindex := cbxAddPlace.ItemIndex;
                        frmmain.txtA2Find.Text := txtAfter.text;
                        frmmain.txtA2Insert.Text := txtadd.text;
                    end else if rbAddCollision.Checked  then begin
                        frmmain.cbCollision.checked := true;
                        frmmain.txtCollision.Text := txtAdd.text;
                    end;
                end;
            1: // Extension
                begin
                    if rbBeginnig.Checked  then begin
                        frmmain.cbaeInsert.Checked := true;
                        frmmain.udeS.Position := 1;
                        frmmain.txtAeInsert.Text := txtAdd.text;
                    end else if rbEnding.checked then begin
                        frmmain.cbAEndOfExtension.Checked := true;
                        frmmain.txtAEndOfExtension.text := txtAdd.text;
                    end else if rbAddPosition.checked then begin
                        frmmain.cbAEInsert.Checked := true;
                        frmmain.udES.Position := SafeInt(txtAddPosition.text,1);
                        frmmain.txtAEPosition.text := txtAddPosition.text;
                        frmmain.txtAEInsert.Text := txtAdd.text;
                    end;
                end;
            end;
        end;
    end;

end;

procedure TFrmWizardRenamingOptions.btnBackClick(Sender: TObject);
begin
    pcPanels.ActivePageIndex :=     pcPanels.ActivePageIndex - 1;
    self.CheckButtonStates;
end;

procedure TFrmWizardRenamingOptions.btnCancelClick(Sender: TObject);
begin
    self.Close;
    self.ModalResult := mrCancel;
end;

procedure TFrmWizardRenamingOptions.btnNextClick(Sender: TObject);
begin
    pcPanels.ActivePageIndex :=     pcPanels.ActivePageIndex + 1;

    self.CheckButtonStates;
end;

procedure TFrmWizardRenamingOptions.btnFinish2Click(Sender: TObject);
begin
    self.AddOption;
    cbClear.Checked := false;
    self.Close;
end;

procedure TFrmWizardRenamingOptions.btnFinishClick(Sender: TObject);
begin
   self.Close;
   self.ModalResult := mrOk;
end;

procedure TFrmWizardRenamingOptions.Button2Click(Sender: TObject);
begin
    if cbclear.checked then frmmain.btnClearOptions.Click;

    self.AddOption;
    cbClear.Checked := false;

    pcPanels.ActivePageIndex := 1;
    self.CheckButtonStates;
end;

procedure TFrmWizardRenamingOptions.CheckButtonStates;
begin
    btnFinish.Enabled := false;
    btnBack.Enabled := true;
    btnNext.Enabled := true;
    if pcPanels.ActivePageIndex = 0 then begin
        btnBack.Enabled := false;
    end;
    if pcpanels.ActivePageIndex = pcpanels.PageCount - 1 then begin
        btnNext.Enabled := false;
        btnFinish.Enabled := true;
    end;
end;

procedure TFrmWizardRenamingOptions.cbRemoveTypeChange(Sender: TObject);

begin

    cbAndMove.Visible := false;
    pnlRemove3.Visible := false;
    txtr3z.Visible := false;
    UpDown3.Visible := false;

    if cbRemoveType.ItemIndex = 1 then begin
        cbAndMove.Visible := true;
        pnlRemove3.visible := true;
        txtr3z.Visible := true;
        UpDown3.Visible := true;
    end;
    self.UpdateRemoveExampleName;


end;

procedure TFrmWizardRenamingOptions.RemoveControlChange(Sender: TObject);
begin
    self.UpdateRemoveExampleName;
end;

procedure TFrmWizardRenamingOptions.cbxAddPartChange(Sender: TObject);
begin
    self.UpdateAddExampleName;
end;

procedure TFrmWizardRenamingOptions.cbxAddPlaceClick(Sender: TObject);
begin
    rbAddAfter.Checked := false;
    rbAddAfter.checked := true;
end;

procedure TFrmWizardRenamingOptions.cbxAddPlaceCloseUp(Sender: TObject);
begin
    rbAddAfter.Checked := false;
    rbAddAfter.checked := true;
end;

procedure TFrmWizardRenamingOptions.cbxAddPlaceSelect(Sender: TObject);
begin
    rbAddAfter.Checked := false;
    rbAddAfter.Checked := true;
end;

procedure TFrmWizardRenamingOptions.cbReplacePartChange(Sender: TObject);
    procedure SetReplaceOnlyVisible(v : boolean);
    var i : integer;
    begin
        for i := 0 to pnlReplaceOnly.ControlCount - 1 do begin
            pnlReplaceOnly.Controls[i].Visible := v;
        end;
    end;
begin
    txtReplacePhrase.Visible := false;
    SetReplaceOnlyVisible(false);


    case cbReplacePart.ItemIndex of
    0,1:
        begin
        end;
    2:
        begin
            txtReplacePhrase.Visible := true;
            SetReplaceOnlyVisible(true);
        end;

    end;

    self.UpdateReplaceExampleName;
end;

procedure TFrmWizardRenamingOptions.ForceAddToOnce;
begin
    ForceScreen := fsAddTo;
end;

procedure TFrmWizardRenamingOptions.ForceRemove;
begin
    ForceScreen := fsRemove;
end;

procedure TFrmWizardRenamingOptions.ForceReplaceOnce;
begin
    ForceScreen := fsReplace;
end;

procedure TFrmWizardRenamingOptions.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
    ForceScreen := fsNone;
end;

procedure TFrmWizardRenamingOptions.FormCreate(Sender: TObject);
var i : integer;
begin
    // always on top
     Windows.SetWindowPos(self.Handle, HWND_TOPMOST, 0, 0, 0, 0,
        (SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOOWNERZORDER or
                         SWP_NOZORDER Or SWP_FRAMECHANGED ) and not SWP_NOZORDER);


    for i := 0 to pcPanels.PageCount - 1 do begin
        pcPanels.Pages[i].TabVisible := false;
    end;

    for i := 0 to pcOptions.PageCount - 1 do begin
        pcOptions.Pages[i].TabVisible := false;
    end;


    wc := TWildCards.create;

   // memo1.ParentColor := true;
end;

procedure TFrmWizardRenamingOptions.FormShow(Sender: TObject);
var i,j : integer;
    sb : TSpeedButton;

    procedure SetForcedButtons;
    begin
        btnNext.Enabled := false;
        btnBack.Enabled := false;
        btnFinish.Enabled := true;
        btnFinish.Visible := true;
        btnCancel.Enabled := true;
    end;
begin
    pcPanels.ActivePageIndex := 0;
    self.CheckButtonStates;


    for I := 0 to frmmain.lvFileList.Items.count - 1 do begin
        if frmmain.lvfilelist.Items[i].Checked  then begin
            j := i;
            break;
        end;
    end;

    example := UnitColumnManager.GetName(j);
    txtExampleName.Text := example;

    tbPosition.Max := length(example)-1;

    {for i := 0 to pcPanels.PageCount  - 1 do begin
        for j := 0 to pcPanels.pages[i].ControlCount  - 1 do begin
            if pcpanels.Pages[i].Controls[j] is TSpeedButton then begin
               sb := TSpeedButton(pcpanels.Pages[i].Controls[j]);
               sb.Visible := true;
               sb.click;
               sb.Visible := false;
            end;
        end;
    end;}

    case ForceScreen of
        fsAddTo:
        begin
            btnNext.Click;
            rbadd.Checked := true;
            btnNext.Click;
            SetForcedButtons;
        end;
        fsReplace:
        begin
            btnNext.Click;
            rbReplace.checked := true;
            btnNext.Click;
            SetForcedButtons;
        end;
        fsRemove:
        begin
            btnNext.Click;
            rbRemove.checked := true;
            btnNext.Click;
            SetForcedButtons;
        end;
    end;
    //ForceScreen := fsNone;
end;


procedure TFrmWizardRenamingOptions.rbAddClick(Sender: TObject);
begin
    pcOptions.ActivePageIndex := 2;
end;

procedure TFrmWizardRenamingOptions.rbAddAfterClick(Sender: TObject);
begin

    self.UpdateAddExampleName;

end;

procedure TFrmWizardRenamingOptions.rbBeginnigClick(Sender: TObject);
begin
    self.UpdateAddExampleName;
end;

procedure TFrmWizardRenamingOptions.rbEndingClick(Sender: TObject);
begin
    self.UpdateAddExampleName;
end;

procedure TFrmWizardRenamingOptions.rbAddPositionClick(Sender: TObject);
begin
    self.UpdateAddExampleName;

end;

procedure TFrmWizardRenamingOptions.rbRemoveClick(Sender: TObject);
begin
    pcOptions.ActivePageIndex := 0;

end;

procedure TFrmWizardRenamingOptions.rbRemoveWordClick(Sender: TObject);
begin
    self.UpdateRemoveExampleName;
end;

procedure TFrmWizardRenamingOptions.ReplaceControlClick(Sender: TObject);
begin
    self.UpdateReplaceExampleName;
end;

procedure TFrmWizardRenamingOptions.rbReplaceClick(Sender: TObject);
begin
    pcOptions.ActivePageIndex := 1;

end;


procedure TFrmWizardRenamingOptions.TabSheet3Show(Sender: TObject);
begin
    case pcOptions.ActivePageIndex of
    0: self.UpdateRemoveExampleName;
    1: self.UpdateReplaceExampleName;
    2: self.UpdateAddExampleName;
    end;


    if rbAdd.checked then begin
        pcOptions.ActivePageIndex := 2;
    end else if rbReplace.checked then begin
        pcOptions.ActivePageIndex := 1;
    end else begin
        pcOptions.ActivePageIndex := 0;
    end;
end;

procedure TFrmWizardRenamingOptions.tbPositionChange(Sender: TObject);
begin
    txtAddPosition.text := IntToStr(tbPosition.Position);
    rbAddPosition.Checked := true;
    self.UpdateAddExampleName;
end;

procedure TFrmWizardRenamingOptions.tsRemoveShow(Sender: TObject);
begin
    self.UpdateRemoveExampleName ;
end;

procedure TFrmWizardRenamingOptions.tsReplaceShow(Sender: TObject);
begin
    self.UpdateReplaceExampleName; 
end;

procedure TFrmWizardRenamingOptions.txtAddChange(Sender: TObject);
begin
    self.UpdateAddExampleName;
end;

procedure TFrmWizardRenamingOptions.txtAfterChange(Sender: TObject);
begin
    self.UpdateAddExampleName;
end;

procedure TFrmWizardRenamingOptions.ReplaceControlChange(Sender: TObject);
begin
    self.UpdateReplaceExampleName;
end;

procedure TFrmWizardRenamingOptions.UpdateAddExampleName;
var s : string;
    procedure AddTextAt(text : string; at : integer);
    begin
        txtExampleName.Text := s;

        //txtExampleName.SetFocus;
        txtexamplename.SelStart := at-1;
        txtExampleName.SelText :=  text;
        txtExampleName.SelLength := length(text);

        txtexamplename.SelStart := at-1;
        txtExampleName.SelLength := length(text);
    end;

var start, ending, place : cardinal;

begin
    // These are Name only renaming option
    if rbAddCollision.checked then cbxAddPart.ItemIndex := 0;
    if rbAddAFter.Checked  then cbxAddPart.ItemIndex := 0;
    

    if cbxAddPart.ItemIndex =0 then begin
        s := ExtractFileName(example);
        s := leftstr(s,
            length(s) - length(ExtractFileExt(example))
        );
    end else begin
        s := ExtractFileExt(example);
        s := rightstr(s,length(s)-1);
    end;



    if rbBeginnig.checked then begin
        AddTextAt(txtAdd.text, 1);
    end else if rbEnding.checked or rbAddCollision.checked then begin
        AddTextAt(txtAdd.text, length(s)+1);
    end else if rbAddPosition.checked then begin
        AddTextAt(txtAdd.text, tbPosition.Position);
    end else if rbAddAfter.checked then begin
        txtExampleName.text := s;

        wc.SetSearchString(example);
        wc.SetSearchPattern(txtAfter.text);
        if txtAfter.text = '' then EXIT;


        if not wc.FindFirst(start,ending) then EXIT;

        if cbxAddPlace.ItemIndex = 1 then
            place := start - 1
        else
            place := ending;

        addtextat(txtAdd.Text, place+1);
    end;
end;


procedure TFrmWizardRenamingOptions.UpdateReplaceExampleName;
var start, ending, place : cardinal;
    s,s2 : string;

    i,j : integer;
begin
    if cbxAddPart.ItemIndex =0 then begin
        s := ExtractFileName(example);
        s := leftstr(s,
            length(s) - length(ExtractFileExt(example))
        );
    end else begin
        s := ExtractFileExt(example);
        s := rightstr(s,length(s)-1);
    end;

    if rbReplaceText.checked  then begin
        case cbReplacePart.ItemIndex  of
        0,1: txtExampleName.text := txtReplaceWith.text;
        2:
            begin
                txtExampleName.text := s;
                if txtReplacePhrase.text = '' then EXIT;

                wc.SetSearchString(s);
                wc.SetSearchPattern(txtReplacePhrase.text);


                if not wc.FindFirst(start,ending) then EXIT;

                if cbReplaceOnly.checked then begin
                    try
                        if (start < strtoint(txtrp2x.text)) or
                            (ending > strtoint(txtRP2y.Text)) then EXIT;
                    except
                        EXIT;
                    end;
                end;


                txtExampleName.SelStart := start-1;
                txtExampleName.SelLength := ending+1-start;
                txtExampleName.SelText := '';


                txtExampleName.SelStart := start-1;
                txtExampleName.SelText := txtReplaceWith.text;
                txtExampleName.SelLength := 0;
                
                txtExampleName.SelStart := start-1;
                txtExampleName.SelLength := length(txtReplaceWith.text);


            end;
        end;
    end else if rbReplaceChar.checked then begin
        txtExampleName.Text := s;
        for i := 0 to length(txtReplaceChar1.text) - 1 do begin
            s2 := '';
            if i < length(txtReplaceChar2.text) then
                s2 := txtReplaceChar2.Text[i+1];
            s := stringreplace(
                s,
                txtReplaceChar1.text[i+1],
                s2,
                [rfReplaceAll]
            );

            txtExampleName.Text := s;
        end;

    end;
end;


procedure TFrmWizardRenamingOptions.UpdateRemoveExampleName;
    var start, ending, place : cardinal;
    s,s2, name : string;

    i,j : integer;
begin

    if rbRemoveWord.checked  then begin
        if cbRemovePhrasePart.ItemIndex = 0 then begin
            s := ExtractFileName(example);
            s := leftstr(s,
                length(s) - length(ExtractFileExt(example))
            );
        end else begin
            s := ExtractFileExt(example);
            s := rightstr(s,length(s)-1);
        end;
        txtExampleName.Text := s;

        if cbRemovePhrase.ItemIndex = 0 then begin
            wc.SetSearchString(s);
            wc.SetSearchPattern(txtRemovePhrase.text);

            if length(txtRemovePhrase.text) = 0 then EXIT;
            if not wc.FindFirst(start,ending) then EXIT;


            txtExampleName.SelStart := start-1;
            txtExampleName.SelLength := ending+1-start;
            txtExampleName.SelText := '';
        end else begin
            name := s;
            s2 := txtRemovePhrase.text;
            s := TokenString(s2, ' ');
            while s <> '' do begin
                name := wc.SearchReplaceWith(
                    name,
                    s,
                    '',
                    true
                );

                s := TokenString(s2, ' ');
            end;
            txtExampleName.Text := name;
        end;

    end else if rbRemoveChars.checked  then begin
        if cbRemoveCharactersPart.ItemIndex = 0 then begin
            s := ExtractFileName(example);
            s := leftstr(s,
                length(s) - length(ExtractFileExt(example))
            );
        end else begin
            s := ExtractFileExt(example);
            s := rightstr(s,length(s)-1);
        end;

        txtExampleName.text := s;

        if cbRemoveCharPosition.ItemIndex = 0 then begin
            try
                txtExampleName.Text := rightstr(
                    txtExampleName.Text,
                    length(txtExampleName.text) - strtoint(txtR2X.text)
                );
            except
                EXIT
            end;
        end else begin
            try
                txtExampleName.Text := leftstr(
                    txtExampleName.Text,
                    length(txtExampleName.text) - strtoint(txtR2X.text)
                );
            except
                EXIT
            end;
        end;
    end else if rbRemoveChars2.checked then begin
        s := ExtractFileName(example);
        s := leftstr(s,
            length(s) - length(ExtractFileExt(example))
        );
        txtExampleName.Text := s;
                
        try
            if cbREmoveType.ItemIndex = 0 then begin
                s := copy(
                    s,
                    strtoint(txtr3x.text),
                    strtoint(txtr3y.Text)+1-strtoint(txtr3x.text)
                );
                txtExampleName.Text := s;

            end else begin
                s2 := copy(
                    s,
                    strtoint(txtr3x.text),
                    strtoint(txtr3y.Text)+1-strtoint(txtr3x.text)
                );

                delete(
                    s,
                    strtoint(txtr3x.text),
                    strtoint(txtr3y.Text)+1-strtoint(txtr3x.text)
                );


                if cbAndMove.checked then begin
                    txtExampleName.Text := s;
                    //txtExampleName.SetFocus;
                    txtexamplename.SelStart := strtoint(txtR3Z.text ) -1;
                    txtExampleName.SelText :=  s2;
                    txtExampleName.SelLength := length(s2);

                    txtexamplename.SelStart := strtoint(txtR3Z.text ) -1;
                    txtExampleName.SelLength := length(s2);
                end else begin
                    txtExampleName.Text := s;
                end;
            end;

        except

        end;
    end;

end;


end.
