unit UnitFrmWizardTextfile;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, ComCtrls, ExtCtrls, StdCtrls, Grids, UnitFrameTextfile;

type
  TFrmWizardTextfile = class(TForm)
    Panel1: TPanel;
    pcPanels: TPageControl;
    TabSheet1: TTabSheet;
    Panel2: TPanel;
    btnBack: TSpeedButton;
    btnNext: TSpeedButton;
    btnCancel: TSpeedButton;
    TabSheet2: TTabSheet;
    Label2: TLabel;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    Label5: TLabel;
    RichEdit3: TRichEdit;
    TabSheet5: TTabSheet;
    Label10: TLabel;
    RichEdit5: TRichEdit;
    Label8: TLabel;
    txtTName: TEdit;
    btnTBrowse: TSpeedButton;
    GroupBox1: TGroupBox;
    Label9: TLabel;
    Panel3: TPanel;
    txtTSkip: TEdit;
    udTSkip: TUpDown;
    txtTDelim: TEdit;
    cbTDelim: TCheckBox;
    Label3: TLabel;
    odTBrowse: TOpenDialog;
    Panel8: TPanel;
    Label4: TLabel;
    rbTMatch: TRadioButton;
    rbTFind: TRadioButton;
    pnlCustomData: TPanel;
    SpeedButton1: TSpeedButton;
    txtTFind: TEdit;
    btnUseTab: TButton;
    Label6: TLabel;
    Label7: TLabel;
    sgFirst: TStringGrid;
    Label12: TLabel;
    Label11: TLabel;
    sgFields: TStringGrid;
    Label13: TLabel;
    Label14: TLabel;
    sgMatch: TStringGrid;
    btnFinish: TButton;
    Label1: TLabel;
    cbxSearchWith: TComboBox;
    TabSheet6: TTabSheet;
    Label15: TLabel;
    Label16: TLabel;
    rbAddToFilename: TRadioButton;
    rbReplaceFilename: TRadioButton;
    cbxColumn: TComboBox;
    Label17: TLabel;
    RadioButton3: TRadioButton;
    Label18: TLabel;
    sgRename: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnBackClick(Sender: TObject);
    procedure btnNextClick(Sender: TObject);
    procedure btnTBrowseClick(Sender: TObject);
    procedure txtTSkipChange(Sender: TObject);
    procedure cbTDelimClick(Sender: TObject);
    procedure txtTDelimChange(Sender: TObject);
    procedure btnUseTabClick(Sender: TObject);
    procedure rbTMatchClick(Sender: TObject);
    procedure rbTFindClick(Sender: TObject);
    procedure txtTFindChange(Sender: TObject);
    procedure btnFinishClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure txtTFindClick(Sender: TObject);
    procedure cbxSearchWithChange(Sender: TObject);
    procedure cbxColumnChange(Sender: TObject);
    procedure rbAddToFilenameClick(Sender: TObject);
    procedure rbReplaceFilenameClick(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);

  private
    matchedlines : TStringList;
    { Private declarations }
    procedure GuessImportSetttings;
    procedure CheckButtonStates;
    procedure RefreshTextfilePreview(inSG : TStringGrid);
    procedure LoadMatchinPreview;
    procedure LoadRenamingPreview;
  public
    { Public declarations }
  end;

var
  FrmWizardTextfile: TFrmWizardTextfile;

implementation

uses {UnitFrmMain,} UnitFrmDummyShowPreview, UnitColumnManager, UnitWildcards,
  UnitTextFileFormat, Math, Menus, UnitUtil, UnitFrmMain, UnitMetaVariables,
  UnitFrmScriptActions, UnitFormScaling;

{$R *.dfm}

procedure TFrmWizardTextfile.RefreshTextfilePreview(inSG : TStringGrid);
var i, j, skip : integer;
    mi : TMenuItem;
begin
    //FrmMain.extfile1.Enabled := false;

     if FileExists(txtTName.text) then begin
        TextFileFormat.SkipedLines := SafeInt(txtTSkip.text);
        TextFileFormat.LoadFromFile(txtTName.text);
        TextFileFormat.Delim := ',';
        if txtTDelim.text <> '' then begin
            if lowercase(txtTDelim.Text) = 'tab' then begin
                TextFileFormat.Delim := #9;
            end else begin
                TextFileFormat.Delim := txtTDelim.text[1];
            end;
        end;

        inSG.ColCount := TextFileFormat.FieldCount;

        //FrmMain.extfile1.Clear;
        //FrmMain.extfile1.Enabled := false;


        if cbTDelim.Checked then begin
            if TextFileFormat.FieldCount = 0 then begin
                inSG.Cells[0, 0] := '?text1?';
                inSG.Cells[0, 1] := '';

            end;

            for i := 0 to TextFileFormat.FieldCount  - 1 do begin

                    inSG.Cells[i, 0] := '?text'+IntToStr(i+1)+'?';
            end;
            for i := 0 to TextFileFormat.FieldCount  - 1 do begin
                for j := 0 to inSG.RowCount - 1 do begin
                    inSG.Cells[i, j+1] := TextFileFormat.GetField(j, i);
                    //sgFields.ColWidths[i] := sgFields.Canvas.TextWidth(sgFields.Cells[i, j+1]) + 8;
                    //sgFields.ColWidths[i] := max(sgFields.ColWidths[i], sgFields.Canvas.TextWidth(sgFields.Cells[i, 0]) + 8);
                end;
            end;


        end else begin
           

            inSG.ColCount := 1;
            inSG.cells[0,0] := '?text1?';
            for j := 1 to 2 do begin
                inSG.cells[0,j] := TextFileFormat.Strings[j-1];
                inSG.ColWidths[0] := inSG.Canvas.TextWidth(inSG.Cells[0, 1]) + 8;
                inSG.ColWidths[0] := max(inSG.ColWidths[0], inSG.Canvas.TextWidth(inSG.Cells[0, 0]) + 8);
            end;
        end;
    end;


end;

procedure TFrmWizardTextfile.SpeedButton1Click(Sender: TObject);
begin
    FrmMain.InsertButtonClick(sender); 
end;

procedure TFrmWizardTextfile.txtTDelimChange(Sender: TObject);
begin
    self.RefreshTextfilePreview(self.sgFields);
end;

procedure TFrmWizardTextfile.txtTFindChange(Sender: TObject);
begin
    self.LoadMatchinPreview;
end;

procedure TFrmWizardTextfile.txtTFindClick(Sender: TObject);
begin
    FrmScriptActions.TextClick(sender);
end;

procedure TFrmWizardTextfile.txtTSkipChange(Sender: TObject);
begin
    self.RefreshTextfilePreview(self.sgFields);
end;

procedure TFrmWizardTextfile.GuessImportSetttings;
var sl : TStringList;
    s1, s2 : string;
    tabcount, commacount, commacount2, commacount3 : integer;
    wc : TRegExpWildcards;
    idx1, idx2 : cardinal;
    tff : TTextFileFormat;
    i,j : integer;
    FilenamesFoundInOrder : boolean;

    function CharCount(s : string; c : char) : integer;
    var i : integer;
    begin
        result := 0;
        for i := 1 to length(s) do begin
            if s[i] = c then inc(result);
        end;
    end;

    procedure UseCSVcomma;
    begin
        rbTFind.checked := true;
        self.txtTDelim.text := ',';
        self.cbTDelim.Checked := true;
    end;
    procedure UseCSVtab;
    begin
        rbTFind.checked := true;
        self.txtTDelim.text := 'TAB';
        self.cbTDelim.Checked := true;
    end;
begin
    if not FileExists(txtTName.text) then EXIT;

    sl := TStringList.Create;
    wc := TRegExpWildcards.Create;
    sl.LoadFromFile(txtTname.text);
    tff := TTextFileFormat.create;
    if sl.Count > 2 then begin
        s1 := sl.Strings[1];
        s2 := sl.Strings[2];



        self.cbTDelim.Checked := false;
        self.txtTDelim.text := ',';
        rbTMatch.checked := true;


        // 1 or more double quote surrounded items with commas between
        wc.SetSearchString(s1);
        wc.SetSearchPattern('"[^"]*"(,"[^"]*")*');
        if wc.FindFirst(idx1,idx2) then begin
            wc.SetSearchString(s2);
            if wc.FindFirst(idx1,idx2) then begin
                UseCSVcomma;
            end;
        end;

        // 1 or more double quote surrounded items with tabs between
        wc.SetSearchString(s1);
        wc.SetSearchPattern('"[^"]*"(\t"[^"]*")*');
        if wc.FindFirst(idx1,idx2) then begin
            wc.SetSearchString(s2);
            if wc.FindFirst(idx1,idx2) then begin
                UseCSVtab;
            end;
        end;

        // 2 or more items with tabs between
        wc.SetSearchString(s1);
        wc.SetSearchPattern('[^\t]*(\t[^t]*)+');
        if wc.FindFirst(idx1,idx2) then begin
            wc.SetSearchString(s2);
            if wc.FindFirst(idx1,idx2) then begin
                UseCSVtab;
            end;
        end;

        // 2 or more items with commas between
        wc.SetSearchString(s1);
        wc.SetSearchPattern('[^,]*(,[^,]*)+');
        if wc.FindFirst(idx1,idx2) then begin
            wc.SetSearchString(s2);
            if wc.FindFirst(idx1,idx2) then begin
                UseCSVcomma;
            end;
        end;


        // search for each file matched by line
        // or just found anywhere
        tff.LoadFromFile(txtTname.text);

        // look for the first file index and ensure it's actually not a folder
        j := FrmMain.FirstFileIndex;
        if not FrmDummyShowPreview.isfolder(FrmMain.lvFileList.Items[j]) then begin
            for i := j+0 to j+min(10, FrmMain.lvFileList.Items.count - 1) do begin
                if not (FrmMain.lvFilelist.Items[i].Checked) then continue;

                s1 := UnitColumnManager.GetName(i);
                FilenamesFoundInOrder := tff.FindLine(s1) = i;
                if not FilenamesFoundInOrder then BREAK;
            end;

            if FilenamesFoundInOrder then begin
                rbTFind.Checked := true;
                txtTFind.Text := '?cfn?';
                EXIT;
            end;

            for i := j+0 to j+min(10, FrmMain.lvFileList.Items.count - 1) do begin
                FilenamesFoundInOrder := tff.FindLine(s1) <> -1;
                if not FilenamesFoundInOrder then break;
            end;
            if FilenamesFoundInOrder then begin
                rbTFind.Checked := true;
                txtTFind.Text := '?cfn?';
                EXIT;
            end;
        end;

        rbTMatch.Checked := true;
    end;

    tff.free;
    sl.free;
    wc.free;
end;


procedure TFrmWizardTextfile.LoadMatchinPreview;
var i, j, cnt, fields, line : integer;
    rec : RenameRecord;
    searchterm : string;
begin
    // load X files from current filelist
    //
    if FrmMain.lvFileList.Items.count = 0 then EXIT;
    if pcpanels.ActivePageIndex <> 3 then EXIT;

    i := FrmMain.FirstFileIndex;
    if (i=-1) then i := 0;

    cnt := min(5, FrmMain.lvFileList.Items.count);
    for j := i to (i + cnt) - 1 do begin
        sgMatch.Cells[0, (j-i)+1] := UnitColumnManager.GetName(j);
    end;

    if rbTMatch.Checked then begin
        for j := i to (i + cnt) - 1 do begin
            sgMatch.Cells[1, (j-i)+1] := IntToStr((j-1)+2);
            sgMatch.cells[2, (j-i)+1] :=
            '"'+StringReplace(TextFileFormat.Strings[(j-i)], TextFileFormat.Delim, ' ', [rfReplaceAll])+ '"' ;
        end;
    end else if rbTFind.Checked then begin
       for j := i to (i+cnt) - 1 do begin
            rec := FrmMain.GetPartialRecord(j);
            case frmmain.FrameTextfield1.cbxSearchWith.ItemIndex  of
            0: searchterm := VAR_CUR_FILENAME;
            1: searchterm := VAR_CUR_FILENAME_NOEXT;
            2: searchterm := txtTFind.text;
            end;

            line := TextFileFormat.FindLine(
                    UnitMetaVariables.ReplaceMetaVariables(searchterm,rec)
                );

            if line = -1 then begin
                sgMatch.Cells[1, (j-i+1)] := '--';
                sgMatch.cells[2, (j-i+1)] := '';
            end else begin
                sgMatch.Cells[1, (j-i+1)] := IntToStr(line+1);
                sgMatch.Cells[2, (j-i+1)] := '"'+
                StringReplace(
                    TextFileFormat.Strings[line],
                    TextFileFormat.Delim, ' ', [rfReplaceAll]
                )+ '"';
            end;
        end;
    end;

end;

procedure TFrmWizardTextfile.LoadRenamingPreview;
var i, j : Integer;
    s : string;
begin

    for i:= 1 to sgMatch.RowCount-1 do begin
        s := TextFileFormat.GetField(StrToInt(sgMatch.Cells[1,i])-1, cbxColumn.ItemIndex);

        sgRename.Cells[0,i] := sgMatch.Cells[0,i]; // copy filename for each

        sgRename.Cells[1,i] := '';
        if rbAddToFilename.Checked then begin


            sgRename.Cells[1,i] := s + sgRename.Cells[0,i];
        end else if rbReplaceFilename.Checked then begin
            sgRename.Cells[1,i] := s;
        end;
    end;
end;

procedure TFrmWizardTextfile.RadioButton3Click(Sender: TObject);
begin
self.LoadRenamingPreview;
end;

procedure TFrmWizardTextfile.rbAddToFilenameClick(Sender: TObject);
begin
self.LoadRenamingPreview;
end;

procedure TFrmWizardTextfile.rbReplaceFilenameClick(Sender: TObject);
begin
self.LoadRenamingPreview;
end;

procedure TFrmWizardTextfile.rbTFindClick(Sender: TObject);
begin
    self.LoadMatchinPreview;
end;

procedure TFrmWizardTextfile.rbTMatchClick(Sender: TObject);
begin
    self.LoadMatchinPreview;
end;

procedure TFrmWizardTextfile.btnBackClick(Sender: TObject);
begin
    pcPanels.ActivePageIndex :=     pcPanels.ActivePageIndex - 1;
    self.CheckButtonStates;     
end;

procedure TFrmWizardTextfile.btnCancelClick(Sender: TObject);
begin
    self.Close; 
end;

procedure TFrmWizardTextfile.btnFinishClick(Sender: TObject);
var s : string;
begin
    frmmain.FrameTextfield1.txtTName.text := self.txtTName.text;
    frmmain.FrameTextfield1.txtTDelim.text := self.txtTDelim.text;
    frmmain.FrameTextfield1.txtTSkip.text  := self.txtTSkip.text;
    frmmain.FrameTextfield1.txtTFind.text := self.txtTFind.text;
    frmmain.FrameTextfield1.rbTMatch.Checked := self.rbTMatch.Checked;
    frmmain.FrameTextfield1.rbTFind.Checked := self.rbTFind.Checked;

    s := '?text'+IntToStr(cbxColumn.ItemIndex+1)+'?';
    if rbAddToFilename.Checked then begin
        FrmMain.pcTemplate.ActivePageIndex := 3;
        FrmMain.btnClearOptions.click;
        FrmScriptActions.NewScriptControl(FrmMain.FlowPanel1, stAddBeginningEnding);
        FrmScriptActions.AlterStep(stAddBeginningEnding, 'txtAdd', s);
    end else if rbReplaceFilename.Checked then begin
        FrmMain.pcTemplate.ActivePageIndex := 3;
        FrmMain.btnClearOptions.click;
        FrmScriptActions.NewScriptControl(FrmMain.FlowPanel1, stReplaceNameExtension );
        FrmScriptActions.AlterStep(stReplaceNameExtension, 'txtReplaceWith', s);
        FrmScriptActions.AlterStep(stReplaceNameExtension, 'cbxReplacePart', '0');
    end;

    btnCancel.click;

    if assigned(frmMain.FrameTextfield1.txtTName.OnChange) then begin
        frmMain.FrameTextfield1.txtTName.OnChange(frmMain.FrameTextfield1.txtTName);
    end;
end;

procedure TFrmWizardTextfile.btnNextClick(Sender: TObject);
var i : integer;
begin
    pcPanels.ActivePageIndex :=  pcPanels.ActivePageIndex + 1;


    case pcPanels.ActivePageIndex  of
    1: begin
        btnNext.Enabled := false;
        // button will be enabled when a valid file is loaded
    end;
    2: begin
        self.RefreshTextfilePreview(self.sgFields);
    end;
    3: begin

        sgMatch.Cells[0,0] := 'Filname';
        sgMatch.Cells[1,0] := 'Line Number';
        sgMatch.Cells[2,0] := 'Line';

        self.LoadMatchinPreview;
    end;
    4: begin
        sgRename.Cells[0,0] := 'Filename';
        sgRename.Cells[1,0] := 'New Name';
        cbxColumn.Items.Clear;
        for i := 0 to sgFields.ColCount-1 do begin
            cbxColumn.Items.Add(sgFields.Cells[i,0]); // headers for each column
        end;
        cbxColumn.ItemIndex := 0;


        Self.LoadRenamingPreview;
    end;
    end;

    self.CheckButtonStates;
end;

procedure TFrmWizardTextfile.btnTBrowseClick(Sender: TObject);
begin
    if odTBrowse.InitialDir = '' then
        odTBrowse.InitialDir := ExtractFilePath(Application.ExeName);

    if odTBrowse.Execute then begin
        txtTName.Text := odTBrowse.FileName;
        txtTName.SelStart := length(txtTName.text);
        self.GuessImportSetttings;
        self.RefreshTextfilePreview(sgFirst);
        Application.ProcessMessages;
    end;
    btnNext.Enabled :=  fileexists(self.txtTName.text);

end;

procedure TFrmWizardTextfile.btnUseTabClick(Sender: TObject);
begin
    txtTDelim.Text := 'TAB';
end;

procedure TFrmWizardTextfile.cbTDelimClick(Sender: TObject);
begin
self.RefreshTextfilePreview(self.sgFields);
end;

procedure TFrmWizardTextfile.cbxColumnChange(Sender: TObject);
begin
    self.LoadRenamingPreview;
end;

procedure TFrmWizardTextfile.cbxSearchWithChange(Sender: TObject);
begin
     pnlCustomData.Visible := cbxSearchWith.ItemIndex = 2;
     self.LoadMatchinPreview;
end;

procedure TFrmWizardTextfile.CheckButtonStates;
begin
    btnBack.Enabled := true;
    btnNext.Enabled := true;
    btnFinish.Enabled := false;

    if pcPanels.ActivePageIndex = 0 then begin
        btnBack.Enabled := false;
    end;
    if pcpanels.ActivePageIndex = pcpanels.PageCount - 1 then begin
        btnNext.Enabled := false;
        btnFinish.Enabled := true;
    end;
end;

procedure TFrmWizardTextfile.FormCreate(Sender: TObject);
var i : integer;
begin
    // always on top
     Windows.SetWindowPos(self.Handle, HWND_TOPMOST, 0, 0, 0, 0,
        (SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOOWNERZORDER or
                         SWP_NOZORDER Or SWP_FRAMECHANGED ) and not SWP_NOZORDER);


    for i := 0 to pcPanels.PageCount - 1 do begin
        pcPanels.Pages[i].TabVisible := false;
    end;


    TFormScaling.RegisterSelf(self);
   // memo1.ParentColor := true;
end;

procedure TFrmWizardTextfile.FormShow(Sender: TObject);
var i,j : integer;
    sb : TSpeedButton;
begin
    pcPanels.ActivePageIndex := 0;
    self.CheckButtonStates;

end;

end.
