unit UnitScriptSteps;

interface

uses Controls, Forms, Classes, StdCtrls, ExtCtrls, Windows, Graphics, ComCtrls, Buttons, Contnrs
    ;




{$TYPEINFO ON}
//{$METHODINFO ON}
{$M+}
type TScriptType = (
    stAddBeginningEnding,
    stAddPosition,
    stAddBeforeAfter,
    stReplaceNameExtension,
    stReplaceCharacters,
    stReplaceNumbers,
    stRemoveWords,
    stRemoveBeginningEnding,
    stRemoveSubstring,
    stRemoveBeforeAfter,

    // new step types below
    stAddCounter,
    stRemoveExpression,
    stConditionalExecute,
    stRemoveWordNumber,
    stSplitAndMove
);
{since the scripttype is saved into a file, any new steps must be placed at
the end}

type TScriptSuperType = (
    sstAdd, sstReplace, sstRemove, sstOther
);

type TScriptStep = class(TComponent)
    private
        FScriptType : TScriptType;
        fenabled : Boolean;
    public
        constructor Create;
    published

    property ScriptType : TScriptType  read FScriptType write FScriptType;
    property Enabled : Boolean read fenabled write fenabled;
end;

type TScriptStepAdd = class(TScriptStep)
    private
    flblAdd, flblToThe : TLabel;
    ftxtAdd, ftxtAddPosition, ftxtAfter : TEdit;
    fcbxAddPart : TComboBox;

    published
    property lblAdd : TLabel read flblAdd write flblAdd;
    property lblToThe : TLabel read flblToThe write flblToThe;
    property txtAdd : TEdit read ftxtAdd write ftxtAdd;
    property txtAddPosition : TEdit read ftxtAddPosition write ftxtAddPosition;
    property txtAfter : TEdit read ftxtAfter write ftxtAfter;
    property cbxAddPart : TComboBox read fcbxAddPart write fcbxAddPart;

end;
type TScriptStepAddCounter = class(TScriptStep)
{NOTE: This add doesn't use the same leading parts and doesn't need to inherit from TSCriptAdd like the other parts}
    private
        flblAddCounter, flblZeros, flblAOfTheName : TLabel;
        ftxtAZeros : TEdit;
        fAUDZeros : TUpDown;
        fpnlAZero : TPanel;
        fcbxBeginningEnding : TComboBox;
    published
        property lblAddCounter : TLabel read flblAddCounter write flblAddCounter;
        property lblZeros : TLabel read flblZeros write flblZeros;
        property lblAOfTheName : TLabel read flblAOfTheName write flblAOfTheName;
        property txtAZeros : TEdit read ftxtAZeros write ftxtAZeros;
        property AUDZeros : TUpDown read fAUDZeros write fAUDZeros;
        property pnlAZero : TPanel read fpnlAZero write fpnlAZero;
        property cbxBeginningEnding : TComboBox read fcbxBeginningEnding write fcbxBeginningEnding;
end;
type TScriptStepAddBeginningEnding = Class(TScriptStepAdd)
    private
    flblAtThe : TLabel;
    fcbxAddAtThe : TComboBox;
    fcbOnCollision : TCheckbox;

    published
    property lblAtThe : TLabel read flblAtThe write flblAtThe;
    property cbxAddAtThe : TComboBox read fcbxAddAtThe write fcbxAddAtThe;
    property cbOnCollision : TCheckBox read fcbOnCollision write fcbOnCollision;

end;
type TScriptStepAddPosition = Class(TScriptStepAdd)
    private
    flblAtCharacterPosition : TLabel;
    ftxtAddPosition : TEdit;
    ftbPosition : TTrackBar;
    flblAddFromThe : TLabel;
    fcbxFromTheBeginningEnding : TComboBox;
    published
    property lblAtCharacterPosition : TLabel read flblAtCharacterPosition write flblAtCharacterPosition;
    property txtAddPosition : TEdit read ftxtAddPosition write ftxtAddPosition;
    property tbPosition : TTrackBar read ftbPosition write ftbPosition;
    property lblAddFromThe : TLabel read flblAddFromThe write flblAddFromThe;
    property cbxFromTheBeginningEnding : TComboBox read fcbxFromTheBeginningEnding write fcbxFromTheBeginningEnding;
end;
type TScriptStepAddBeforeAfter = Class(TScriptStepAdd)
    private
    flblPlaceIt : TLabel;
    ftxtAfter : TEdit;
    fcbxAddPlace : TComboBox;
    published
    property lblPlaceIt : TLabel read flblPlaceIt write flblPlaceIt;
    property txtAfter : TEdit read ftxtAfter write ftxtAfter;
    property cbxAddPlace : TComboBox read fcbxAddPlace write fcbxAddPlace;

end;


type TScriptStepReplace = class(TScriptStep)
end;

type TScriptStepReplaceNameExtension = class(TScriptStepReplace)
    private
    flblReplaceThe, flblWith, flblThru, flblRMInThe : TLabel;
    fcbxReplacePart, fcbxReplaceTarget : TComboBox;
    ftxtReplacePhrase, ftxtReplaceWith,
    ftxtRP2X, ftxtRP2Y : TEdit;
    fudRP2X, fudRP2Y : TUpDown;
    fpnlReplaceOnly : TPanel;
    fcbReplaceOnly : TCheckbox;
    published
    property lblReplaceThe : TLabel read flblReplaceThe write flblReplaceThe;
    property lblWith : TLabel read flblWith write flblWith;
    property lblThru : TLabel read flblThru write flblThru;
    property cbxReplacePart : TComboBox read fcbxReplacePart write fcbxReplacePart;
    property txtReplacePhrase : TEdit read ftxtReplacePhrase write ftxtReplacePhrase;
    property txtReplaceWith : TEdit read ftxtReplaceWith write ftxtReplaceWith;
    property txtRP2X : TEdit read ftxtRP2X write ftxtRP2X;
    property txtRP2Y : TEdit read ftxtRP2Y write ftxtRP2Y;
    property udRP2X : TUpDown read fudRP2X write fudRP2X;
    property udRP2Y : TUpDown read fudRP2Y write fudRP2Y;
    property pnlReplaceOnly : TPanel read fpnlReplaceOnly write fpnlReplaceOnly;
    property cbReplaceOnly : TCheckBox read fcbReplaceOnly write fcbReplaceOnly;
    property lblRMInThe : TLabel read flblRmInThe write flblRmInThe;
    property cbxReplaceTarget : TComboBox read fcbxReplaceTarget write fcbxReplaceTarget;
end;
type TScriptStepReplaceCharacters = class(TScriptStepReplace)
    private
    flblReplaceEach,
    flblWithChar  : TLabel;
    ftxtReplaceChar1, ftxtReplaceChar2 : TEdit;
    flblInThe : TLabel;
    fcbxReplaceCharPart : TComboBox;
    published
    property lblReplaceEach : TLabel read flblReplaceEach write flblReplaceEach;
    property lblWithChar : TLabel read flblWithChar write flblWithChar;
    property txtReplaceChar1 : TEdit read ftxtReplaceChar1 write ftxtReplaceChar1;
    property txtReplaceChar2 : TEdit read ftxtReplaceChar2 write ftxtReplaceChar2;
    property lblInThe : TLabel read flblInThe write flblInThe;
    property cbxReplaceCharPart : TComboBox read fcbxReplaceCharPart write fcbxReplaceCharPart;
end;
type TScriptStepReplaceNumbers = class(TScriptStepReplace)
    private
    flblReplaceNumbers : TLabel;
    fcbxNumbers : TComboBox;
    flblOfTheName : TLabel;
    published
    property lblReplaceNumbers : TLabel read flblReplaceNumbers write flblReplaceNumbers;
    property cbxNumbers : TComboBox read fcbxNumbers write fcbxNumbers;
    property lblOfTheName : TLabel read flblOfTheName write flblOfTheName;

end;

type TScriptStepOther = class(TScriptStep)
end;
type TScriptStepConditionExecute = class(TScriptStepOther)
    private
    fcbxCESkipRemove : TComboBox;
    flblCESKipTheNExt : TLabel;
    ftxtCE1 : TEdit;
    fudCE1 : TUpDown;
    fpnlCE1 : TPanel;
    flblCESteps : TLabel;
    flblCEIf : TLabel;
    published
    property cbxCESkipRemove: TCombobox read fcbxCESkipRemove write fcbxCESkipRemove ;
    property lblCESkipTheNext : TLabel read flblCESkipTheNext write flblCESkipTheNext;
    property txtCE1 : TEdit read ftxtCE1 write ftxtCE1;
    property udCE1 : TUpDown read fudCE1 write fudCE1;
    property pnlCE1 : TPanel read fpnlCE1 write fpnlCE1;
    property lblCESteps : TLabel read flblCESteps write flblCESteps;
    property lblCEIf : TLabel read flblCEIf write flblCEIf;
end;

type TScriptStepRemove = class(TScriptStep)
end;

type TScriptStepRemoveExpression = class(TScriptStepRemove)
    private
        flblreRemoveTheExpression : TLabel;
        fcbreAtThe : TCheckBox;
        fcbxreBegginingEnding : TComboBox;
        flblreOfTheName : TLabel;
        fcbreThatSTartsWIth : TCheckBox;
        fcbxrePhraseCharacters : TComboBox;
        ftxtrePhraseCharacters : TEdit;

        fcbxreHasInTheMiddle : TCheckBox;
        fcbxrePhraseCharacters2 : TComboBox;
        ftxtrePhraseCharacters2 : TEdit;

        fcbreAndEndsWith : TCheckBox;
        fcbxrePhraseCharacters3 : TComboBox;
        ftxtrePhraseCharacters3 : TEdit;
        fcbreAndStore : TCheckBox;

        fcbreRemoveNumber : TCheckBox;
        fpnlRE1 : TPanel;
        ftxtRE1 : TEdit;
        fudRE1 : TUpDown;
    published
        property lblreRemoveTheExpression : TLabel read flblreRemoveTheExpression write flblreRemoveTheExpression;
        property cbreAtThe : TCheckBox read fcbreAtThe write fcbreAtThe;
        property cbxreBegginingEnding : TComboBox read fcbxreBegginingEnding write fcbxreBegginingEnding;
        property lblreOfTheName : TLabel read flblreOfTheName write flblreOfTheName;
        property cbreThatSTartsWIth : TCheckBox read fcbreThatSTartsWIth write fcbreThatSTartsWIth;
        property cbxrePhraseCharacters : TComboBox read fcbxrePhraseCharacters write fcbxrePhraseCharacters;
        property txtrePhraseCharacters : Tedit read ftxtrePhraseCharacters write ftxtrePhraseCharacters;

        property cbreHasInTheMiddle : TCheckBox read fcbxreHasInTheMiddle write fcbxreHasInTheMiddle;
        property cbxrePhraseCharacters2 : TComboBox read fcbxrePhraseCharacters2 write fcbxrePhraseCharacters2;
        property txtrePhraseCharacters2 : Tedit read ftxtrePhraseCharacters2 write ftxtrePhraseCharacters2;

        property cbreAndEndsWith : TCheckBox read fcbreAndEndsWith write fcbreAndEndsWith;
        property cbxrePhraseCharacters3 : TComboBox read fcbxrePhraseCharacters3 write fcbxrePhraseCharacters3;
        property txtrePhraseCharacters3 : Tedit read ftxtrePhraseCharacters3 write ftxtrePhraseCharacters3;

        property cbreAndStore : TCheckBox read fcbreAndStore write fcbreAndStore;

        property cbreRemoveNumber : TCheckBox read fcbreRemoveNumber write fcbreRemoveNumber;
        property pnlRE1 : TPanel read fpnlRE1 write fpnlRE1;
        property txtRE1 : TEdit read ftxtRE1 write ftxtRE1;
        property udRE1 : TUpDown read fudRE1 write fudRE1;
end;
type TScriptStepRemoveWords = class(TScriptStepRemove)
    private
    flblRemoveWords : TLabel;
    fpnlRW1 : TPanel;
    ftxtRW1 : TEdit;
    fudWR1 : TupDown;
    fcbxRemovePhrase : TComboBox;
    ftxtRemovePhrase : TEdit;
    flblFromThe : TLabel;
    fcbxRemovePhrasePart : TComboBox;
    published
    property lblRemoveWords : TLabel read flblRemoveWords write flblRemoveWords;
    property pnlRW1 : TPanel read fpnlRW1 write fpnlRW1;
    property txtRW1 : TEdit read ftxtRW1 write ftxtRW1;
    property upWR1 : TUpDown read fudWR1 write fudWR1;
    property cbxRemovePhrase : TComboBox read fcbxRemovePhrase write fcbxRemovePhrase;
    property txtRemovePhrase : TEdit read ftxtRemovePhrase write ftxtRemovePhrase;
    property lblFromThe : TLabel read flblFromThe write flblFromThe;
    property cbxRemovePhrasePart : TComboBox read fcbxRemovePhrasePart write fcbxRemovePhrasePart;

end;
type TScriptStepRemoveCharacters = class(TScriptStepRemove)
    private
    flblRemoveChars : TLabel;
    ftxtR2X: TEdit;
    fpnlR2X: TPanel;
    fudR2X: TUpDown;
    flblCharsFromThe : TLabel;
    fcbxRemoveCharPosition : TComboBox;
    flblOfThe : TLabel;
    fcbxRemoveCharactersPart : TComboBox;
    fcbAndSTore : TCheckbox;
    published
    property lblRemoveChars : TLabel read flblRemoveChars write flblRemoveChars;
    property txtR2X : TEdit read ftxtR2X write ftxtR2X;
    property pnlR2X : TPanel read fpnlR2X write fpnlR2X;
    property udR2X : TUpDown read fudR2X write fudR2X;
    property lblCharsFromThe : TLabel read flblCharsFromThe write flblCharsFromThe;
    property cbxRemoveCharPosition : TComboBox read fcbxRemoveCharPosition write fcbxRemoveCharPosition;
    property lblOfThe : TLabel read flblOfThe write flblOfThe;
    property cbxRemoveCharactersPart : TComboBox read fcbxRemoveCharactersPart write fcbxRemoveCharactersPart;
    property cbAndStore : TCheckbox read fcbandstore write fcbandstore;

end;
type TScriptStepRemoveSubstring = class(TScriptStepRemove)
    private
    flblRemoveSubstring : TLabel;
    fcbxRemoveType : TComboBox;
    flblChars, flblCharThru : TLabel;
     ftxtR3X, ftxtR3Y, ftxtR3Z : TEdit;
     fpnlR3X, fpnlR3Y, fpnlR3Z : TPanel;
     fudR3X, fudR3Y, fudR3Z : TUpDown;

    fcbAndMove : TCheckBox;
    fcbAndStoreRM : TCheckBox;
    published
    property lblRemoveSubstring : TLabel read flblRemoveSubstring write flblRemoveSubstring;
    property cbxRemoveType : TComboBox read fcbxRemoveType write fcbxRemoveType;
    property lblChars : TLabel read flblChars write flblChars;
    property lblCharThru : TLabel read flblCharThru write flblCharThru;
    property txtR3X : TEdit read ftxtR3X write ftxtR3X;
    property txtR3Y : TEdit read ftxtR3Y write ftxtR3Y;
    property txtR3Z : TEdit read ftxtR3Z write ftxtR3Z;
    property pnlR3X : TPanel read fpnlR3X write fpnlR3X;
    property pnlR3Y : TPanel read fpnlR3Y write fpnlR3Y;
    property pnlR3Z : TPanel read fpnlR3Z write fpnlR3Z;
    property udR3X : TUpDown read fudR3X write fudR3X;
    property udR3Y : TUpDown read fudR3Y write fudR3Y;
    property udR3Z : TUpDown read fudR3Z write fudR3Z;
    property cbAndMove : TCheckBox read fcbAndMove write fcbAndMove;
    property cbAndStoreRM : TCheckBox read fcbAndStoreRM write fcbAndStoreRM;

end;
type TScriptStepRemoveBeforeAfter = class(TScriptStepRemove)
    private
        flblRemoveEverything : TLabel;
        fcbxBeforeAfter : TComboBox;
        flblThePhrase : TLabel;
        ftxtRemove2Phrase : TEdit;
        fcbAndStoreRM2 : TCheckBox;
    published
        property lblRemoveEverything : TLabel read flblRemoveEverything write flblRemoveEverything;
        property cbxBeforeAfter : TComboBox read fcbxBeforeAfter write fcbxBeforeAfter;
        property lblThePhrase : TLabel read flblThePhrase write flblThePhrase;
        property txtRemove2Phrase : TEdit read ftxtRemove2Phrase write ftxtRemove2Phrase;
        property cbAndStoreRM2 : TCheckBox read fcbAndStoreRM2 write fcbAndStoreRM2;
end;
type TScriptStepRemoveWordNumber = class(TScriptStepRemove)
    private
      flblrwRemoveWordNumber : TLabel;
      ftxtRW1 : TEdit;
      fudRW1 : TupDown;
      fpnlRW1 : TPanel;
      flblrwAWordContains : TLabel;
      fcbxrwCharactersType : TComboBox;
      ftxtrwCharacters : TEdit;
      fcbrwStoreTemp : TCheckBox;
    published
        property lblrwRemoveWordNumber : TLabel read flblrwRemoveWordNumber write flblrwRemoveWordNumber;
        property txtRW1 : TEdit read ftxtRW1 write ftxtRW1;
        property udRW1 : TupDown read fudRW1 write fudRW1;
        property pnlRW1 : TPanel read fpnlRW1 write fpnlRW1;
        property lblrwAWordContains : TLabel read flblrwAWordContains write flblrwAWordContains;
        property cbxrwCharactersType : TComboBox read fcbxrwCharactersType write fcbxrwCharactersType;
        property txtrwCharacters : TEdit read ftxtrwCharacters write ftxtrwCharacters;
        property cbrwStoreTemp : TCheckBox read fcbrwStoreTemp write fcbrwStoreTemp;
end;


type TScriptStepSplitAndMove = class(TScriptStepOther)
    private
        flblSplitTheName : TLabel;
        ftxtFilemask : TEdit;
        fbtnAutoSplit : TButton;
        flblMoveTheParts : TLabel;
        ftxtMove : TEdit;
    published
        property lblSplitTheName : TLabel read flblSplitTheName write flblSplitTheName;
        property txtFilemask : TEdit read ftxtFilemask write ftxtFilemask;
        property lblMoveTheParts : TLabel read flblMoveTheParts write flblMoveTheParts;
        property txtMove : TEdit read ftxtMove write ftxtMove;
        property btnAutoSplit : TButton read fbtnAutoSplit write fbtnAutoSplit;
end;



Type TMyToplinePanel = Class(TPanel)
        procedure Paint(); override;
        procedure Resize(); override;
    private
    public
        RoundBottom : boolean;
         procedure Invalidate; override;
End;
Type TMyPanelBottom = Class(TPanel)
    public

        procedure Paint; override;
        procedure Invalidate; override;
End;

type TTransPanel = Class(TPanel)
    public
        procedure Invalidate; override;
       // procedure Changed;
    protected
        procedure CreateParams(var Params: TCreateParams); override;
        procedure Paint; override;
        procedure Resize; override;
end;
Type TTransFlowPanel = Class(TFlowPanel)
    public
        procedure Invalidate; override;
    protected
        procedure CreateParams(var Params: TCreateParams); override;
        procedure Paint; override;
End;

type
    TScriptStepControl = class(TObject)
        private
            fDeleted : boolean;
            function GetTag : integer;
        public
            pnlTop : TMyToplinePanel;
            outerpnl, pnlLeft, pnlRight : TTransPanel;
            pnlBtm : TMyPanelBottom;


        pnlMid : TTransFlowPanel;
        sb1,sbtoggle, sbup, sbdown, sbdelete, sbenable : TSpeedButton;
        imgReplace : Timage;
        ScriptStep : TScriptStep;

        property Deleted : boolean read fDeleted write fDeleted;
        property Tag : integer read GetTag;
    end;



implementation

uses UnitUtil, UnitFrmMain, UnitFrmScriptActions, UnitFrmDummyPreview, UnitFrmConfig;

{ TScriptStep }

constructor TScriptStep.Create;
begin
    FrmDummyAutoPreview.InformOfKeypress;
    fenabled := true;
end;



{ MyPanel }

procedure TMyToplinePanel.Invalidate;
begin
    //if not SmoothAni then
        inherited;
end;

procedure TMyToplinePanel.Paint;
var
    rHead : TRect;
    ssc : TScriptStepControl;
begin
    self.ParentColor := false;
    if self.RoundBottom  then begin
        self.color := DimColor(clBtnFace, 0.95);
    end else begin
        self.color := SetBlueColor(clBtnFace, 1.14);
    end;


    self.Canvas.Brush.Color := frmmain.scrlScriptbox.Color;
    self.Canvas.FillRect(
        rect(
        self.ClientRect.Left,
        self.ClientRect.top,
        self.ClientRect.Right,
        self.ClientRect.Bottom
        )
    );

    // outter gray rounded corners
    if self.RoundBottom  then begin
        self.Canvas.Pen.Color := clGray;
    end else begin
         self.Canvas.Pen.Color := DimColor(clGray, 0.80);
    end;
    self.Canvas.Brush.Color := DimColor(self.color,   0.97);
    self.Canvas.RoundRect(
        self.ClientRect.Left,
        self.ClientRect.Top,
        self.ClientRect.Right,
        self.ClientRect.Bottom,
        11,7
    );
    // side lines

    if self.RoundBottom  then begin
        self.Canvas.Rectangle(
            self.ClientRect.Left,
            self.ClientRect.top + trunc(self.clientrect.Bottom * 0.5),
            self.ClientRect.Right,
            self.ClientRect.Bottom-7
        );
    end else begin
        self.Canvas.Rectangle(
            self.ClientRect.Left,
            self.ClientRect.top + trunc(self.clientrect.Bottom * 0.5),
            self.ClientRect.Right,
            self.ClientRect.Bottom
        );
    end;

    if RoundBottom then begin
        // rounded part of bottom with outline
        self.Canvas.Pen.Color := DimColor(clGray, 0.97);
        self.Canvas.Brush.Color := DimColor(self.color,   0.93);


        self.Canvas.RoundRect(
            self.ClientRect.Left,
            self.ClientRect.bottom - 14,
            self.ClientRect.Right,
            self.ClientRect.Bottom,
            11,7
        );

        // bottom darker color
        rhead.Left := self.ClientRect.left+1;
        rhead.right := self.ClientRect.Right-1;
        rhead.Top := self.ClientRect.top + trunc(self.clientrect.Bottom * 0.5);
        rhead.Bottom := self.ClientRect.Bottom - 7;

        self.canvas.Brush.color := DimColor(self.Color,   0.93);
        self.Canvas.FillRect(rhead);

        //
        // right button shadowbox
        ssc := FrmScriptActions.GetScriptControl(self.tag);

        self.Canvas.Pen.Color := DimColor(self.color, 0.93);
        self.canvas.Brush.color := DimColor(self.Color,   0.93);
        if ((not assigned(ssc.sbenable)) or (ssc.sbenable.Visible = false)) then
            if frmconfig.cbShowUpDown.checked then begin
                self.canvas.RoundRect(
                    ssc.pnlTop.Width-(((20+3)*4)+8)  -4,
                    ssc.sbtoggle.Top-2,
                    ssc.pnltop.Width - 4,
                    ssc.pnlTop.Top + ssc.sbtoggle.Height+3,
                    11,7
                );
            end else begin
                self.canvas.RoundRect(
                    ssc.pnlTop.Width-(((20+3)*2)+8)  -4,
                    ssc.sbtoggle.Top-2,
                    ssc.pnltop.Width - 4,
                    ssc.pnlTop.Top + ssc.sbtoggle.Height+3,
                    11,7
                );
            end;
    end else begin
        // bottom darker color
        rhead.Left := self.ClientRect.left+1;
        rhead.right := self.ClientRect.Right-1;
        rhead.Top := self.ClientRect.top + trunc(self.clientrect.Bottom * 0.5);
        rhead.Bottom := self.ClientRect.Bottom;

        self.Canvas.FillRect(rhead);
    end;
end;

procedure TMyToplinePanel.Resize;
begin
    canvas.Brush.Style := bsClear;
    inherited;
end;

{ TyPanelBottom }

procedure TMyPanelBottom.Invalidate;
begin
    //if not SmoothAni then
    //self.DoubleBuffered := true;
    canvas.Brush.Style := bsClear;
    inherited;
end;

procedure TMyPanelBottom.Paint;
begin
    //if SmoothAni then EXIT;
    inherited;

    self.Canvas.Brush.Color := frmmain.scrlScriptbox.Color;
    self.Canvas.FillRect(
        rect(
        self.ClientRect.Left,
        self.ClientRect.top,
        self.ClientRect.Right,
        self.ClientRect.Bottom
        )
    );

    // darker rounded bottom with outline
    self.Canvas.Pen.Color := DimColor(clGray, 0.80);

    self.Canvas.Brush.Color := DimColor(SetBlueColor(clBtnFace, 1.14),   0.95);
    self.Canvas.RoundRect(
        self.ClientRect.Left,
        self.ClientRect.bottom - 14,
        self.ClientRect.Right,
        self.ClientRect.Bottom,
        11,7
    );

    //left/right lines
    self.Canvas.Rectangle(
        rect(
        self.ClientRect.Left,
        self.ClientRect.top,
        self.ClientRect.Right,
        self.ClientRect.Bottom - 8
        )
    );

    // white fill
    self.Canvas.Brush.Color := clWhite;
    self.Canvas.FillRect(
        rect(
        self.ClientRect.Left+1,
        self.ClientRect.top,
        self.ClientRect.Right-1,
        self.ClientRect.Bottom - 7
        )
    );

end;



//
// Workarounds to get transparent panels 
//
procedure TTransFlowPanel.CreateParams(var Params: TCreateParams);
begin
     inherited CreateParams(Params);
     params.ExStyle := Params.ExStyle + WS_EX_Transparent;
     ControlStyle := ControlStyle - [csOpaque] + [csAcceptsControls];

     //self.DoubleBuffered := true;
end;
procedure TTransFlowPanel.Invalidate;
begin
    //if not SmoothAni then
    canvas.Brush.Style := bsClear;
    inherited;
end;
procedure TTransFlowPanel.Paint;
var i : integer;
begin
    //if not SmoothAni then
    canvas.Brush.Style := bsClear;
    inherited;
end;
{ TTransPanel }

procedure TTransPanel.CreateParams(var Params: TCreateParams);
begin
    inherited CreateParams(Params);
    params.ExStyle := Params.ExStyle + WS_EX_Transparent;
    ControlStyle := ControlStyle - [csOpaque] + [csAcceptsControls];
    canvas.Brush.Style := bsClear;

    //self.DoubleBuffered := true;
end;
procedure TTransPanel.Invalidate;
begin
    //if not SmoothAni then
        canvas.Brush.Style := bsClear;
    inherited;

end;
procedure TTransPanel.Paint;
var i : integer;
begin
    //if not SmoothAni then
        canvas.Brush.Style := bsClear;
    inherited;
end;
procedure TTransPanel.Resize;
begin
    canvas.Brush.Style := bsClear;
    //inherited;
end;

{ TScriptStepControl }

function TScriptStepControl.GetTag: integer;
begin
    result := self.pnlTop.Tag;
end;


end.
